# GenoML-core
GenoML is an Automated Machine Learning (AutoML) for Genomic. This is the core package of GenoML. 
this repo is under development, please report any issues (bug, performance, documentation) on the [GenoML issues page](https://github.com/GenoML/genoml/issues). 

Here are some quick "get started" exmaples, please checkout the additional options and details in the [Usage][] and [CLI][].
In general, use linux or mac with python > 3.5 for best results.

## Install 
Run:
~~~~
pip install genoml
~~~~

## Train the ML model 
You can use the IPDGC (International Parkinson's Disease Genomics Consortium) test data. This data is a simulation of the genetic and clinical data used for Parkinson's diagnosis in previous publications. You can find it at [IPDGC example data][].

Download and unzip data:
~~~
wget https://github.com/ipdgc/GenoML-Brief-Intro/raw/master/exampleData.zip
unzip exampleData.zip 
~~~

To train, run:
~~~~
genoml-train --geno-prefix=./exampleData/training --pheno-file=./exampleData/training.pheno --model-dir=./exampleModel
~~~~

Final tuned model and performance metrics are stored in the ```--model-dir``` directory. 

## Using the trained ML model for inference
~~~~
genoml-inference --model-dir=./exampleModel --valid-dir=./exampleData --valid-geno-prefix=./exampleData/validation --valid-pheno-file=./exampleData/validation.pheno
~~~~

Valdiation results and model performance metrics are stored in the ```--valid-dir``` directory. 

> For debugging purposes, include the ```-v``` or ```-vvv``` flags at the end of a command.

[usage]: https://genoml.github.io/docs/usage
[CLI]: https://genoml.github.io/docs/cli
[IPDGC example data]: https://github.com/ipdgc/GenoML-Brief-Intro/raw/master/exampleData.zip

     
## Report issues 
Please report any issue or suggestions on the [GenoML issues page](https://github.com/GenoML/genoml/issues).

## run with ... 
## Rscript $pathToGenoML/otherPackages/prepSblupToScale.R $prefix $gwas $geno

## testing 
prefix <- "20190124-125238"
gwas <- "example_GWAS.txt"
geno <- "20190124-125238"

## Parse args and start logging
args <- commandArgs()
print(args)
prefix <- args[6]
gwas <- args[7]
geno <- args[8]

## load library
library("data.table")

## load SBLUP snps
snpList <- fread(paste(prefix,".reduced_genos_snpList", sep = ""), header = F)
names(snpList) <- c("SNP")
## load GWAS results
gwasResults <- fread(file = gwas, header = T)

## load map file
snpFile <- fread(paste(prefix,".forSblup.bim", sep = ""), header = F)
names(snpFile) <- c("CHR","SNP","CM","BP","minorAllele","majorAllele")

## merge files
temp <- merge(snpList, gwasResults, by = "SNP")
data <- merge(temp, snpFile, by = "SNP")

## reduce data and export list for scaling
dat <- data[,c("SNP","CHR","BP","p")]
names(dat) <- c("SNP","CHR","BP","P")
fwrite(dat, file = paste(prefix, ".temp.snpsToPull2", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)

## close down shop and don't save nuthin
q("no")

## Parse args and start logging
args <- commandArgs()
print(args)
prefix <- args[6]
sink(file = paste(prefix, "_discreteTraining.Rout", sep = ""))
ncores <- as.numeric(args[7])
trainSpeed <- args[8]
cvReps <- as.numeric(args[9])
gridSearch <- as.numeric(args[10])
imputeMissingData <- args[11]

## Check command arguments from user
print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
print(paste("TRAINING SPEED is ", trainSpeed, sep = ""))
print(paste("RUNNNING CROSS VALIDATION FOR ", cvReps, " REPS", sep = ""))
print(paste("GRID SEARCH FOR ", gridSearch, " ITERATIONS", sep = ""))
print(paste("ANOTHER LEVEL OF IMPUTATION AND DATA TRANSFORMATION USING ", imputeMissingData, sep = ""))

## Load additional packages
packageList <- c("caret","ggplot2","data.table","rBayesianOptimization","plotROC")
lapply(packageList, library, character.only = TRUE)

## Load dataset
train <- fread(paste(prefix,".dataForML", sep = ""), header = T)

### set outcome as a factor, check missingness, then impute missing data and scale
train$PHENO[train$PHENO == 2] <- "DISEASE"
train$PHENO[train$PHENO == 1] <- "CONTROL"
sum(is.na(train))
ID <- train$ID
train[,c("ID") := NULL]
preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
train_processed <- predict(preProcValues, train) # here we make the preprocessed values

## a bit more data munging that doesn't matter most of the time, we'll be ignoring this for now due to prefiltering but worth including in your considerations
nzv <- nearZeroVar(train_processed[,-1], saveMetrics= TRUE) # checks for near non zero and flags
fwrite(nzv, paste(prefix,".nzv", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the near and nonzero predictors
if(length(names(train)) < 1001) # if more than 1000 variables this step is skipped for memeory and speed reasons
{
descrCor <- cor(train_processed[,-1]) # builds correlation matrix
highlyCorDescr <- findCorrelation(descrCor, cutoff = .75, names = T, verbose = T) # checks correlated features and summarizes, can write function in later to drop
write.table(highlyCorDescr, paste(prefix,".highCor", sep = ""), quote = F, sep = "\t", row.names = F, col.names = F) # this exports globally correlated predictors
}
## the two files above might want to be used to exclude some data prior to re-analysis
#comboInfo <- findLinearCombos(train_processed) # finds biased linear combinations
#fwrite(comboInfo, paste(prefix,".comboInfo", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the possible linear combinations in the dataset that may be problematic and should be examined

### to begin tune first begin parallel parameters 
library("parallel")
library("doParallel")
cluster <- makeCluster(ncores) # convention to leave 1 core for OS
registerDoParallel(cluster)
set.seed(123) # makes generally reproducible grid searches from random or bayes tunes at paramter optimization

## here we set the cross validation
fitControl <- trainControl(method = "cv",
	number = cvReps,
	classProbs = TRUE,
	summaryFunction = twoClassSummary,
	search = "random")

## now we start making models if the trainSpeed is ALL
if(trainSpeed == "ALL")
{

	glm.model <- train(PHENO ~ ., data = train_processed,
		method = "glm",
		trControl = fitControl,
		tuneLength = gridSearch,
		metric = "ROC")

	bayesglm.model <- train(PHENO ~ ., data = train_processed,
		method = "bayesglm",
		trControl = fitControl,
		tuneLength = gridSearch,
		metric = "ROC")

	xgbTree.model <- train(PHENO ~ ., data = train_processed, 
		method = "xgbTree", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	xgbDART.model <- train(PHENO ~ ., data = train_processed, 
		method = "xgbDART", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	rf.model <- train(PHENO ~ ., data = train_processed, 
		method = "rf", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	nb.model <- train(PHENO ~ ., data = train_processed, 
		method = "nb", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	nnet.model <- train(PHENO ~ ., data = train_processed, 
		method = "nnet", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	dnn.model <- train(PHENO ~ ., data = train_processed, 
		method = "dnn", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	C5.0.model <- train(PHENO ~ ., data = train_processed, 
		method = "C5.0", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	glmnet.model <- train(PHENO ~ ., data = train_processed, 
		method = "glmnet", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	svmRadial.model <- train(PHENO ~ ., data = train_processed, 
		method = "svmRadial", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	lda.model <- train(PHENO ~ ., data = train_processed, 
		method = "lda", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	modelsRan <- list(glm=glm.model, bayesglm=bayesglm.model, xgbTree=xgbTree.model, xgbDART=xgbDART.model, rf=rf.model, nb=nb.model, nnet=nnet.model, dnn=dnn.model, C5.0=C5.0.model, glmnet=glmnet.model, svmRadial=svmRadial.model, lda=lda.model)
}

## now we start making models if the trainSpeed is FAST
if(trainSpeed == "FAST")
{

	glm.model <- train(PHENO ~ ., data = train_processed,
		method = "glm",
		trControl = fitControl,
		tuneLength = gridSearch,
		metric = "ROC")

	xgbTree.model <- train(PHENO ~ ., data = train_processed, 
		method = "xgbTree", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	xgbDART.model <- train(PHENO ~ ., data = train_processed, 
		method = "xgbDART", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	nb.model <- train(PHENO ~ ., data = train_processed, 
		method = "nb", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	nnet.model <- train(PHENO ~ ., data = train_processed, 
		method = "nnet", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	dnn.model <- train(PHENO ~ ., data = train_processed, 
		method = "dnn", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	glmnet.model <- train(PHENO ~ ., data = train_processed, 
		method = "glmnet", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	lda.model <- train(PHENO ~ ., data = train_processed, 
		method = "lda", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	modelsRan <- list(glm=glm.model, xgbTree=xgbTree.model, xgbDART=xgbDART.model, nb=nb.model, nnet=nnet.model, dnn=dnn.model, glmnet=glmnet.model, lda=lda.model)
}

## now we start making models if the trainSpeed is FURIOUS
if(trainSpeed == "FURIOUS")
{

	glm.model <- train(PHENO ~ ., data = train_processed,
		method = "glm",
		trControl = fitControl,
		tuneLength = gridSearch,
		metric = "ROC")

	nb.model <- train(PHENO ~ ., data = train_processed, 
		method = "nb", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	nnet.model <- train(PHENO ~ ., data = train_processed, 
		method = "nnet", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	dnn.model <- train(PHENO ~ ., data = train_processed, 
		method = "dnn", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	glmnet.model <- train(PHENO ~ ., data = train_processed, 
		method = "glmnet", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	lda.model <- train(PHENO ~ ., data = train_processed, 
		method = "lda", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	modelsRan <- list(glm=glm.model, nb=nb.model, nnet=nnet.model, dnn=dnn.model, glmnet=glmnet.model, lda=lda.model)
}

## now we start making models if the trainSpeed is BOOSTED
if(trainSpeed == "BOOSTED")
{

	xgbTree.model <- train(PHENO ~ ., data = train_processed, 
		method = "xgbTree", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	xgbDART.model <- train(PHENO ~ ., data = train_processed, 
		method = "xgbDART", 
		trControl = fitControl, 
		tuneLength = gridSearch,
		metric = "ROC")

	modelsRan <- list(xgbTree=xgbTree.model, xgbDART=xgbDART.model)
}

### shut down multicore
stopCluster(cluster)
registerDoSEQ()

### now compare best models
sink(file = paste(prefix,"_methodPerformance.tab",sep =""), type = c("output"))
methodComparisons <- resamples(modelsRan)
summary(methodComparisons)
sink()
sink(file = paste(prefix,"_methodTimings.tab",sep =""), type = c("output"))
methodComparisons$timings
sink()

## pick best model from model compare then output plots in this case, its picked via ROC, maximizing the mean AUC across resamplings
ROCs <- as.matrix(methodComparisons, metric = methodComparisons$metric[1])
meanROCs <- as.data.frame(colMeans(ROCs, na.rm = T))
meanROCs$method <- rownames(meanROCs)
names(meanROCs)[1] <- "meanROC" 
bestFromROC <- subset(meanROCs, meanROC == max(meanROCs$meanROC))
bestAlgorithm <- paste(bestFromROC[1,2])
write.table(bestAlgorithm, file = paste(prefix,"_bestModel.algorithm",sep = ""), quote = F, row.names = F, col.names = F) # exports "method" option for the best algorithm
bestModel <- get(paste(bestAlgorithm, ".model", sep = ""))
save(bestModel, file = paste(prefix,"_bestModel.RData",sep = ""))
varImpList <- varImp(bestModel, scale = F) # here we get the importance matrix for the best model unscaled
varImpTable <- as.matrix(varImpList$importance)
write.table(varImpTable, file = paste(prefix,"_varImp.tab",sep =""), quote = F, sep = "\t", col.names = F)
train_processed$predicted <- predict(bestModel, train_processed)
train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
trained$ID <- ID
write.table(trained, file = paste(prefix,"_trainingSetPredictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
ggsave(plot = overlayedRocs, filename = paste(prefix,"_plotRoc.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
ggsave(plot = densPlot, filename = paste(prefix,"_plotDensity.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
ggsave(plot = overlayedRocs, filename = paste(prefix,"_plotRocNoCI.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
confMat <- confusionMatrix(data = as.factor(trained$predicted), reference = as.factor(trained$PHENO), positive = "DISEASE")
sink(file = paste(prefix,"_confMat.txt",sep =""), type = c("output"))
confMat
sink()
sink()

### sweep the floor, turn everything off and shut the door behind you
q("no")

## run with ... 
## Rscript $pathToGenoML/otherPackages/checkPrs.R $prefix $pheno

library("data.table")
library("caret")
library("pROC")

args <- commandArgs()
print(args)
prefix <- args[6]
pheno <- args[7]
## testing
# prefix <- "g-adni.harmonized-p-adni.amyloid_disc-c-adni.PCs-a-adni.age_sex_e2_e4"
# pheno <- "adni.amyloid_disc"

predictedInput <- paste(prefix, "_validation_predictions.tab", sep = "")
predictedFile <- fread(predictedInput)
predictedFile$PHENO <- NULL
phenoInput <- paste(pheno, "", sep = "")#paste(pheno, ".pheno", sep = "")
phenoFile <- fread(phenoInput)
phenoFile$ID <- paste(phenoFile$FID, phenoFile$IID, sep = "_")
data <- merge(phenoFile, predictedFile, by = "ID")
minPheno <- min(data$PHENO)
maxPheno <- max(data$PHENO)
if(minPheno == 1 & maxPheno == 2)
{
  data$bin <- data$PHENO - 1
  outPut <- matrix(nrow = 3, ncol = 3)
  rocAuc <- roc(response = data$bin, predictor =  data$probDisease)
  outPut[1,1] <- auc(rocAuc)
  outPut[1,2] <- ci(rocAuc, of="auc")[1]
  outPut[1,3] <- ci(rocAuc, of="auc")[3]
  coords(rocAuc, "best")
  thresh <- coords(rocAuc, "best")[1]
  data$bin50 <- as.numeric(ifelse(data$probDisease > 0.5, 1, 0))
  rocAuc <- roc(response = data$bin, predictor = data$bin50)
  outPut[2,1] <- auc(rocAuc)
  outPut[2,2] <- ci(rocAuc, of="auc")[1]
  outPut[2,3] <- ci(rocAuc, of="auc")[3]
  data$binBest <- as.numeric(ifelse(data$probDisease > thresh, 1, 0))
  rocAuc <- roc(response = data$bin, predictor = data$binBest)
  outPut[3,1] <- auc(rocAuc)
  outPut[3,2] <- ci(rocAuc, of="auc")[1]
  outPut[3,3] <- ci(rocAuc, of="auc")[3]
  row.names(outPut) <- c("probability","partition_at_50percent","partition_at_best")
  write.table(outPut, file = paste(prefix, ".validation_summary.txt", sep = ""), quote = F, sep = "\t", col.names = c("AUC","low_95_CI","high_95_CI"))
 ## confmat at best threshold
  confMat <- confusionMatrix(data = as.factor(data$binBest), reference = as.factor(data$bin), positive = "1")
	sink(file = paste(prefix,"_confMatAtBestThresh_validation.txt",sep =""))
	print(confMat)
	sink()
}
if(minPheno != 1 & maxPheno != 2)
{
  model <- lm(PHENO ~ predicted, data = data)
  sink(file = paste(prefix, ".validation_summary.txt", sep = ""))
  print(summary(model))
  sink()
}
q("no")

#' Title
#'
#' @param geno
#' @param covs
#' @param predictor
#' @param pheno
#'
#' @return
#' @export
#'
#' @examples
getHandlerToGenotypeData = function(geno,covs,predictor,id,fid,pheno){
  
  stopifnot(file.exists(paste0(geno,".bed")))
  stopifnot(file.exists(paste0(geno,".bim")))
  stopifnot(file.exists(paste0(geno,".fam")))
  stopifnot(file.exists(paste0(covs,".cov")))
  cdata = read.table(paste0(covs,".cov"),header = TRUE,stringsAsFactors=F)
  #cat("Covariates are",paste0(colnames(cdata),collapse=", "),"\n")
  phenofile = paste0(pheno, ".pheno")
  if(!file.exists(phenofile))
    stopifnot(predictor %in% colnames(cdata))
  stopifnot(id %in% colnames(cdata))
  stopifnot(fid %in% colnames(cdata))
  
  #Generating the phenotype file
  if(file.exists(phenofile)){
    phenoDat = read.table(phenofile,header = TRUE,stringsAsFactors=F)
  }else{
    phenoDat = cdata[,c(fid,id,predictor)]
    write.table(phenoDat,phenofile,
                sep = " ", row.names = FALSE, quote = FALSE)
    
  }
  
  #Removing the phenotype from the covariates
  cdata = cdata[,colnames(cdata) != predictor]
  
  genoHandler = NULL
  genoHandler$geno = geno
  genoHandler$pheno = pheno
  genoHandler$covs = covs
  genoHandler$id = id
  genoHandler$fid = fid
  genoHandler$covsDat =  cdata
  genoHandler$phenoDat = phenoDat
  genoHandler$Class = predictor
  attr(genoHandler,"class") = "genohandler"
  return(genoHandler)
}

#' Title
#'
#' @param handler 
#' @param type 
#' @param index 
#'
#' @return
#' @export
#'
#' @examples
getHandlerFromFold = function(handler,type="train",index=1){
  key = paste0(type,"FoldFiles")
  if(type == "test"){
    stopifnot(!is.null(handler$testFolds))
    stopifnot(length(handler$testFolds) >= index)
  }
  if(type == "train"){
    stopifnot(!is.null(handler$trainFolds))
    stopifnot(length(handler$testFolds) >= index)
  }
  stopifnot(!is.null(handler[[key]]))
  files = handler[[key]][[index]]  
  handler = getHandlerToGenotypeData(geno=files$genoFile,
                                     covs=gsub(".cov","",files$covsFile),
                                     predictor=handler$Class,
                                     id=handler$id,
                                     fid=handler$fid,
                                     pheno=gsub(".pheno","",files$phenoFile))
  return(handler)
}

#' Title
#'
#' @param h 
#' @param level 
#'
#' @return
#' @export
#'
#' @examples
verifyHandler = function(h,level=1){
  if(level >= 1){
    stopifnot(file.exists(paste0(h$geno,".bed")))
    stopifnot(file.exists(paste0(h$geno,".bim")))
    stopifnot(file.exists(paste0(h$geno,".fam")))
    stopifnot(file.exists(paste0(h$covs,".cov")))
    cdata = read.table(paste0(h$covs,".cov"),header = TRUE)
    stopifnot(h$id %in% colnames(cdata))
    stopifnot(file.exists(paste0(h$pheno,".pheno")))
  }
  if(level >= 2){
    stopifnot(!is.null(h$trainFolds))
    stopifnot(!is.null(h$testFolds))
  }
}

cleanHandler = function(h,level=1){
  file.remove(paste0(h$geno,".bed"))
  file.remove(paste0(h$geno,".bim"))
  file.remove(paste0(h$geno,".fam"))
  file.remove(paste0(h$covs,".cov"))
  file.remove(paste0(h$pheno,".pheno"))
  if(!is.null(h$nfolds)){
    for(i in 1:h$nfolds){
      cleanHandler(getHandlerFromFold(handler=h,type="train",index=i))
      cleanHandler(getHandlerFromFold(handler=h,type="test",index=i))
    }
  }
}

#' Title
#'
#' @param handler 
#'
#' @return
#' @export
#'
#' @examples
print.genohandler = function(handler){
  cat("A verified GenoML handler with the following features\n")
  cat("Genotype files (bed/bim/fam) prefix",handler$geno,"\n")
  cat("Covariates file",paste0(handler$covs,".cov"),"\n")
  cat("Class attribute in the covariates",handler$Class,"\n")
  cat(nrow(handler$covsDat),"examples and columns",paste0(colnames(handler$covsDat),collapse=", "),"\n")
  cat("Predictor values count\n")
  print(table(handler$phenoDat[,handler$Class]))
  if(!is.null(handler$trainFolds)){
    if(handler$plan == "k-fold cv"){
      cat("K-fold evaluation with k =",
          length(handler$trainFolds),
          "and test split proportion",
          signif(length(handler$testFolds[[1]])/length(handler$trainFolds[[1]]),2),"\n")
    }else
      cat("Hold out cross-validation with test split proportion",
          signif(length(handler$testFolds[[1]])/length(handler$trainFolds[[1]]),2),"\n")
    
    if(is.null(handler$trainFoldFiles) & is.null(handler$testFoldFiles))
      cat("No data was generated from the data partitions created\n")
    else{
      if(!is.null(handler$trainFoldFiles)){
        cat(length(handler$trainFoldFiles),"sets of files were created for training. See below for the 1st one\n")
        print(handler$trainFoldFiles[[1]])
      }
      if(!is.null(handler$testFoldFiles)){
        cat(length(handler$testFoldFiles),"sets of files were created for test. See below for the 1st one\n")
        print(handler$testFoldFiles[[1]])
      }
    }
  }
  
  
}



#' Title
#'
#' @param genoHandler A handler obtained by calling to `getHandlerToGenotypeData()`
#' @param how We can get a sample with "holdout" and "k-fold cv"
#' @param k The number of folds when we use cross-validation
#' @param p The proportion of data that does to training
#'
#' @return The same handler, with two new fields, `trainFolds` and `testFolds` with the indexes
#' @export
#'
#' @examples
getSamplesFromHandler = function(genoHandler,how="k-fold cv",k=10,p=0.75){
  
  stopifnot(how == "k-fold cv" | how == "holdout")
  genoHandler$plan = how
  
  library(caret)
  pred <- genoHandler$Class #accessing the column given by the user
  
  if(how == "holdout"){
    hoFold = createDataPartition(y=genoHandler$phenoDat[[h$Class]],p=p)
    genoHandler$folds = hoFold
    genoHandler$nfolds = 1
    genoHandler$trainFolds = NULL
    genoHandler$testFolds = NULL
    genoHandler$trainFolds$train1 = hoFold$Resample1
    genoHandler$testFolds$test1 = (1:length(genoHandler$phenoDat[[h$Class]]))[-hoFold$Resample1]
  }else{
    
    folds <- createFolds(y=genoHandler$covsDat[[pred]], k=k, list = TRUE, returnTrain = FALSE)
    genoHandler$folds = folds
    genoHandler$nfolds = length(folds)
    
    trainFolds <- list() #list with the indexes used for train in each one of the k cross-validations
    testFolds <- list()  #list with the indexes saved for test in each one of the k cross-validations
    for (i in 1:genoHandler$nfolds){
      trainFolds[[paste0("train",i)]] = NULL
      trainFolds[[paste0("train",i)]] = (1:length(genoHandler$phenoDat[[h$Class]]))[-folds[[names(folds[i])]]]
      testFolds[[paste0("test",i)]] = NULL
      testFolds[[paste0("test",i)]] = folds[[names(folds[i])]]
    }
    genoHandler$trainFolds = trainFolds
    genoHandler$testFolds = testFolds
  }
  return(genoHandler)
}



#' Title Creating your genotipe data
#'
#' @param genoHandler 
#' @param workPath 
#' @param path2plink 
#' @param onlyFold 
#' @param which.to.create 
#'
#' @return
#' @export
#'
#' @examples
genData = function(genoHandler,
                   workPath = "~/genoml-core-master",
                   path2plink="~/genoml-core-master/otherPackages/",
                   onlyFold=-1,
                   onlyFiles=F,
                   which.to.create=c("train","test")){
  verifyHandler(genoHandler)
  stopifnot(dir.exists(workPath))
  if(path2plink != "")
    stopifnot(dir.exists(path2plink))
  
  if(onlyFold > 0)
    indexes = onlyFold
  else
    indexes = 1:genoHandler$nfolds
  for(tt in which.to.create){
    key = paste0(tt,"FoldFiles")
    genoHandler[[key]] = NULL
    
  }
  
  for (i in indexes){
    foldFiles = NULL
    #generation of a new directory for each iteration
    for(tt in which.to.create){
      key = paste0(tt,"FoldFiles")
      dir.create(file.path(workPath, paste0("Fold",tt,i)), showWarnings = FALSE)
      dirFold = paste0(workPath,"/", paste0("Fold",tt,i))
      
      splitIdx <- paste0(tt,i)
      covsFoldDT <- genoHandler$covsDat[genoHandler[[paste0(tt,"Folds")]][[splitIdx]],] #dataframe with the covariates of the individuals given by this fold
      
      covsFold <- paste0("COVS_",tt,i)
      covsFile = file = paste0(dirFold, "/" ,covsFold,".cov")
      write.table(covsFoldDT, covsFile, sep = " ", row.names = FALSE, quote = FALSE) #file with the covs
      foldFiles$covsFile = covsFile
      
      genoFold = paste0(basename(genoHandler$geno),tt,".",i)
      phenoFold = paste0(basename(genoHandler$pheno),i)
      
      #generation of the geno file using plink
      idsfile = paste0(dirFold, "/",basename(genoHandler$covs),tt,".ids")
      write.table(genoHandler$covsDat[genoHandler[[paste0(tt,"Folds")]][[splitIdx]],c(genoHandler$fid,genoHandler$id)],idsfile,
                  col.names=F,sep = " ", row.names = FALSE, quote = FALSE)
      foldFiles$idsFile = idsfile
      
      #Generating the phenotype files
      phenoFoldDT <- genoHandler$phenoDat[genoHandler[[paste0(tt,"Folds")]][[splitIdx]],] #dataframe with the covariates of the individuals given by this fold
      phenofile = paste0(dirFold, "/", phenoFold,tt, ".pheno")
      write.table(phenoFoldDT,phenofile,
                  sep = " ", row.names = FALSE, quote = FALSE)
      foldFiles$phenoFile = phenofile
      
      #Generating the genotype files
      genofile = paste0(dirFold, "/", genoFold)
      command = paste0(path2plink,"plink --bfile ", genoHandler$geno, " --keep ", idsfile, " --make-bed --out ", genofile)
      r = mySystem(command)
      foldFiles$genoFile = genofile
      genoHandler[[key]][[1]] = foldFiles
    }
  }
  return(genoHandler)
}


#' Title
#'
#' @param genoHandler
#' @param how
#' @param workPath
#' @param path2plink
#'
#' @return
#' @export
#'
#' @examples
mostRelevantSNPs = function(handler,
                            how="PRSICE",
                            phenoScale="DISC",
                            SNPcolumnatGWAS="SNP",
                            clumpField="p",
                            path2plink,...){
  
  verifyHandler(handler)
  if(path2plink != "")
    stopifnot(dir.exists(path2plink))
  
  #call to the function that reproduces step1 of the pipeline and gets a dataForML por each one of the nfolds iterations
  trainCluster_initData(handler=handler,
                        reduce = how,
                        path2plink=path2plink,
                        path2gcta64=path2plink,
                        phenoScale=phenoScale,
                        SNPcolumnatGWAS=SNPcolumnatGWAS,
                        clumpField=clumpField,...)
  
}

trainCluster_initData = function(handler,
                                 addit="NA",
                                 reduce="PRSICE",
                                 gwas="RISK_noSpain.tab",
                                 SNPcolumnatGWAS="SNP",
                                 clumpField="p",
                                 herit=NA,
                                 path2plink,
                                 path2gcta64,
                                 cores=1,
                                 phenoScale="DISC",
                                 path2PRSice=path2plink,
                                 PRSiceexe="PRSice_linux",
                                 path2GWAS,...){
  
  geno = basename(handler$geno)
  pheno = basename(handler$pheno)
  workPath=paste0(dirname(handler$geno),"/")
  path2Genotype=paste0(dirname(handler$geno),"/")
  cov = basename(handler$covs)
  
  ### options passed from list on draftCommandOptions.txt
  prefix=paste0("g-",geno,"-p-",pheno,"-c-",cov,"-a-",addit)
  fprefix = paste0(workPath,"/",prefix)  ##CAMBIAR
  
  if(reduce == "PRUNE" || reduce == "DEFAULT"){
    command = paste0(path2plink,"plink --bfile ",path2Genotype,"/",geno," --indep-pairwise 10000 1 0.1 --out ",fprefix,".temp")
    mySystem(command)
    command = paste0(path2plink,"plink --bfile ",path2Genotype,"/",geno," --extract ",fprefix,".temp.prune.in --recode A --out ",
                     fprefix,".reduced_genos")
    #cat("The command",command,"\n")
    mySystem(command)
    command = paste0("cut -f 1 ",fprefix,".temp.prune.in > ",fprefix,".reduced_genos_snpList")
    mySystem(command)
    
  }else if(reduce == "SBLUP" & !is.na(gwas) & !is.na(herit)){
    ### if $reduce = SBLUP, $gwas is not NA and $herit is not NA
    command = paste0("`wc -l < ",path2Genotype,"/",geno,".bim | awk '{print $1}'`")
    cat("The command",command,"\n")
    nsnps = as.numeric(system(command,intern=T))
    
    sbluplambda = nsnps * (1/herit) - 1
    
    #cat("The command",command,"\n")
    mySystem(command)
    command = paste0(path2plink,"plink --bfile ",path2Genotype,"/",geno," --pheno ",workPath,"/",pheno,".pheno --make-bed --out ",
                     workPath,"/",geno,".forSblup")
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0(path2gcta64,"/gcta64 --bfile ",workPath,"/",geno,".forSblup --cojo-file ",path2GWAS,"/",gwas," --cojo-sblup ",sbluplambda,
                     " --cojo-wind 10000 --thread-num ",cores," --out ",fprefix,".temp")
    #cat("The command",command,"\n")
    mySystem(command)
    command = paste0(path2gcta64,"/gcta64 --bfile ",workPath,"/",geno,".forSblup --cojo-file ",path2GWAS,"/",gwas," --cojo-sblup ",sbluplambda,
                     " --cojo-wind 10000 --thread-num ",cores," --out ",fprefix,".temp")
    #cat("The command",command,"\n")
    mySystem(command)
    
    ## load SBLUP results
    sblupdata <- fread(paste(fprefix,".temp.sblup.cojo", sep = ""), header = F)
    
    ## start filters for sign matching and abs > 1 in sblup estimates to get ~25% data
    sblupdata$match <- ifelse(sign(sblupdata$V3) == sign(sblupdata$V4), 1, 0)
    sblupdata <- subset(sblupdata, match == 1 & abs(sblupdata$V4) > 1)
    names(sblupdata) <- c("SNP","effectAllele","gwasBeta","sblupBeta","effectMatch")
    ## export list of SNPs to pull
    fwrite(sblupdata, paste(fprefix,".sblupToPull", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
    
    command = paste0(path2plink,"plink --bfile ",workPath,"/",geno,".forSblup --extract ",workPath,geno,".sblupToPull --indep-pairwise 10000 1 0.1 --out ",
                     fprefix,".pruning")
    #cat("The command",command,"\n")
    mySystem(command)
    
    
    command = paste0(path2plink,"plink --bfile ",workPath,geno,".forSblup --extract ",fprefix,".pruning.prune.in --recode A --out ",
                     fprefix,".reduced_genos")
    #cat("The command",command,"\n")
    mySystem(command)
    # exports SNP list for extraction in validataion set
    command = paste0("cut -f 1 ",fprefix,".pruning.prune.in > ",fprefix,".reduced_genos_snpList; rm ",workPath,geno,".forSblup.*")
    #cat("The command",command,"\n")
    mySystem(command)
    
  }else if(reduce == "PRSICE" & !is.na(gwas)){
    ### if $reduce = PRSICE, $phenoScale is DISC, $gwas is not NA, $cov = NA
    
    ifelse(is.na(cov),covstr <- " ",covstr <- paste0(" --cov-file ",path2Genotype,"/",cov,".cov "))
    ifelse(phenoScale == "DISC",binaryTarget <- T,binaryTarget <- F)
    
    command = genPRSiceCommand(geno,
                               pheno,
                               covstr,
                               path2PRSice,
                               PRSiceexe,
                               cores,
                               fprefix,
                               path2Genotype,
                               path2GWAS,
                               gwas,
                               binaryTarget,
                               ...)
    
    cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0("cut -f 2 ",fprefix,".temp.snp > ",fprefix,".temp.snpsToPull")
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0("awk 'NR == 2 {print $3}' ",fprefix,".temp.summary")
    cat("The command",command,"\n")
    thresh = as.numeric(system(command,intern=T))
    
    command = clumpCommand(geno,gwas,thresh,fprefix,path2plink,path2Genotype,path2GWAS,SNPcolumnatGWAS,clumpField)
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0("cut -f 3 ",fprefix,".tempClumps.clumped > ",fprefix,".temp.snpsToPull2")
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0(path2plink,"plink --bfile ",path2Genotype,geno," --extract ",fprefix,".temp.snpsToPull2 --recode A --out ",fprefix,".reduced_genos")
    #cat("The command",command,"\n")
    mySystem(command)
    # exports SNP list for extraction in validataion set
    command = paste0("cut -f 1 ",fprefix,".temp.snpsToPull2 > ",fprefix,".reduced_genos_snpList")
    #cat("The command",command,"\n")
    mySystem(command)
    
    return(handler)
    
  }else
    stop("The combination of parameters is not right")
}







#' Title
#'
#' @param handler 
#' @param addit 
#' @param path2plink 
#'
#' @return
#' @export
#'
#' @examples
fromSNPs2MLdata = function(handler,addit,path2plink){
  
  if(!is.null(handler$nfolds)){
    modes = c("train","test")
  }else
    modes = "train"
  
  for(mode in modes){
    if(mode == "train" & length(modes) == 1){
      geno = basename(handler$geno)
      pheno = basename(handler$pheno)
      workPath=paste0(dirname(handler$geno),"/")
      path2Genotype=paste0(dirname(handler$geno),"/")
      cov = basename(handler$covs)
      prefix <- paste("g",geno,"p",pheno,"c",cov,"a",addit, sep = "-")
      
    }else if(mode == "train" & length(modes) > 1){
      geno = basename(handler$trainFoldFiles[[1]]$genoFile)
      pheno = basename(gsub(".pheno","",handler$trainFoldFiles[[1]]$phenoFile))
      workPath=paste0(dirname(handler$trainFoldFiles[[1]]$genoFile),"/")
      path2Genotype=workPath
      cov = basename(gsub(".cov","",handler$trainFoldFiles[[1]]$covsFile))
      prefix <- paste("g",geno,"p",pheno,"c",cov,"a",addit, sep = "-")
      
    }else if(mode == "test" & length(modes) > 1){
      geno = basename(handler$testFoldFiles[[1]]$genoFile)
      pheno = basename(gsub(".pheno","",handler$testFoldFiles[[1]]$phenoFile))
      workPath=paste0(dirname(handler$testFoldFiles[[1]]$genoFile),"/")
      path2Genotype=workPath
      cov = basename(gsub(".cov","",handler$testFoldFiles[[1]]$covsFile))
      
      #We need the previous prefix
      genotrn = basename(handler$trainFoldFiles[[1]]$genoFile)
      phenotrn = basename(gsub(".pheno","",handler$trainFoldFiles[[1]]$phenoFile))
      covtrn = basename(gsub(".cov","",handler$trainFoldFiles[[1]]$covsFile))
      workPathtrn=paste0(dirname(handler$trainFoldFiles[[1]]$genoFile),"/")
      previous <- paste("g",genotrn,"p",phenotrn,"c",covtrn,"a",addit, sep = "-")
      prefix <- paste("g",geno,"p",pheno,"c",cov,"a",addit, sep = "-")
      command = paste0(path2plink,"plink --bfile ",workPath,"/",geno," --keep ",workPath,"/",cov,".cov" ,
                       " --extract ",workPathtrn,"/",previous,
                       ".reduced_genos_snpList --recode A --out ",workPath,"/", prefix,".reduced_genos")
      
      cat("Running command ",command,"\n")
      system(command)
    }else
      stop()
    
    
    
    print(prefix)
    #sink(file = paste(prefix, "_mergeInput.Rout", sep = ""), type = c("output"))
    print(paste("GENO PREEFIX file set as ", geno, sep = ""))
    print(paste("PHENO PREEFIX file set as ", pheno, sep = ""))
    print(paste("COV PREEFIX file set as ", cov, sep = "")) # if not specified load NA
    print(paste("ADDIT PREEFIX file set as ", addit, sep = "")) # if not specified load NA
    print(paste("ALL RESULTS TAGGED WITH PREFIX -> ", prefix, sep = ""))
    
    ## load packages
    library("data.table")
    ### now decide what to merge
    genoPheno <- 2
    addCov <- ifelse(cov == "NA", 0, 1)
    addAddit <- ifelse(addit == "NA", 0, 1)
    nFiles <- genoPheno + addCov + addAddit # this specifies the number of files to merge
    print(paste("MERGING ", nFiles," FILES", sep = ""))
    genotypeInput <- paste(workPath,prefix, ".reduced_genos.raw", sep = "")
    phenoInput <- paste(workPath,pheno, ".pheno", sep = "")
    covInput <- paste(workPath,cov, ".cov", sep = "")
    additInput <- paste(workPath,addit, ".addit", sep = "")
    
    ### run for only geno and pheno data, ie nFiles = 2
    if(nFiles == 2)
    {
      genosRaw <- fread(genotypeInput)
      phenoRaw <- fread(phenoInput)
      genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
      phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
      phenoRaw[, c("FID","IID") := NULL]
      genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
      temp <- merge(phenoRaw, genosRaw, by = "ID")
      names(temp)[2] <- "PHENO"
      fname = paste(workPath,prefix,".dataForML", sep = "")
      fwrite(temp, file = fname, quote = F, sep = "\t", row.names = F, na = NA)
      print("First 100 variable names for your file below, the rest are likely just more genotypes...")
      print(head(names(temp), n = 100))
      print("... and the last 100 variable names for your file below...")
      print(tail(names(temp), n = 100))
      print(paste("Your final file has ", length(temp$ID)," samples, and ", length(names(temp))," predictors for analysis", sep = ""))
      handler[[paste0(mode,"mldata")]] = fname
    }
    
    ### run for studies that have all geno, pheno, cov and addit data availible, ie nFiles = 4
    if(nFiles == 4)
    {
      genosRaw <- fread(genotypeInput)
      phenoRaw <- fread(phenoInput)
      covRaw <- fread(covInput)
      additRaw <- fread(additInput)
      genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
      phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
      covRaw$ID <- paste(covRaw$FID, covRaw$IID, sep = "_")
      additRaw$ID <- paste(additRaw$FID, additRaw$IID, sep = "_")
      phenoRaw[, c("FID","IID") := NULL]
      genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
      covRaw[, c("FID","IID") := NULL]
      additRaw[, c("FID","IID") := NULL]
      temp1 <- merge(phenoRaw, covRaw, by = "ID")
      temp2 <- merge(temp1, additRaw, by = "ID")
      temp3 <- merge(temp2, genosRaw, by = "ID")
      names(temp3)[2] <- "PHENO"
      fname = paste(workPath,prefix,".dataForML", sep = "")
      fwrite(temp3, file = fname, quote = F, sep = "\t", row.names = F, na = NA)
      print("First 100 variable names for your file below, the rest are likely just more genotypes...")
      print(head(names(temp3), n = 100))
      print("... and the last 100 variable names for your file below...")
      print(tail(names(temp3), n = 100))
      print(paste("Your final file has ", length(temp3$ID)," samples, and ", length(names(temp3))," predictors for analysis", sep = ""))
      
      handler[[paste0(mode,"mldata")]] = fname
    }
    
    ### run for studies that have all geno, pheno and cov data availible (addit is missing), ie nFiles = 3
    if(nFiles == 3 & addit == "NA")
    {
      genosRaw <- fread(genotypeInput)
      phenoRaw <- fread(phenoInput)
      otherRaw <- fread(covInput)
      genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
      phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
      otherRaw$ID <- paste(otherRaw$FID, otherRaw$IID, sep = "_")
      phenoRaw[, c("FID","IID") := NULL]
      genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
      otherRaw[, c("FID","IID") := NULL]
      temp1 <- merge(phenoRaw, otherRaw, by = "ID")
      temp2 <- merge(temp1, genosRaw, by = "ID")
      names(temp2)[2] <- "PHENO"
      fname = paste(workPath,prefix,".dataForML", sep = "")
      fwrite(temp2, file = fname, quote = F, sep = "\t", row.names = F, na = NA)
      print("First 100 variable names for your file below, the rest are likely just more genotypes...")
      print(head(names(temp2), n = 100))
      print("... and the last 100 variable names for your file below...")
      print(tail(names(temp2), n = 100))
      print(paste("Your final file has ", length(temp2$ID)," samples, and ", length(names(temp2))," predictors for analysis", sep = ""))
      handler[[paste0(mode,"mldata")]] = fname
    }
    
    ### run for studies that have all geno, pheno and addit data availible (cov is missing), ie nFiles = 3
    if(nFiles == 3 & cov == "NA")
    {
      genosRaw <- fread(genotypeInput)
      phenoRaw <- fread(phenoInput)
      otherRaw <- fread(additInput)
      genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
      phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
      otherRaw$ID <- paste(otherRaw$FID, otherRaw$IID, sep = "_")
      phenoRaw[, c("FID","IID") := NULL]
      genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
      otherRaw[, c("FID","IID") := NULL]
      temp1 <- merge(phenoRaw, otherRaw, by = "ID")
      temp2 <- merge(temp1, genosRaw, by = "ID")
      names(temp2)[2] <- "PHENO"
      fname = paste(workPath,prefix,".dataForML", sep = "")
      fwrite(temp2, file = fname, quote = F, sep = "\t", row.names = F, na = NA)
      print("First 100 variable names for your file below, the rest are likely just more genotypes...")
      print(head(names(temp2), n = 100))
      print("... and the last 100 variable names for your file below...")
      print(tail(names(temp2), n = 100))
      print(paste("Your final file has ", length(temp2$ID)," samples, and ", length(names(temp2))," predictors for analysis", sep = ""))
      handler[[paste0(mode,"mldata")]] = fname
    }
    
    
  }
  return(handler)
}

#' Title
#'
#' @param prefix 
#' @param outcome 
#' @param skipMLinit 
#' @param ncores 
#' @param learningAlgorithm
#' @param cvReps 
#' @param gridSearch 
#' @param imputeMissingData 
#' @param testCov 
#' @param testPheno 
#' @param testAddit 
#' @param testGeno 
#' @param clLogPath 
#' @param workPath 
#' @param caretPath 
#' @param clParams 
#'
#' @return
#' @export
#'
#' @examples
genoMLtrainAndTest = function(handler,
                              outcome=c("cont","disc"),
                              skipMLinit=F,
                              ncores=1,
                              learningAlgorithm="xgbTree",
                              cvReps=10,
                              gridSearch=30,
                              imputeMissingData="median",
                              useCluster=T,
                              clLogPath="~/launch/",
                              caretPath="/home/jbotia/caret/pkg/caret/",
                              clParams=" -l h_rt=96:0:0 -l tmem=3G,h_vmem=3G "){
  stopifnot(handler$nfolds == 1)
  detach(package:caret, unload=TRUE)
  if(useCluster){
    library(devtools)
    cat("Loading caret from...",caretPath,"\n")
    load_all(caretPath)
    
  }else
    library(caret)
  library(plotROC)
  prefix = gsub(".dataForML","",basename(handler$trainmldata))
  workPath = dirname(handler$trainmldata)
  options(bitmapType='cairo')
  expid = learningAlgorithm
  ## Parse args and start logging
  prefixout = paste0(prefix,"_",expid)
  cat("Starting ML data initialization\n")
  train <- fread(handler$trainmldata, header = T)
  ### set outcome as a factor, check missingness, then impute missing data and scale
  if(outcome == "disc"){
    train$PHENO[train$PHENO == 2] <- "DISEASE"
    train$PHENO[train$PHENO == 1] <- "CONTROL"  
  }
  
  sum(is.na(train))
  ID <- train$ID
  train[,c("ID") := NULL]
  preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
  train_processed <- predict(preProcValues, train) # here we make the preprocessed values
  
  ## a bit more data munging that doesn't matter most of the time, we'll be ignoring this for now due to prefiltering but worth including in your considerations
  #nzv <- nearZeroVar(train_processed[,-1], saveMetrics= TRUE) # checks for near non zero and flags
  #descrCor <- cor(train_processed[,-1]) # builds correlation matrix
  #highlyCorDescr <- findCorrelation(descrCor, cutoff = .75, names = T, verbose = T) # checks correlated features and summarizes, can write function in later to drop
  #fwrite(nzv, paste(workPath,prefixout,".nzv", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the near and nonzero predictors
  #write.table(highlyCorDescr, paste(workPath,prefixout,".highCor", sep = ""), quote = F, sep = "\t", row.names = F, col.names = F) # this exports globally correlated predictors
  ## the two files above might want to be used to exclude some data prior to re-analysis
  #comboInfo <- findLinearCombos(train_processed) # finds biased linear combinations
  #fwrite(comboInfo, paste(prefix,".comboInfo", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the possible linear combinations in the dataset that may be problematic and should be examined
  
  if(outcome == "cont")
    stop("Continuous mode not implemented")
  
  
  
  ## Load dataset
  ## Check command arguments from user
  print("This is a discrete run\n")
  print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
  print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
  print(paste("RUNNNING CROSS VALIDATION FOR ", cvReps, " REPS", sep = ""))
  print(paste("GRID SEARCH FOR ", gridSearch, " ITERATIONS", sep = ""))
  print(paste("ANOTHER LEVEL OF IMPUTATION AND DATa TRANSFORMATION USING ", imputeMissingData, sep = ""))
  
  
  ## here we set the cross validation
  cat("Setting trainControl object\n")
  if(useCluster){
    clusterwd = paste0(workPath,"/cluster/")
    if(!dir.exists(clusterwd))
      dir.create(clusterwd)
    fitControl <- trainControl(method = "cv",
                               number = cvReps,
                               classProbs = TRUE,
                               summaryFunction = twoClassSummary,
                               search = "random",
                               clLogPath=clusterwd,
                               clParams=clParams)
    
  }else
    fitControl <- trainControl(method = "cv",
                               number = cvReps,
                               classProbs = TRUE,
                               summaryFunction = twoClassSummary,
                               search = "random")
  
  cat("Calling train and then wait\n")
  model <- train(PHENO ~ ., 
                 data = train_processed,
                 workPath=workPath,
                 method = learningAlgorithm,
                 trControl = fitControl,
                 tuneLength = gridSearch,
                 metric = "ROC")
  
  cat("Processing discrete stuff\n")
  ## pick best model from model compare then output plots in this case, its picked via ROC, 
  # maximizing the mean AUC across resamplings
  bestAlgorithm <- learningAlgorithm
  write.table(bestAlgorithm, file = paste(workPath,prefixout,"_bestModel.algorithm",sep = ""), 
              quote = F, row.names = F, col.names = F) # exports "method" option for the best algorithm
  handler$bestAlgorithm = bestAlgorithm
  handler$bestModel = model
  bestModel <- model
  
  train_processed$predicted <- predict(bestModel, train_processed)
  train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
  train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
  train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
  trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
  trained$ID <- train$ID
  write.table(trained, file = paste(workPath,prefixout,"_trainingSetPredictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
  handler$trainingPredictions = trained
  overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
  ggsave(plot = overlayedRocs, filename = paste(workPath,prefixout,"_plotRoc.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
  densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
  ggsave(plot = densPlot, filename = paste(workPath,prefixout,"_plotDensity.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
  overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
  ggsave(plot = overlayedRocs, filename = paste(workPath,prefixout,"_plotRocNoCI.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
  
  # print("entering varImp")
  # varImpList <- varImp(bestModel, scale = F) # here we get the importance matrix for the best model unscaled
  # print(varImpList)
  # if(!is.null(varImpList)){
  #   print(varImpList)
  #   varImpTable <- as.matrix(varImpList$importance)
  #   print(varImpTable)
  #   write.table(varImpTable, file = paste(workPath,prefixout,"_varImp.tab",sep =""), quote = F, sep = "\t", col.names = F)
  # }
  # handler$varImportance = varImpTable
  
  confMat <- confusionMatrix(data = as.factor(trained$predicted), reference = as.factor(trained$PHENO), positive = "DISEASE")
  handler$confMat = confMat
  testGeno = basename(handler$testFoldFiles[[1]]$genoFile)
  testPheno = basename(gsub(".pheno","",handler$testFoldFiles[[1]]$phenoFile))
  workPath=paste0(dirname(handler$testFoldFiles[[1]]$genoFile),"/")
  testCov = basename(gsub(".cov","",handler$testFoldFiles[[1]]$covsFile))
  testAddit = "NA"
  testprefix <- paste("g",testGeno,"p",testPheno,"c",testCov,"a",testAddit,sep = "-")
  
  print(paste("DATA PREEFIX file for VALIDATION set as ", testprefix, sep = ""))
  print(paste("ANOTHER LEVEL OF IMPUTATION AND DATA TRANSFORMATION USING ", imputeMissingData, sep = ""))
  #Let us check headers
  checkVariantNames(handler$trainmldata,handler$testmldata)
  ## Load dataset
  train <- fread(handler$testmldata, header = T)
  
  ### set outcome as a factor, check missingness, then impute missing data and scale
  train$PHENO[train$PHENO == 2] <- "DISEASE"
  train$PHENO[train$PHENO == 1] <- "CONTROL"
  ID <- train$ID
  train[,c("ID") := NULL]
  preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) 
  # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
  train_processed <- predict(preProcValues, train) # here we make the preprocessed values
  
  train_processed$predicted <- predict(bestModel, train_processed)
  train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
  train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
  train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
  trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
  trained$ID <- ID
  handler$evalPredictions = trained
  write.table(trained, file = paste(workPath,testprefix,"_validation_predictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
  overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
  ggsave(plot = overlayedRocs, filename = paste(workPath,testprefix,"_validation_plotRoc.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
  densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
  ggsave(plot = densPlot, filename = paste(workPath,testprefix,"_validation_plotDensity.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
  overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
  ggsave(plot = overlayedRocs, filename = paste(workPath,testprefix,"_validation_plotRocNoCI.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
  confMat <- confusionMatrix(data = as.factor(trained$predicted), reference = as.factor(trained$PHENO), positive = "DISEASE")
  print(confMat)
  handler$evalConfMat = confMat
  return(handler)
  
}



genPRSiceCommand = function(geno,
                            pheno,
                            covstr,
                            path2PRSice,
                            PRSiceexe,
                            cores,
                            fprefix,
                            path2Genotype,
                            path2GWAS,
                            gwas,
                            binaryTarget,
                            barLevels="5E-8,4E-8,3E-8,2E-8,1E-8,9E-7,8E-7,7E-7,6E-7,5E-7,4E-7,3E-7,2E-7,1E-7,9E-6,8E-6,7E-6,6E-6,5E-6,4E-6,3E-6,2E-6,1E-6,9E-5,8E-5,7E-5,6E-5,5E-5,4E-5,3E-5,2E-5,1E-5,9E-4,8E-4,7E-4,6E-4,5E-4,4E-4,3E-4,2E-4,1E-4,9E-3,8E-3,7E-3,6E-3,5E-3,4E-3,3E-3,2E-3,1E-3,9E-2,8E-2,7E-2,6E-2,5E-2,4E-2,3E-2,2E-2,1E-2,9E-1,8E-1,7E-1,6E-1,5E-1,4E-1,3E-1,2E-1,1E-1,1 ",
                            gwasDef=" --beta --snp SNP --A1 A1 --A2 A2 --stat b --se se --pvalue p"){
  
  return(paste0("Rscript ",path2PRSice,"PRSice.R --binary-target T --prsice ",path2PRSice,PRSiceexe,
                " -n ",
                cores, " --out ",fprefix,".temp --pheno-file ",path2Genotype,"/",pheno,".pheno -t ",
                path2Genotype,"/",geno," -b ",
                path2GWAS,"/",gwas,covstr,
                " --print-snp --score std --perm 10000 ",
                " --bar-levels ",barLevels,
                " --fastscore --binary-target ",binaryTarget,
                gwasDef))
  
}



clumpCommand = function(geno,gwas,thresh,fprefix,path2plink,path2Genotype,path2GWAS,SNPcolumnatGWAS,clumpField){
  return(paste0(path2plink,"plink --bfile ",path2Genotype,"/",geno," --extract ",
                fprefix,".temp.snpsToPull --clump ",path2GWAS,"/",gwas,
                " --clump-p1 ",thresh," --clump-p2 ",thresh,
                " --clump-snp-field ",SNPcolumnatGWAS," --clump-field ",clumpField," --clump-r2 0.1 --clump-kb 250 --out ",
                fprefix,".tempClumps"))
  
  
}

checkVariantNames = function(traindata,testdata){
  
  cat("Checking possible change of main allele between train ",traindata,
      " and test data ",testdata,"\n")
  train = fread(traindata, header = T)
  test = fread(testdata,header=T)
  snps = grep(":",colnames(train))
  snps = colnames(train)[snps]
  sentinel = F
  for(snp in snps){
    if(!(snp %in% colnames(test))){
      cat(snp," from traning data is not at test data\n")
      thesplit = stringr::str_split(snp,"_")
      commonpart = thesplit[[1]][[1]]
      letter = thesplit[[1]][[2]]
      testpos = grep(commonpart,colnames(test))
      wrongsnp = colnames(test)[testpos]
      test[,testpos] = 2 - test[,..testpos]
      
      cat("Converting ",wrongsnp," into ",paste0(commonpart,"_",letter),"\n")
      colnames(test)[testpos] = paste0(commonpart,"_",letter)
      sentinel = T
    }
  }
  if(sentinel){
    cat("Saving ",testdata," again to disk\n")
    fwrite(test, file = testdata, quote = F, sep = "\t", row.names = F, na = NA)  
  }
  else
    cat("No need to change any variant name, identical column nanes for test/train data\n")
  
}


mySystem = function(command,verbose=T,strict=T,intern=F){
  if(verbose)
    cat("The command to run is ",command,"\n")
  r = attr(system(command,intern=T),"status")
  if(strict & !is.null(r)){
    if(r > 0)
      stop(paste0("Something went wrong with the command ",command))
  }
  print(r)
  
}

## load data here from command script
args <- commandArgs()
print(args)
geno <- args[6]
pheno <- args[7]
cov <- args[8] # if no covs, sepc NA on command line
addit <- args[9] # if no addit, spec NA on command line
prefix <- args[10] # take it from the main python code
## prefix <- paste("g",geno,"p",pheno,"c",cov,"a",addit, sep = "-")
print(prefix)
sink(file = paste(prefix, "_mergeInput.Rout", sep = ""), type = c("output"))
print(paste("GENO PREEFIX file set as ", args[6], sep = ""))
print(paste("PHENO PREEFIX file set as ", args[7], sep = ""))
print(paste("COV PREEFIX file set as ", args[8], sep = "")) # if not specified load NA
print(paste("ADDIT PREEFIX file set as ", args[9], sep = "")) # if not specified load NA
print(paste("ALL RESULTS TAGGED WITH PREFIX -> ", prefix, sep = ""))

## load packages
library("data.table")

### now decide what to merge
genoPheno <- 2
addCov <- ifelse(cov == "NA", 0, 1)
addAddit <- ifelse(addit == "NA", 0, 1)
nFiles <- genoPheno + addCov + addAddit # this specifies the number of files to merge
print(paste("MERGING ", nFiles," FILES", sep = ""))
genotypeInput <- paste(prefix, ".reduced_genos.raw", sep = "")
phenoInput <- paste(pheno, "", sep = "") ## phenoInput <- paste(pheno, ".pheno", sep = "")
covInput <- paste(cov, "", sep = "") ## covInput <- paste(cov, ".cov", sep = "")
additInput <- paste(addit, "", sep = "") ## additInput <- paste(addit, ".addit", sep = "")

### run for only geno and pheno data, ie nFiles = 2
if(nFiles == 2)
{
	genosRaw <- fread(genotypeInput)
	phenoRaw <- fread(phenoInput)
	genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
	phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
	phenoRaw[, c("FID","IID") := NULL]
	genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
	temp <- merge(phenoRaw, genosRaw, by = "ID")
	names(temp)[2] <- "PHENO"
	fwrite(temp, file = paste(prefix,".dataForML", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
	print("First 100 variable names for your file below, the rest are likely just more genotypes...")
	print(head(names(temp), n = 100))
	print("... and the last 100 variable names for your file below...")
	print(tail(names(temp), n = 100))
	print(paste("Your final file has ", length(temp$ID)," samples, and ", length(names(temp))," predictors for analysis", sep = ""))	
}

### run for studies that have all geno, pheno, cov and addit data availible, ie nFiles = 4
if(nFiles == 4)
{
	genosRaw <- fread(genotypeInput)
	phenoRaw <- fread(phenoInput)
	covRaw <- fread(covInput)
	additRaw <- fread(additInput)
	genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
	phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
	covRaw$ID <- paste(covRaw$FID, covRaw$IID, sep = "_")
	additRaw$ID <- paste(additRaw$FID, additRaw$IID, sep = "_")
	phenoRaw[, c("FID","IID") := NULL]
	genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
	covRaw[, c("FID","IID") := NULL]
	additRaw[, c("FID","IID") := NULL]
	temp1 <- merge(phenoRaw, covRaw, by = "ID")
	temp2 <- merge(temp1, additRaw, by = "ID")
	temp3 <- merge(temp2, genosRaw, by = "ID")
	names(temp3)[2] <- "PHENO"
	fwrite(temp3, file = paste(prefix,".dataForML", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
	print("First 100 variable names for your file below, the rest are likely just more genotypes...")
	print(head(names(temp3), n = 100))
	print("... and the last 100 variable names for your file below...")
	print(tail(names(temp3), n = 100))
	print(paste("Your final file has ", length(temp3$ID)," samples, and ", length(names(temp3))," predictors for analysis", sep = ""))	
}

### run for studies that have all geno, pheno and cov data availible (addit is missing), ie nFiles = 3
if(nFiles == 3 & addit == "NA")
{
	genosRaw <- fread(genotypeInput)
	phenoRaw <- fread(phenoInput)
	otherRaw <- fread(covInput)
	genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
	phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
	otherRaw$ID <- paste(otherRaw$FID, otherRaw$IID, sep = "_")
	phenoRaw[, c("FID","IID") := NULL]
	genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
	otherRaw[, c("FID","IID") := NULL]
	temp1 <- merge(phenoRaw, otherRaw, by = "ID")
	temp2 <- merge(temp1, genosRaw, by = "ID")
	names(temp2)[2] <- "PHENO"
	fwrite(temp2, file = paste(prefix,".dataForML", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
	print("First 100 variable names for your file below, the rest are likely just more genotypes...")
	print(head(names(temp2), n = 100))
	print("... and the last 100 variable names for your file below...")
	print(tail(names(temp2), n = 100))
	print(paste("Your final file has ", length(temp2$ID)," samples, and ", length(names(temp2))," predictors for analysis", sep = ""))	
}

### run for studies that have all geno, pheno and addit data availible (cov is missing), ie nFiles = 3
if(nFiles == 3 & cov == "NA")
{
	genosRaw <- fread(genotypeInput)
	phenoRaw <- fread(phenoInput)
	otherRaw <- fread(additInput)
	genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
	phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
	otherRaw$ID <- paste(otherRaw$FID, otherRaw$IID, sep = "_")
	phenoRaw[, c("FID","IID") := NULL]
	genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
	otherRaw[, c("FID","IID") := NULL]
	temp1 <- merge(phenoRaw, otherRaw, by = "ID")
	temp2 <- merge(temp1, genosRaw, by = "ID")
	names(temp2)[2] <- "PHENO"
	fwrite(temp2, file = paste(prefix,".dataForML", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
	print("First 100 variable names for your file below, the rest are likely just more genotypes...")
	print(head(names(temp2), n = 100))
	print("... and the last 100 variable names for your file below...")
	print(tail(names(temp2), n = 100))
	print(paste("Your final file has ", length(temp2$ID)," samples, and ", length(names(temp2))," predictors for analysis", sep = ""))	
}

### save the log file
sink()

### now quit w/o saving workspace
q("no")

## Parse args and start logging
args <- commandArgs()
print(args)
prefix <- args[6]

## load library
library("data.table")

## load SBLUP results
data <- fread(paste(prefix,".temp.sblup.cojo", sep = ""), header = F)

## start filters for sign matching and abs > 1 in sblup estimates to get ~25% data
data$match <- ifelse(sign(data$V3) == sign(data$V4), 1, 0)
dat <- subset(data, match == 1 & abs(data$V4) > 0.05)
names(dat) <- c("SNP","effectAllele","gwasBeta","sblupBeta","effectMatch")

## export list of SNPs to pull
fwrite(dat, paste(prefix,".sblupToPull", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)

## close down shop and don't save nuthin
q("no")

list.of.packages <- c(    "caret", "lattice", "ggplot2", "rBayesianOptimization", "plotROC", "doParallel", "randomForest", "xgboost", "e1071")
new.packages <- list.of.packages[!(list.of.packages %in% installed.packages()[,"Package"])]
if(length(new.packages)) install.packages(new.packages, repos = "https://cloud.r-project.org/")

## Load additional packages
packageList <- c("caret","ggplot2","data.table","rBayesianOptimization","plotROC","stringr")
lapply(packageList, library, character.only = TRUE)

models = NULL
models[["ALL"]] = c("dnn","lda","glm", "nnet","C5.0","glmnet","nb", "xgbLinear", "earth", "svmRadial", "lasso", 
                    "ridge", "evtree", "xgbTree", "rf", "bayesglm", "xgbDART")
models[["FAST"]] =  c("glm", "glmnet", "xgbLinear", "earth", "svmRadial", "lasso", "xgbTree", "xgbDART")
models[["FURIOUS"]] = c("glm", "glmnet", "xgbLinear", "earth", "svmRadial", "lasso")
models[["BOOSTED"]] = c("xgbLinear", "xgbTree", "xgbDART")

trainCluster_prepareData = function(geno,pheno,cov,split){
  covfile = paste0(cov,".cov")
  phenofile = paste0(pheno,".pheno")
  covdata = read.delim(covfile,stringsAsFactors=F)
  
  
}

mySystem = function(command,verbose=T,strict=T,intern=F){
  if(verbose)
    cat("The command to run is ",command,"\n")
  r = attr(system(command,intern=T),"status")
  if(strict & !is.null(r)){
    if(r > 0)
      stop(paste0("Something went wrong with the command ",command))  
  }
  print(r)
  
}

#' Title
#'
#' @param reduce 
#' @param herit 
#' @param geno 
#' @param pheno 
#' @param cov 
#' @param addit 
#' @param pathtoplink 
#'
#' @return
#' @export
#'
#' @examples
trainCluster_initData = function(geno,
                                 pheno,
                                 cov,
                                 addit="NA",
                                 reduce="PRSICE",
                                 gwas="RISK_noSpain.tab",
                                 herit=NA,
                                 path2GenoML="~/GenoML",
                                 path2plink=paste0(path2GenoML,"/otherPackages/"),
                                 path2gcta64=paste0(path2GenoML,"/otherPackages/"),
                                 cores=1,
                                 phenoScale="DISC",
                                 workPath=path2GenoML,
                                 path2PRSice=path2plink,
                                 path2GWAS=path2GenoML,
                                 path2Genotype=path2GenoML){
  
  ### options passed from list on draftCommandOptions.txt
  prefix=paste0("g-",geno,"-p-",pheno,"-c-",cov,"-a-",addit)
  fprefix = paste0(workPath,"/",prefix)
  
  if(reduce == "PRUNE" || reduce == "DEFAULT"){
    command = paste0(path2plink,"plink --bfile ",path2Genotype,"/",geno," --indep-pairwise 10000 1 0.1 --out ",fprefix,".temp")
    mySystem(command)
    command = paste0(path2plink,"plink --bfile ",path2Genotype,"/",geno," --extract ",fprefix,".temp.prune.in --recode A --out ",
                     fprefix,".reduced_genos")
    #cat("The command",command,"\n")
    mySystem(command)
    command = paste0("cut -f 1 ",fprefix,".temp.prune.in > ",fprefix,".reduced_genos_snpList")
    mySystem(command)
    
  }else if(reduce == "SBLUP" & !is.na(gwas) & !is.na(herit)){
    ### if $reduce = SBLUP, $gwas is not NA and $herit is not NA
    command = paste0("`wc -l < ",path2Genotype,"/",geno,".bim | awk '{print $1}'`")
    cat("The command",command,"\n")
    nsnps = as.numeric(system(command,intern=T))
    
    sbluplambda = nsnps * (1/herit) - 1
    
    #cat("The command",command,"\n")
    mySystem(command)
    command = paste0(path2plink,"plink --bfile ",path2Genotype,"/",geno," --pheno ",workPath,"/",pheno,".pheno --make-bed --out ",
                     workPath,"/",geno,".forSblup")
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0(path2gcta64,"/gcta64 --bfile ",workPath,"/",geno,".forSblup --cojo-file ",path2GWAS,"/",gwas," --cojo-sblup ",sbluplambda,
                     " --cojo-wind 10000 --thread-num ",cores," --out ",fprefix,".temp")
    #cat("The command",command,"\n")
    mySystem(command)
    command = paste0(path2gcta64,"/gcta64 --bfile ",workPath,"/",geno,".forSblup --cojo-file ",path2GWAS,"/",gwas," --cojo-sblup ",sbluplambda,
                     " --cojo-wind 10000 --thread-num ",cores," --out ",fprefix,".temp")
    #cat("The command",command,"\n")
    mySystem(command)
    
    ## load SBLUP results
    sblupdata <- fread(paste(fprefix,".temp.sblup.cojo", sep = ""), header = F)
    
    ## start filters for sign matching and abs > 1 in sblup estimates to get ~25% data
    sblupdata$match <- ifelse(sign(sblupdata$V3) == sign(sblupdata$V4), 1, 0)
    sblupdata <- subset(sblupdata, match == 1 & abs(sblupdata$V4) > 1)
    names(sblupdata) <- c("SNP","effectAllele","gwasBeta","sblupBeta","effectMatch")
    ## export list of SNPs to pull
    fwrite(sblupdata, paste(fprefix,".sblupToPull", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
    
    command = paste0(path2plink,"/plink --bfile ",workPath,"/",geno,".forSblup --extract ",workPath,geno,".sblupToPull --indep-pairwise 10000 1 0.1 --out ",
                     fprefix,".pruning")
    #cat("The command",command,"\n")
    mySystem(command)
    
    
    command = paste0(path2plink,"/plink --bfile ",workPath,geno,".forSblup --extract ",fprefix,".pruning.prune.in --recode A --out ",
                     fprefix,".reduced_genos")
    #cat("The command",command,"\n")
    mySystem(command)
    # exports SNP list for extraction in validataion set
    command = paste0("cut -f 1 ",fprefix,".pruning.prune.in > ",fprefix,".reduced_genos_snpList; rm ",workPath,geno,".forSblup.*")
    #cat("The command",command,"\n")
    mySystem(command)
    
  }else if(reduce == "PRSICE" & !is.na(gwas)){
    ### if $reduce = PRSICE, $phenoScale is DISC, $gwas is not NA, $cov = NA
    
    ifelse(is.na(cov),covstr <- " ",covstr <- paste0(" --cov-file ",path2Genotype,"/",cov,".cov "))
    ifelse(phenoScale == "DISC",binaryTarget <- T,binaryTarget <- F)
    
    command = paste0("Rscript ",path2PRSice,"/PRSice.R --binary-target T --prsice ",path2PRSice,"/PRSice_linux -n ", 
                     cores, " --out ",fprefix,".temp --pheno-file ",path2Genotype,"/",pheno,".pheno -t ",path2Genotype,"/",geno," -b ",
                     path2GWAS,"/",gwas,covstr,
                     " --print-snp --score std --perm 10000 ",
                     " --bar-levels ",
                     "5E-8,4E-8,3E-8,2E-8,1E-8,9E-7,8E-7,7E-7,6E-7,5E-7,4E-7,3E-7,2E-7,1E-7,9E-6,8E-6,7E-6,6E-6,5E-6,4E-6,3E-6,2E-6,1E-6,9E-5,8E-5,7E-5,6E-5,5E-5,4E-5,3E-5,2E-5,1E-5,9E-4,8E-4,7E-4,6E-4,5E-4,4E-4,3E-4,2E-4,1E-4,9E-3,8E-3,7E-3,6E-3,5E-3,4E-3,3E-3,2E-3,1E-3,9E-2,8E-2,7E-2,6E-2,5E-2,4E-2,3E-2,2E-2,1E-2,9E-1,8E-1,7E-1,6E-1,5E-1,4E-1,3E-1,2E-1,1E-1,1 ", 
                     " --fastscore --binary-target ",binaryTarget," --beta --snp SNP --A1 A1 --A2 A2 --stat b --se se --pvalue p")
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0("cut -f 2 ",fprefix,".temp.snp > ",fprefix,"prefix.temp.snpsToPull")
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0("awk 'NR == 2 {print $3}' ",fprefix,".temp.summary")
    cat("The command",command,"\n")
    thresh = as.numeric(system(command,intern=T))
    
    
    command = paste0(path2plink,"/plink --bfile ",path2Genotype,"/",geno," --extract ",
                     fprefix,".temp.snpsToPull --clump ",path2GWAS,"/",gwas, 
                     " --clump-p1 ",thresh," --clump-p2 ",thresh,
                     " --clump-snp-field SNP --clump-field p --clump-r2 0.1 --clump-kb 250 --out ",
                     fprefix,".tempClumps")
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0("cut -f 3 ",fprefix,".tempClumps.clumped > ",fprefix,".temp.snpsToPull2")
    #cat("The command",command,"\n")
    mySystem(command)
    
    command = paste0(path2plink,"/plink --bfile ",path2Genotype,geno," --extract ",fprefix,".temp.snpsToPull2 --recode A --out ",fprefix,".reduced_genos")
    #cat("The command",command,"\n")
    mySystem(command)
    # exports SNP list for extraction in validataion set
    command = paste0("cut -f 1 ",fprefix,".temp.snpsToPull2 > ",fprefix,".reduced_genos_snpList")
    #cat("The command",command,"\n")
    mySystem(command)
    
  }else
    stop("The combination of parameters is not right")
  
  
  trainCluster_merge(geno,pheno,cov,addit="NA",prefix,workPath=workPath)
  
}


#' Title
#'
#' @param prefix 
#' @param outcome 
#' @param skipMLinit 
#' @param ncores 
#' @param trainSpeed 
#' @param cvReps 
#' @param gridSearch 
#' @param imputeMissingData 
#' @param testCov 
#' @param testPheno 
#' @param testAddit 
#' @param testGeno 
#' @param clLogPath 
#' @param workPath 
#' @param caretPath 
#' @param clParams 
#'
#' @return
#' @export
#'
#' @examples
trainCluster_runAtomic = function(prefix,
                                  outcome=c("cont","disc"),
                                  skipMLinit=F,
                                  ncores=1,
                                  trainSpeed="xgbTree",
                                  cvReps=10,
                                  gridSearch=30,
                                  imputeMissingData="median",
                                  testCov=NULL,
                                  testPheno=NULL,
                                  testAddit=NULL,
                                  testGeno=NULL,
                                  clLogPath="~/launch/",
                                  workPath="../",
                                  caretPath="/home/jbotia/caret/pkg/caret/",
                                  clParams=" -l h_rt=96:0:0 -l tmem=3G,h_vmem=3G "){
  detach(package:caret, unload=TRUE)
  library(devtools)
  options(bitmapType='cairo')
  cat("Loading caret from...",caretPath,"\n")
  load_all(caretPath)
  expid = trainSpeed
  ## Parse args and start logging
  prefixout = paste0(prefix,"_",expid)
  cat("Starting ML data initialization\n")
  train <- fread(paste(workPath,prefix,".dataForML", sep = ""), header = T)
  ### set outcome as a factor, check missingness, then impute missing data and scale
  if(outcome == "disc"){
    train$PHENO[train$PHENO == 2] <- "DISEASE"
    train$PHENO[train$PHENO == 1] <- "CONTROL"  
  }
  
  sum(is.na(train))
  ID <- train$ID
  train[,c("ID") := NULL]
  preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
  train_processed <- predict(preProcValues, train) # here we make the preprocessed values
  
  ## a bit more data munging that doesn't matter most of the time, we'll be ignoring this for now due to prefiltering but worth including in your considerations
  #nzv <- nearZeroVar(train_processed[,-1], saveMetrics= TRUE) # checks for near non zero and flags
  #descrCor <- cor(train_processed[,-1]) # builds correlation matrix
  #highlyCorDescr <- findCorrelation(descrCor, cutoff = .75, names = T, verbose = T) # checks correlated features and summarizes, can write function in later to drop
  #fwrite(nzv, paste(workPath,prefixout,".nzv", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the near and nonzero predictors
  #write.table(highlyCorDescr, paste(workPath,prefixout,".highCor", sep = ""), quote = F, sep = "\t", row.names = F, col.names = F) # this exports globally correlated predictors
  ## the two files above might want to be used to exclude some data prior to re-analysis
  #comboInfo <- findLinearCombos(train_processed) # finds biased linear combinations
  #fwrite(comboInfo, paste(prefix,".comboInfo", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the possible linear combinations in the dataset that may be problematic and should be examined
  
  if(outcome == "cont"){
    ## here we set the cross validation
    fitControl <- trainControl(method = "cv",
                               number = cvReps,
                               search = "random")
    print("This is a continuous run\n")
    ## Check command arguments from user
    print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
    print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
    print(paste("RUNNNING CROSS VALIDATION FOR ", cvReps, " REPS", sep = ""))
    print(paste("GRID SEARCH FOR ", gridSearch, " ITERATIONS", sep = ""))
    print(paste("ANOTHER LEVEL OF IMPUTATION AND DATa TRANSFORMATION USING ", imputeMissingData, sep = ""))
    
    model <- train(PHENO ~ ., data = train_processed,
                   method = trainSpeed,
                   trControl = fitControl,
                   tuneLength = gridSearch,
                   metric = "Rsquared", 
                   maximize = TRUE)
    
  }else{
    
    ## Load dataset
    ## Check command arguments from user
    print("This is a discrete run\n")
    print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
    print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
    print(paste("RUNNNING CROSS VALIDATION FOR ", cvReps, " REPS", sep = ""))
    print(paste("GRID SEARCH FOR ", gridSearch, " ITERATIONS", sep = ""))
    print(paste("ANOTHER LEVEL OF IMPUTATION AND DATa TRANSFORMATION USING ", imputeMissingData, sep = ""))
    
    
    ## here we set the cross validation
    cat("Setting trainControl object\n")
    fitControl <- trainControl(method = "cv",
                               number = cvReps,
                               classProbs = TRUE,
                               summaryFunction = twoClassSummary,
                               search = "random",
                               clLogPath=clLogPath,
                               clParams=clParams)
    
    cat("Calling train and then wait\n")
    model <- train(PHENO ~ ., data = train_processed,
                   method = trainSpeed,
                   trControl = fitControl,
                   tuneLength = gridSearch,
                   metric = "ROC")
    cat("Processing discrete stuff\n")
    ## pick best model from model compare then output plots in this case, its picked via ROC, 
    # maximizing the mean AUC across resamplings
    bestAlgorithm <- trainSpeed
    write.table(bestAlgorithm, file = paste(workPath,prefixout,"_bestModel.algorithm",sep = ""), quote = F, row.names = F, col.names = F) # exports "method" option for the best algorithm
    bestModel <- model
    save(bestModel, file = paste(workPath,prefixout,"_bestModel.RData",sep = ""))
    
    train_processed$predicted <- predict(bestModel, train_processed)
    train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
    train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
    train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
    trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
    trained$ID <- train$ID
    write.table(trained, file = paste(workPath,prefixout,"_trainingSetPredictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
    overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
    ggsave(plot = overlayedRocs, filename = paste(workPath,prefixout,"_plotRoc.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
    densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
    ggsave(plot = densPlot, filename = paste(workPath,prefixout,"_plotDensity.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
    overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
    ggsave(plot = overlayedRocs, filename = paste(workPath,prefixout,"_plotRocNoCI.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
    
    print(str(bestModel))
    varImpList <- varImp(bestModel, scale = F) # here we get the importance matrix for the best model unscaled
    print(varImpList)
    varImpTable <- as.matrix(varImpList$importance)
    print(varImpTable)
    write.table(varImpTable, file = paste(workPath,prefixout,"_varImp.tab",sep =""), quote = F, sep = "\t", col.names = F)
    
    confMat <- confusionMatrix(data = as.factor(trained$predicted), reference = as.factor(trained$PHENO), positive = "DISEASE")
    sink(file = paste(workPath,prefixout,"_confMat.txt",sep =""), type = c("output"))
    print(confMat)
    sink()
    
    trainCluster_merge(testGeno,testPheno,testCov,testAddit,prefix,workPath)
    testprefix <- paste("g",testGeno,"p",testPheno,"c",testCov,"a",testAddit,sep = "-")
    
    print(paste("DATA PREEFIX file for VALIDATION set as ", testprefix, sep = ""))
    print(paste("ANOTHER LEVEL OF IMPUTATION AND DATA TRANSFORMATION USING ", imputeMissingData, sep = ""))
    #Let us check headers
    trainCluster_checkVariantNames(testprefix,prefix)
    ## Load dataset
    train <- fread(paste(workPath,testprefix,".dataForML", sep = ""), header = T)
    sink(file = paste(workPath,testprefix, "_discreteValidation.Rout", sep = ""), type = c("output"))
    ### set outcome as a factor, check missingness, then impute missing data and scale
    train$PHENO[train$PHENO == 2] <- "DISEASE"
    train$PHENO[train$PHENO == 1] <- "CONTROL"
    ID <- train$ID
    train[,c("ID") := NULL]
    preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
    train_processed <- predict(preProcValues, train) # here we make the preprocessed values
    
    train_processed$predicted <- predict(bestModel, train_processed)
    train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
    train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
    train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
    trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
    trained$ID <- ID
    write.table(trained, file = paste(workPath,testprefix,"_validation_predictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
    overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
    ggsave(plot = overlayedRocs, filename = paste(workPath,testprefix,"_validation_plotRoc.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
    densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
    ggsave(plot = densPlot, filename = paste(workPath,testprefix,"_validation_plotDensity.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
    overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
    ggsave(plot = overlayedRocs, filename = paste(workPath,testprefix,"_validation_plotRocNoCI.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
    confMat <- confusionMatrix(data = as.factor(trained$predicted), reference = as.factor(trained$PHENO), positive = "DISEASE")
    sink(file = paste(workPath,testprefix,"_validation_confMat.txt",sep =""), type = c("output"))
    print(confMat)
    sink()
    
    
    
  }
}

trainCluster_launch = function(expid,prefix,
                               outcome=c("cont","disc"),
                               skipMLinit=F,
                               ncores=1,
                               trainSpeed="ALL",
                               cvReps=5,
                               gridSearch=30,
                               imputeMissingData="median"){
  ## Parse args and start logging
  
  if(!skipMLinit){
    cat("Starting ML data initialization\n")
    train <- fread(paste(workPath,prefix,".dataForML", sep = ""), header = T)
    ### set outcome as a factor, check missingness, then impute missing data and scale
    if(outcome == "disc"){
      train$PHENO[train$PHENO == 2] <- "DISEASE"
      train$PHENO[train$PHENO == 1] <- "CONTROL"  
    }
    
    sum(is.na(train))
    ID <- train$ID
    train[,c("ID") := NULL]
    preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
    train_processed <- predict(preProcValues, train) # here we make the preprocessed values
    
    ## a bit more data munging that doesn't matter most of the time, we'll be ignoring this for now due to prefiltering but worth including in your considerations
    nzv <- nearZeroVar(train_processed[,-1], saveMetrics= TRUE) # checks for near non zero and flags
    descrCor <- cor(train_processed[,-1]) # builds correlation matrix
    highlyCorDescr <- findCorrelation(descrCor, cutoff = .75, names = T, verbose = T) # checks correlated features and summarizes, can write function in later to drop
    fwrite(nzv, paste(workPath,prefix,".nzv", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the near and nonzero predictors
    write.table(highlyCorDescr, paste(workPath,prefix,".highCor", sep = ""), quote = F, sep = "\t", row.names = F, col.names = F) # this exports globally correlated predictors
    ## the two files above might want to be used to exclude some data prior to re-analysis
    #comboInfo <- findLinearCombos(train_processed) # finds biased linear combinations
    #fwrite(comboInfo, paste(prefix,".comboInfo", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the possible linear combinations in the dataset that may be problematic and should be examined
    
    if(outcome == "cont")
      ## here we set the cross validation
      fitControl <- trainControl(method = "cv",
                                 number = cvReps,
                                 search = "random")
    else
      ## here we set the cross validation
      fitControl <- trainControl(method = "cv",
                                 number = cvReps,
                                 classProbs = TRUE,
                                 summaryFunction = twoClassSummary,
                                 search = "random")
    token = list(train_processed=train_processed,fitControl=fitControl)
    saveRDS(token,paste(workPath,prefix,".train_processed.rds", sep = ""))
    
    
  }else
    cat("Skipping ML data initialization\n")
  
  
  
  for(model in models[[trainSpeed]]){
    newprefix = paste0(prefix,"_",expid,"_",model)
    cat("We launch now ",model," algorithm\n")
    command = paste0("echo \"cd /SAN/neuroscience/WT_BRAINEAC/ml/nalls/otherPackages/; ")
    if(outcome == "cont")
      command = paste0(command,"Rscript -e \\\"source(\\\\\\\"trainCluster.R\\\\\\\"); trainContCluster_run(",
                       "prefix=\\\\\\\"",prefix,"\\\\\\\"",
                       ",method=","\\\\\\\"",model,"\\\\\\\"",
                       ",ncores=",ncores,
                       ",cvReps=",cvReps,
                       ",gridSearch=",gridSearch,
                       ",imputeMissingData=","\\\\\\\"",imputeMissingData,"\\\\\\\")",
                       "\\\"\" | qsub -S /bin/bash -cwd -N ",paste0(expid,".",model),
                       " -l h_rt=24:0:0 -l tmem=7.9G,h_vmem=7.9G",
                       " -o /home/jbotia/launch/",newprefix,
                       ".log -e /home/jbotia/launch/",newprefix,".e")
    else
      command = paste0(command,"Rscript -e \\\"source(\\\\\\\"trainCluster.R\\\\\\\"); trainDiscCluster_run(",
                       "prefix=\\\\\\\"",prefix,"\\\\\\\"",
                       ",method=","\\\\\\\"",model,"\\\\\\\"",
                       ",ncores=",ncores,
                       ",cvReps=",cvReps,
                       ",gridSearch=",gridSearch,
                       ",imputeMissingData=","\\\\\\\"",imputeMissingData,"\\\\\\\")",
                       "\\\"\" | qsub -S /bin/bash -cwd -N ",paste0(expid,".",model),
                       " -l h_rt=24:0:0 -l tmem=7.9G,h_vmem=7.9G",
                       " -o /home/jbotia/launch/",newprefix,
                       ".log -e /home/jbotia/launch/",newprefix,".e")
    cat("The command",command,"\n")
    system(command)
  }
}

trainDiscCluster_run = function(prefix,method,ncores,cvReps,gridSearch,imputeMissingData){
  ## Load dataset
  ## Check command arguments from user
  print("This is a discrete run\n")
  print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
  print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
  print(paste("RUNNNING CROSS VALIDATION FOR ", cvReps, " REPS", sep = ""))
  print(paste("GRID SEARCH FOR ", gridSearch, " ITERATIONS", sep = ""))
  print(paste("ANOTHER LEVEL OF IMPUTATION AND DATa TRANSFORMATION USING ", imputeMissingData, sep = ""))
  
  token = readRDS(paste(workPath,prefix,".train_processed.rds", sep = ""))
  train_processed = token$train_processed
  fitControl = token$fitControl
  
  model <- train(PHENO ~ ., data = train_processed,
                 method = method,
                 trControl = fitControl,
                 tuneLength = gridSearch,
                 metric = "ROC")
  
  traintokenfile = paste0(workPath,prefix,"_",method,".rds")
  saveRDS(model,traintokenfile)
  
}

trainContCluster_run = function(prefix,method,ncores,cvReps,gridSearch,imputeMissingData){
  
  print("This is a continuous run\n")
  ## Check command arguments from user
  print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
  print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
  print(paste("RUNNNING CROSS VALIDATION FOR ", cvReps, " REPS", sep = ""))
  print(paste("GRID SEARCH FOR ", gridSearch, " ITERATIONS", sep = ""))
  print(paste("ANOTHER LEVEL OF IMPUTATION AND DATa TRANSFORMATION USING ", imputeMissingData, sep = ""))
  
  
  token = readRDS(paste(workPath,prefix,".train_processed.rds", sep = ""))
  train_processed = token$train_processed
  fitControl = token$fitControl
  
  model <- train(PHENO ~ ., data = train_processed,
                 method = method,
                 trControl = fitControl,
                 tuneLength = gridSearch,
                 metric = "Rsquared", 
                 maximize = TRUE)
  
  traintokenfile = paste0(workPath,prefix,"_",method,".rds")
  saveRDS(model,traintokenfile)
}


trainCluster_resume = function(prefix,trainSpeed,outcome=c("cont","disc"),fromAtomic=F)
{
  #sink(file = paste(prefix, "_continuousTraining.Rout", sep = ""))
  ##Juan's add
  options(bitmapType='cairo')
  
  if(!fromAtomic)
    train_processed = readRDS(paste(workPath,prefix,".train_processed.rds", sep = ""))$train_processed
  
  cat("Resuming ",prefix,"after the cluster run with speed",trainSpeed,"\n")
  methods = models[[trainSpeed]]
  modelsRan = NULL
  for(method in methods){
    if(fromAtomic){
      #g-CALLS_B_Train-p-pheno_BTrain-c-covs_BTrain-a-NA_xgbTree_bestModel.RData
      filein = paste0(workPath,prefix,"_",method,"_bestModel.RData")
      if(file.exists(filein)){
        load(filein)
        modelsRan[[method]] =  bestModel
        cat("Just readed ",filein,"\n")
      }else
        cat("Model Atomic file",filein,"for method",method," is missing\n")  
      
    }else{
      
      filein = paste0(workPath,prefix,"_",method,".rds")
      if(file.exists(filein)){
        modelsRan[[method]] =  readRDS(filein)
        cat("Just readed ",filein,"\n")
      }
      
      else
        cat("Model file",filein,"for method",method," is missing\n")
    }
  }
  if(!is.null(modelsRan)){
    ## now compare best models
    sink(file = paste(workPath,prefix,"_methodPerformance.tab",sep =""), type = c("output"))
    methodComparisons <- resamples(modelsRan)
    print(summary(methodComparisons))
    sink()
    sink(file = paste(workPath,prefix,"_methodTimings.tab",sep =""), type = c("output"))
    print(methodComparisons$timings)
    sink()
    
    if(outcome == "cont"){
      cat("Processing continuous stuff\n")
      
      ## pick best model from model compare then output plots in this case, its picked via ROC, maximizing the mean AUC across resamplings
      evalMetric <- as.matrix(methodComparisons, metric = methodComparisons$metric[3]) # default metric here is R2
      meanEvalMetric <- as.data.frame(colMeans(evalMetric, na.rm = T))
      meanEvalMetric$method <- rownames(meanEvalMetric)
      names(meanEvalMetric)[1] <- "meanR2s" 
      bestEvalMetric <- subset(meanEvalMetric, meanR2s == max(meanEvalMetric$meanR2s))
      bestAlgorithm <- paste(bestEvalMetric[1,2])
      write.table(bestAlgorithm, file = paste(workPath,prefix,"_bestModel.algorithm",sep = ""), quote = F, row.names = F, col.names = F) # exports "method" option for the best algorithm
      bestModel <- modelsRan[[bestAlgorithm]]
      save(bestModel, file = paste(workPath,prefix,"_bestModel.RData",sep = ""))
      varImpList <- varImp(bestModel, scale = F) # here we get the importance matrix for the best model unscaled
      varImpTable <- as.matrix(varImpList$importance)
      write.table(varImpTable, file = paste(workPath,prefix,"_varImp.tab",sep =""), quote = F, sep = "\t", col.names = F)
      train_processed$predicted <- predict(bestModel, train_processed)
      trained <- train_processed[,c("PHENO","predicted")]
      train <- fread(paste(workPath,prefix,".dataForML", sep = ""), header = T)
      trained$ID <- train$ID
      write.table(trained, file = paste(workPath,prefix,"_trainingSetPredictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
      meanDiff <- format(mean(abs(trained$predicted - trained$PHENO)), digits = 3, scientific = T)
      regPlot <- ggplot(trained, aes(x=PHENO, y=predicted)) + geom_point(shape=1) + geom_smooth(method=lm, se=T) + 
        ggtitle(paste("mean abs(observed-predicted) = ", meanDiff,sep = "")) + xlab("Observed") + ylab("Predicted") + theme_bw()
      ggsave(plot = regPlot, filename = paste(workPath,prefix,"_plotRegs.png",sep =""), width = 8, height = 8, units = "in", dpi = 300)
      
    }else{
      cat("Processing discrete stuff\n")
      ## pick best model from model compare then output plots in this case, its picked via ROC, 
      # maximizing the mean AUC across resamplings
      ROCs <- as.matrix(methodComparisons, metric = methodComparisons$metric[1])
      meanROCs <- as.data.frame(colMeans(ROCs, na.rm = T))
      meanROCs$method <- rownames(meanROCs)
      names(meanROCs)[1] <- "meanROC" 
      bestFromROC <- subset(meanROCs, meanROC == max(meanROCs$meanROC))
      bestAlgorithm <- bestFromROC[1,2]
      write.table(bestAlgorithm, file = paste(workPath,prefix,"_bestModel.algorithm",sep = ""), quote = F, row.names = F, col.names = F) # exports "method" option for the best algorithm
      bestModel <- modelsRan[[bestAlgorithm]]
      save(bestModel, file = paste(workPath,prefix,"_bestModel.RData",sep = ""))
      
      if(!fromAtomic){
        train_processed$predicted <- predict(bestModel, train_processed)
        train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
        train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
        train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
        trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
        
        train <- fread(paste(workPath,prefix,".dataForML", sep = ""), header = T)
        trained$ID <- train$ID
        write.table(trained, file = paste(workPath,prefix,"_trainingSetPredictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
        overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
        ggsave(plot = overlayedRocs, filename = paste(workPath,prefix,"_plotRoc.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
        densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
        ggsave(plot = densPlot, filename = paste(workPath,prefix,"_plotDensity.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
        overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
        ggsave(plot = overlayedRocs, filename = paste(workPath,prefix,"_plotRocNoCI.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
        
        varImpList <- varImp(bestModel, scale = F) # here we get the importance matrix for the best model unscaled
        varImpTable <- as.matrix(varImpList$importance)
        write.table(varImpTable, file = paste(workPath,prefix,"_varImp.tab",sep =""), quote = F, sep = "\t", col.names = F)
        
        confMat <- confusionMatrix(data = as.factor(trained$predicted), reference = as.factor(trained$PHENO), positive = "DISEASE")
        sink(file = paste(workPath,prefix,"_confMat.txt",sep =""), type = c("output"))
        print(confMat)
        sink()
      }
      
      
    }
    ### sweep the floor, turn everything off and shut the door behind you
  }
}


trainCluster_variantScale = function(prefix,gwas,geno){
  library(data.table)
  
  #sink(file = paste(workPath,prefix, "_alleleDosageScaling.Rout", sep = ""))
  
  ## now read in the data
  cat("Reading ",paste(workPath,geno, ".bim", sep = ""),"\n")
  mapFile <- fread(file = paste(workPath,geno, ".bim", sep = ""))
  cat("Reading ",paste(workPath,prefix, ".temp.snpsToPull2", sep = ""),"\n")
  snpList <- fread(file = paste(workPath,prefix, ".temp.snpsToPull2", sep = ""))
  cat("Reading ",paste0(workPath,gwas),"\n")
  gwasResults <- fread(file = paste0(workPath,gwas))
  cat("Reading ",paste(workPath,prefix, ".reduced_genos.raw", sep = ""),"\n")
  genoDoses <- fread(file = paste(workPath,prefix, ".reduced_genos.raw", sep = ""))
  cat("Done\n")
  ## now make some tweaks to the GWAS
  gwasResults$mafWeight <- ifelse(gwasResults$freq < 0.5, gwasResults$b, -1*gwasResults$b)
  cat("GWAS modified\n")
  print(head(gwasResults))
  
  ## build the index file
  mapReduced <- mapFile[,c("V2","V5")]
  names(mapReduced) <- c("SNP","minorAllele")
  snpsReduced <- snpList[,c("SNP","CHR","BP","P")]
  gwasReduced <- gwasResults[,c("SNP","mafWeight")]
  cat("Merging\n")
  varIndexTemp <-merge(mapReduced, snpsReduced, by = "SNP")
  print(head(varIndexTemp))
  cat("Done\n")
  varIndex <- merge(varIndexTemp, gwasReduced, by = "SNP")
  print(head(varIndex))
  cat("Done\n")
  fwrite(varIndex,file = paste(workPath,prefix, "variantWeightings", sep = "."), quote = F, sep = "\t", row.names = F, na = NA)
  varIndex$rawSnpName <- paste(varIndex$SNP, varIndex$minorAllele, sep = "_")
  
  ## now recode the *.raw file with new weights for minor alleles
  for (i in 1:length(varIndex$rawSnpName)) 
  {
    thisVar <- varIndex$rawSnpName[i]
    thisVarWeight <- varIndex$mafWeight[i]
    thisVarWeighted <- genoDoses[[thisVar]]*thisVarWeight
    genoDoses[[thisVar]] <- thisVarWeighted
  }
  
  ## here we just output the weighted file over the old one, not the best idea but...
  fwrite(genoDoses, file = paste(workPath,prefix, ".reduced_genos.raw", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
  
  ## shut'em down
  #sink()
}


#Let us check headers
trainCluster_checkVariantNames = function(testprefix,oldprefix){
  
  traindata = paste0(workPath,oldprefix,".dataForML")
  testdata = paste0(workPath,testprefix,".dataForML")
  
  cat("Checking possible change of main allele between train ",traindata,
      " and test data ",testdata,"\n")
  train = fread(traindata, header = T)
  test = fread(testdata,header=T)
  snps = grep(":",colnames(train))
  snps = colnames(train)[snps]
  sentinel = F
  for(snp in snps){
    if(!(snp %in% colnames(test))){
      cat(snp," from traning data is not at test data\n")
      thesplit = str_split(snp,"_")
      commonpart = thesplit[[1]][[1]]
      letter = thesplit[[1]][[2]]
      testpos = grep(commonpart,colnames(test))
      wrongsnp = colnames(test)[testpos]
      test[,testpos] = 2 - test[,..testpos]
      
      cat("Converting ",wrongsnp," into ",paste0(commonpart,"_",letter),"\n")
      colnames(test)[testpos] = paste0(commonpart,"_",letter)
      sentinel = T
    }
  }
  if(sentinel){
    cat("Saving ",testdata," again to disk\n")
    fwrite(test, file = testdata, quote = F, sep = "\t", row.names = F, na = NA)  
  }
  else
    cat("No need to change any variant name, identical column nanes for test/train data\n")
  
}


trainCluster_validate = function(geno,
                                 pheno,
                                 cov,
                                 addit="NA",
                                 outcome,
                                 oldprefix,
                                 useAllModels=F,
                                 imputeMissingData="median",
                                 trainSpeed="ALL"){
  
  trainCluster_merge(geno,pheno,cov,addit,oldprefix)
  testprefix <- paste("g",geno,"p",pheno,"c",cov,"a",addit, sep = "-")
  
  ##Juan's add
  options(bitmapType='cairo')
  print(paste("DATA PREEFIX file set as ", testprefix, sep = ""))
  print(paste("ANOTHER LEVEL OF IMPUTATION AND DATA TRANSFORMATION USING ", imputeMissingData, sep = ""))
  
  ## Load additional packages
  packageList <- c("caret","ggplot2","data.table","rBayesianOptimization","plotROC")
  lapply(packageList, library, character.only = TRUE)
  
  #Let us check headers
  trainCluster_checkVariantNames(testprefix,oldprefix)
  
  ## Load dataset
  train <- fread(paste(workPath,testprefix,".dataForML", sep = ""), header = T)
  
  
  if(outcome == "disc"){
    sink(file = paste(workPath,testprefix, "_discreteValidation.Rout", sep = ""), type = c("output"))
    ### set outcome as a factor, check missingness, then impute missing data and scale
    train$PHENO[train$PHENO == 2] <- "DISEASE"
    train$PHENO[train$PHENO == 1] <- "CONTROL"
    ID <- train$ID
    train[,c("ID") := NULL]
    preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
    train_processed <- predict(preProcValues, train) # here we make the preprocessed values
    
    if(!useAllModels){
      m = colnames(read.delim(paste0(workPath,oldprefix,"_bestModel.algorithm"),stringsAsFactors=F))[1]
      cat("The best model is ",m,'\n')
      ## find out what the best model from earlier tune and load
      oldname = paste0(workPath,oldprefix,"_bestModel.RData")
      newname = paste0(workPath,m,"_bestModel.RData")
      if(file.exists(newname) & !file.exists(oldname)){
        cat("WARNING: File ", newname," exists already\n")
      }else{
        cat("Changing name of model from ",oldname," to ",newname,"\n")
        file.copy(from=oldname,to=newname,overwrite=T)
      }
      load(newname) # this loads in "bestModel"
      ## now summarize and export
      train_processed$predicted <- predict(bestModel, train_processed)
      train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
      train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
      train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
      trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
      trained$ID <- ID
      write.table(trained, file = paste(workPath,testprefix,"_validation_predictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
      overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
      ggsave(plot = overlayedRocs, filename = paste(workPath,testprefix,"_validation_plotRoc.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
      densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
      ggsave(plot = densPlot, filename = paste(workPath,testprefix,"_validation_plotDensity.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
      overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
      ggsave(plot = overlayedRocs, filename = paste(workPath,testprefix,"_validation_plotRocNoCI.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
      confMat <- confusionMatrix(data = as.factor(trained$predicted), reference = as.factor(trained$PHENO), positive = "DISEASE")
      sink(file = paste(workPath,testprefix,"_validation_confMat.txt",sep =""), type = c("output"))
      print(confMat)
      sink()
    }else{ 
      #We will use all models
      localmodels = 
        for(localmodel in models[[trainSpeed]]){
          filein = paste0(workPath,oldprefix,"_",localmodel,"_bestModel.RData")
          
          if(file.exists(filein)){
            cat("Assessing ",filein,"\n")
            load(filein)
            ## now summarize and export
            train_processed$predicted <- predict(bestModel, train_processed)
            train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
            train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
            train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
            trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
            trained$ID <- ID
            write.table(trained, file = paste(workPath,testprefix,"_",localmodel,"_validation_predictions.tab",sep =""), 
                        quote = F, sep = "\t", row.names = F)
            overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + 
              geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
            ggsave(plot = overlayedRocs, filename = paste(workPath,testprefix,"_",localmodel,"_validation_plotRoc.png",sep =""), 
                   width = 8, height = 5, units = "in", dpi = 300)
            densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
            ggsave(plot = densPlot, filename = paste(workPath,testprefix,"_",localmodel,"_validation_plotDensity.png",sep =""), 
                   width = 8, height = 5, units = "in", dpi = 300)
            overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + 
              style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
            ggsave(plot = overlayedRocs, filename = paste(workPath,testprefix,"_",localmodel,"_validation_plotRocNoCI.png",sep =""), 
                   width = 8, height = 5, units = "in", dpi = 300)
            confMat <- confusionMatrix(data = as.factor(trained$predicted), 
                                       reference = as.factor(trained$PHENO), positive = "DISEASE")
            sink(file = paste(workPath,testprefix,"_",localmodel,"_validation_confMat.txt",sep =""), type = c("output"))
            print(confMat)
            sink()  
          }else{
            cat("File",filein,"not found, skipping the model\n")
          }
          
          
        }
      
    }
    sink()
    
  }else{
    sink(file = paste(workPath,testprefix, "_continuousValdiation.Rout", sep = ""), type = c("output"))
    
    
    ## Load additional packages
    packageList <- c("caret","ggplot2","data.table","rBayesianOptimization","plotROC")
    lapply(packageList, library, character.only = TRUE)
    
    ## Load dataset
    train <- fread(paste(workPath,testprefix,".dataForML", sep = ""), header = T)
    
    ## impute missing data and scale
    ID <- train$ID
    train[,c("ID") := NULL]
    preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
    train_processed <- predict(preProcValues, train) # here we make the preprocessed values
    m = read.delim(paste0(workPath,oldprefix,"_bestModel.algorithm"),stringsAsFactors=F)
    ## find out what the best model from earlier tune and load
    oldname = paste0(workPath,oldprefix,"_bestModel.RData")
    newname = paste0(workPath,m,"_bestModel.RData")
    if(file.exists(newname) & !file.exists(oldname)){
      cat("WARNING: File ", newname," exists already\n")
    }else{
      cat("Changing name of model from ",oldname," to ",newname,"\n")
      file.copy(from=oldname,to=newname,overwrite=T)
    }
    load(newname) # this loads in "bestModel"
    
    ## now summarize and export
    train_processed$predicted <- predict(bestModel, train_processed)
    trained <- train_processed[,c("PHENO","predicted")]
    trained$ID <- ID
    write.table(trained, file = paste(workPath,testprefix,"_validation_predictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
    meanDiff <- format(mean(abs(trained$predicted - trained$PHENO)), digits = 3, scientific = T)
    regPlot <- ggplot(trained, aes(x=PHENO, y=predicted)) + geom_point(shape=1) + geom_smooth(method=lm, se=T) + ggtitle(paste("mean abs(observed-predicted) = ", meanDiff,sep = "")) + xlab("Observed") + ylab("Predicted") + theme_bw()
    ggsave(plot = regPlot, filename = paste(workPath,testprefix,"_validation_plotRegs.png",sep =""), width = 8, height = 8, units = "in", dpi = 300)
    sink()
  }
}

trainCluster_merge = function(geno,pheno,cov,addit,previous,workPath){
  
  prefix <- paste("g",geno,"p",pheno,"c",cov,"a",addit, sep = "-")
  
  command = paste0("plink --bfile ",workPath,"/",geno," --keep ",workPath,"/",cov,".cov" ,
                   " --extract ",workPath,"/",previous,
                   ".reduced_genos_snpList --recode A --out ",workPath,"/", prefix,".reduced_genos")
  
  cat("Running command ",command,"\n")
  system(command)
  
  ## Merges in R start by the commands below acessing additional scripts
  #Rscript $pathToGenoML/otherPackages/mergeForGenoML.R $geno $pheno $cov $addit
  ## if phenoScale = CNT
  #Rscript $pathToGenoML/otherPackages/validateCont.R $prefix $cores $imputeMissingData $bestModelName
  
  print(prefix)
  #sink(file = paste(prefix, "_mergeInput.Rout", sep = ""), type = c("output"))
  print(paste("GENO PREEFIX file set as ", geno, sep = ""))
  print(paste("PHENO PREEFIX file set as ", pheno, sep = ""))
  print(paste("COV PREEFIX file set as ", cov, sep = "")) # if not specified load NA
  print(paste("ADDIT PREEFIX file set as ", addit, sep = "")) # if not specified load NA
  print(paste("ALL RESULTS TAGGED WITH PREFIX -> ", prefix, sep = ""))
  
  ## load packages
  library("data.table")
  ### now decide what to merge
  genoPheno <- 2
  addCov <- ifelse(cov == "NA", 0, 1)
  addAddit <- ifelse(addit == "NA", 0, 1)
  nFiles <- genoPheno + addCov + addAddit # this specifies the number of files to merge
  print(paste("MERGING ", nFiles," FILES", sep = ""))
  genotypeInput <- paste(workPath,prefix, ".reduced_genos.raw", sep = "")
  phenoInput <- paste(workPath,pheno, ".pheno", sep = "")
  covInput <- paste(workPath,cov, ".cov", sep = "")
  additInput <- paste(workPath,addit, ".addit", sep = "")
  
  ### run for only geno and pheno data, ie nFiles = 2
  if(nFiles == 2)
  {
    genosRaw <- fread(genotypeInput)
    phenoRaw <- fread(phenoInput)
    genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
    phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
    phenoRaw[, c("FID","IID") := NULL]
    genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
    temp <- merge(phenoRaw, genosRaw, by = "ID")
    names(temp)[2] <- "PHENO"
    fwrite(temp, file = paste(workPath,prefix,".dataForML", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
    print("First 100 variable names for your file below, the rest are likely just more genotypes...")
    print(head(names(temp), n = 100))
    print("... and the last 100 variable names for your file below...")
    print(tail(names(temp), n = 100))
    print(paste("Your final file has ", length(temp$ID)," samples, and ", length(names(temp))," predictors for analysis", sep = ""))	
  }
  
  ### run for studies that have all geno, pheno, cov and addit data availible, ie nFiles = 4
  if(nFiles == 4)
  {
    genosRaw <- fread(genotypeInput)
    phenoRaw <- fread(phenoInput)
    covRaw <- fread(covInput)
    additRaw <- fread(additInput)
    genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
    phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
    covRaw$ID <- paste(covRaw$FID, covRaw$IID, sep = "_")
    additRaw$ID <- paste(additRaw$FID, additRaw$IID, sep = "_")
    phenoRaw[, c("FID","IID") := NULL]
    genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
    covRaw[, c("FID","IID") := NULL]
    additRaw[, c("FID","IID") := NULL]
    temp1 <- merge(phenoRaw, covRaw, by = "ID")
    temp2 <- merge(temp1, additRaw, by = "ID")
    temp3 <- merge(temp2, genosRaw, by = "ID")
    names(temp3)[2] <- "PHENO"
    fwrite(temp3, file = paste(workPath,prefix,".dataForML", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
    print("First 100 variable names for your file below, the rest are likely just more genotypes...")
    print(head(names(temp3), n = 100))
    print("... and the last 100 variable names for your file below...")
    print(tail(names(temp3), n = 100))
    print(paste("Your final file has ", length(temp3$ID)," samples, and ", length(names(temp3))," predictors for analysis", sep = ""))	
  }
  
  ### run for studies that have all geno, pheno and cov data availible (addit is missing), ie nFiles = 3
  if(nFiles == 3 & addit == "NA")
  {
    genosRaw <- fread(genotypeInput)
    phenoRaw <- fread(phenoInput)
    otherRaw <- fread(covInput)
    genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
    phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
    otherRaw$ID <- paste(otherRaw$FID, otherRaw$IID, sep = "_")
    phenoRaw[, c("FID","IID") := NULL]
    genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
    otherRaw[, c("FID","IID") := NULL]
    temp1 <- merge(phenoRaw, otherRaw, by = "ID")
    temp2 <- merge(temp1, genosRaw, by = "ID")
    names(temp2)[2] <- "PHENO"
    fwrite(temp2, file = paste(workPath,prefix,".dataForML", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
    print("First 100 variable names for your file below, the rest are likely just more genotypes...")
    print(head(names(temp2), n = 100))
    print("... and the last 100 variable names for your file below...")
    print(tail(names(temp2), n = 100))
    print(paste("Your final file has ", length(temp2$ID)," samples, and ", length(names(temp2))," predictors for analysis", sep = ""))	
  }
  
  ### run for studies that have all geno, pheno and addit data availible (cov is missing), ie nFiles = 3
  if(nFiles == 3 & cov == "NA")
  {
    genosRaw <- fread(genotypeInput)
    phenoRaw <- fread(phenoInput)
    otherRaw <- fread(additInput)
    genosRaw$ID <- paste(genosRaw$FID, genosRaw$IID, sep = "_")
    phenoRaw$ID <- paste(phenoRaw$FID, phenoRaw$IID, sep = "_")
    otherRaw$ID <- paste(otherRaw$FID, otherRaw$IID, sep = "_")
    phenoRaw[, c("FID","IID") := NULL]
    genosRaw[, c("FID","IID","MAT","PAT","SEX","PHENOTYPE") := NULL]
    otherRaw[, c("FID","IID") := NULL]
    temp1 <- merge(phenoRaw, otherRaw, by = "ID")
    temp2 <- merge(temp1, genosRaw, by = "ID")
    names(temp2)[2] <- "PHENO"
    fwrite(temp2, file = paste(workPath,prefix,".dataForML", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)
    print("First 100 variable names for your file below, the rest are likely just more genotypes...")
    print(head(names(temp2), n = 100))
    print("... and the last 100 variable names for your file below...")
    print(tail(names(temp2), n = 100))
    print(paste("Your final file has ", length(temp2$ID)," samples, and ", length(names(temp2))," predictors for analysis", sep = ""))	
  }
  
  ### save the log file
  sink()
}

## Parse args and start logging
args <- commandArgs()
print(args)
prefix <- args[6]
sink(file = paste(prefix, "_continuousValdiation.Rout", sep = ""), type = c("output"))
ncores <- as.numeric(args[7])
imputeMissingData <- args[8]
bestModelName <- args[9]

## Check command arguments from user
print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
print(paste("ANOTHER LEVEL OF IMPUTATION AND DATA TRANSFORMATION USING ", imputeMissingData, sep = ""))
print(paste("BEST MODEL FROM STEP 2/3 file set as ", bestModelName, sep = ""))

## Load additional packages
packageList <- c("caret","ggplot2","data.table","rBayesianOptimization","plotROC")
lapply(packageList, library, character.only = TRUE)

## Load dataset
train <- fread(paste(prefix,".dataForML", sep = ""), header = T)

## impute missing data and scale
ID <- train$ID
train[,c("ID") := NULL]
preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
train_processed <- predict(preProcValues, train) # here we make the preprocessed values

## find out what the best model from earlier tune and load
loadingModel <- paste(bestModelName, "_bestModel.RData", sep = "")
load(loadingModel) # this loads in "bestModel"

## now summarize and export
train_processed$predicted <- predict(bestModel, train_processed)
trained <- train_processed[,c("PHENO","predicted")]
trained$ID <- ID
write.table(trained, file = paste(prefix,"_validation_predictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
meanDiff <- format(mean(abs(trained$predicted - trained$PHENO)), digits = 3, scientific = T)
regPlot <- ggplot(trained, aes(x=PHENO, y=predicted)) + geom_point(shape=1) + geom_smooth(method=lm, se=T) + ggtitle(paste("mean abs(observed-predicted) = ", meanDiff,sep = "")) + xlab("Observed") + ylab("Predicted") + theme_bw()
ggsave(plot = regPlot, filename = paste(prefix,"_validation_plotRegs.png",sep =""), width = 8, height = 8, units = "in", dpi = 300)
sink()

### sweep the floor, turn everything off and shut the door behind you
q("no")

## run with ... 
## Rscript $pathToGenoML/otherPackages/filterSblup.R $prefix $gwas $geno

## Parse args and start logging
library(data.table)
args <- commandArgs()
print(args)
prefix <- args[6]
gwas <- args[7]
geno <- args[8]
sink(file = paste(prefix, "_alleleDosageScaling.Rout", sep = ""))

## now read in the data
mapFile <- fread(file = paste(geno, ".bim", sep = ""))
snpList <- fread(file = paste(prefix, ".temp.snpsToPull2", sep = ""))
gwasResults <- fread(file = gwas)
genoDoses <- fread(file = paste(prefix, ".reduced_genos.raw", sep = ""))

## now make some tweaks to the GWAS
gwasResults$mafWeight <- ifelse(gwasResults$freq < 0.5, gwasResults$b, -1*gwasResults$b)

## build the index file
mapReduced <- mapFile[,c("V2","V5")]
names(mapReduced) <- c("SNP","minorAllele")
snpsReduced <- snpList[,c("SNP","CHR","BP","P")]
gwasReduced <- gwasResults[,c("SNP","mafWeight")]
varIndexTemp <-merge(mapReduced, snpsReduced, by = "SNP")
varIndex <- merge(varIndexTemp, gwasReduced, by = "SNP")
fwrite(varIndex, file = paste(prefix, "variantWeightings", sep = "."), quote = F, sep = "\t", row.names = F, na = NA)
varIndex$rawSnpName <- paste(varIndex$SNP, varIndex$minorAllele, sep = "_")

## now recode the *.raw file with new weights for minor alleles
for (i in 1:length(varIndex$rawSnpName)) 
{
  thisVar <- varIndex$rawSnpName[i]
  thisVarWeight <- varIndex$mafWeight[i]
  thisVarWeighted <- genoDoses[[thisVar]]*thisVarWeight
  genoDoses[[thisVar]] <- thisVarWeighted
}

## here we just output the weighted file over the old one, not the best idea but...
fwrite(genoDoses, file = paste(prefix, ".reduced_genos.raw", sep = ""), quote = F, sep = "\t", row.names = F, na = NA)

## shut'em down
sink()
q("no")

## Parse args and start logging
args <- commandArgs()
print(args)
prefix <- args[6]
sink(file = paste(prefix, "_continuousTraining.Rout", sep = ""))
ncores <- as.numeric(args[7])
trainSpeed <- args[8]
cvReps <- as.numeric(args[9])
gridSearch <- as.numeric(args[10])
imputeMissingData <- args[11]

## Check command arguments from user
print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
print(paste("TRAINING SPEED is ", trainSpeed, sep = ""))
print(paste("RUNNNING CROSS VALIDATION FOR ", cvReps, " REPS", sep = ""))
print(paste("GRID SEARCH FOR ", gridSearch, " ITERATIONS", sep = ""))
print(paste("ANOTHER LEVEL OF IMPUTATION AND DATa TRANSFORMATION USING ", imputeMissingData, sep = ""))

## Load additional packages
packageList <- c("caret","ggplot2","data.table","rBayesianOptimization","plotROC")
lapply(packageList, library, character.only = TRUE)

## Load dataset
train <- fread(paste(prefix,".dataForML", sep = ""), header = T)

## check missingness, then impute missing data and scale
sum(is.na(train))
ID <- train$ID
train[,c("ID") := NULL]
preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
train_processed <- predict(preProcValues, train) # here we make the preprocessed values

## a bit more data munging that doesn't matter most of the time, we'll be ignoring this for now due to prefiltering but worth including in your considerations
nzv <- nearZeroVar(train_processed[,-1], saveMetrics= TRUE) # checks for near non zero and flags
fwrite(nzv, paste(prefix,".nzv", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the near and nonzero predictors
if(length(names(train)) < 1001) # if more than 1000 variables this step is skipped for memeory and speed reasons
{
	descrCor <- cor(train_processed[,-1]) # builds correlation matrix
	highlyCorDescr <- findCorrelation(descrCor, cutoff = .75, names = T, verbose = T) # checks correlated features and summarizes, can write function in later to drop
	write.table(highlyCorDescr, paste(prefix,".highCor", sep = ""), quote = F, sep = "\t", row.names = F, col.names = F) # this exports globally correlated predictors
}
## the two files above might want to be used to exclude some data prior to re-analysis
#comboInfo <- findLinearCombos(train_processed) # finds biased linear combinations
#fwrite(comboInfo, paste(prefix,".comboInfo", sep = ""), quote = F, sep = "\t", row.names = F, na = NA) # this exports the possible linear combinations in the dataset that may be problematic and should be examined

### to begin tune first begin parallel parameters 
library("parallel")
library("doParallel")
cluster <- makeCluster(ncores) # convention to leave 1 core for OS
registerDoParallel(cluster)
set.seed(123) # makes generally reproducible grid searches from random or bayes tunes at paramter optimization

## here we set the cross validation
fitControl <- trainControl(method = "cv",
            number = cvReps,
            search = "random")

## now we start making models if the trainSpeed is ALL
if(trainSpeed == "ALL")
{
	
	glm.model <- train(PHENO ~ ., data = train_processed,
	       method = "glm",
	       trControl = fitControl,
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	bayesglm.model <- train(PHENO ~ ., data = train_processed,
	       method = "bayesglm",
	       trControl = fitControl,
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbTree.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbTree", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbLinear.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbLinear", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbDART.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbDART", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	rf.model <- train(PHENO ~ ., data = train_processed, 
	       method = "rf", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       ## Specify which metric to optimize
	       metric = "Rsquared", maximize = TRUE)
	
	ridge.model <- train(PHENO ~ ., data = train_processed, 
	       method = "ridge", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	evtree.model <- train(PHENO ~ ., data = train_processed, 
	       method = "evtree", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	glmnet.model <- train(PHENO ~ ., data = train_processed, 
	       method = "glmnet", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       ## Specify which metric to optimize
	       metric = "Rsquared", maximize = TRUE)
	
	svmRadial.model <- train(PHENO ~ ., data = train_processed, 
	       method = "svmRadial", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	earth.model <- train(PHENO ~ ., data = train_processed, 
	       method = "earth", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	lasso.model <- train(PHENO ~ ., data = train_processed, 
	       method = "lasso", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	modelsRan <- list(glm=glm.model, bayesglm=bayesglm.model, xgbTree=xgbTree.model, xgbDART=xgbDART.model, xgbLinear=xgbLinear.model, rf=rf.model, ridge=ridge.model, evtree=evtree.model, glmnet=glmnet.model, svmRadial=svmRadial.model, earth=earth.model, lasso=lasso.model)
}

## now we start making models if the trainSpeed is FAST
if(trainSpeed == "FAST")
{
	
	glm.model <- train(PHENO ~ ., data = train_processed,
	       method = "glm",
	       trControl = fitControl,
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbTree.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbTree", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbLinear.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbLinear", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbDART.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbDART", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
				
	glmnet.model <- train(PHENO ~ ., data = train_processed, 
	       method = "glmnet", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	svmRadial.model <- train(PHENO ~ ., data = train_processed, 
	       method = "svmRadial", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	earth.model <- train(PHENO ~ ., data = train_processed, 
	       method = "earth", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	lasso.model <- train(PHENO ~ ., data = train_processed, 
	       method = "lasso", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	modelsRan <- list(glm=glm.model, xgbTree=xgbTree.model, xgbDART=xgbDART.model, xgbLinear=xgbLinear.model, glmnet=glmnet.model, svmRadial=svmRadial.model, earth=earth.model, lasso=lasso.model)
}

## now we start making models if the trainSpeed is FURIOUS
if(trainSpeed == "FURIOUS")
{
	
	glm.model <- train(PHENO ~ ., data = train_processed,
	       method = "glm",
	       trControl = fitControl,
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbLinear.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbLinear", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	glmnet.model <- train(PHENO ~ ., data = train_processed, 
	       method = "glmnet", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       ## Specify which metric to optimize
	       metric = "Rsquared", maximize = TRUE)
	
	svmRadial.model <- train(PHENO ~ ., data = train_processed, 
	       method = "svmRadial", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	earth.model <- train(PHENO ~ ., data = train_processed, 
	       method = "earth", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	lasso.model <- train(PHENO ~ ., data = train_processed, 
	       method = "lasso", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	modelsRan <- list(glm=glm.model, xgbLinear=xgbLinear.model, glmnet=glmnet.model, svmRadial=svmRadial.model, earth=earth.model, lasso=lasso.model)
}

## now we start making models if the trainSpeed is BOOSTED
if(trainSpeed == "BOOSTED")
{
	
	xgbTree.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbTree", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbLinear.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbLinear", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	xgbDART.model <- train(PHENO ~ ., data = train_processed, 
	       method = "xgbDART", 
	       trControl = fitControl, 
	       tuneLength = gridSearch,
	       metric = "Rsquared", maximize = TRUE)
	
	modelsRan <- list(xgbTree=xgbTree.model, xgbDART=xgbDART.model, xgbLinear=xgbLinear.model)
}

## shut down multicore
stopCluster(cluster)
registerDoSEQ()

## now compare best models
sink(file = paste(prefix,"_methodPerformance.tab",sep =""), type = c("output"))
methodComparisons <- resamples(modelsRan)
summary(methodComparisons)
sink()
sink(file = paste(prefix,"_methodTimings.tab",sep =""), type = c("output"))
methodComparisons$timings
sink()

## pick best model from model compare then output plots in this case, its picked via ROC, maximizing the mean AUC across resamplings
evalMetric <- as.matrix(methodComparisons, metric = methodComparisons$metric[3]) # default metric here is R2
meanEvalMetric <- as.data.frame(colMeans(evalMetric, na.rm = T))
meanEvalMetric$method <- rownames(meanEvalMetric)
names(meanEvalMetric)[1] <- "meanR2s" 
bestEvalMetric <- subset(meanEvalMetric, meanR2s == max(meanEvalMetric$meanR2s))
bestAlgorithm <- paste(bestEvalMetric[1,2])
write.table(bestAlgorithm, file = paste(prefix,"_bestModel.algorithm",sep = ""), quote = F, row.names = F, col.names = F) # exports "method" option for the best algorithm
bestModel <- get(paste(bestAlgorithm, ".model", sep = ""))
save(bestModel, file = paste(prefix,"_bestModel.RData",sep = ""))
varImpList <- varImp(bestModel, scale = F) # here we get the importance matrix for the best model unscaled
varImpTable <- as.matrix(varImpList$importance)
write.table(varImpTable, file = paste(prefix,"_varImp.tab",sep =""), quote = F, sep = "\t", col.names = F)
train_processed$predicted <- predict(bestModel, train_processed)
trained <- train_processed[,c("PHENO","predicted")]
trained$ID <- ID
write.table(trained, file = paste(prefix,"_trainingSetPredictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
meanDiff <- format(mean(abs(trained$predicted - trained$PHENO)), digits = 3, scientific = T)
regPlot <- ggplot(trained, aes(x=PHENO, y=predicted)) + geom_point(shape=1) + geom_smooth(method=lm, se=T) + ggtitle(paste("mean abs(observed-predicted) = ", meanDiff,sep = "")) + xlab("Observed") + ylab("Predicted") + theme_bw()
ggsave(plot = regPlot, filename = paste(prefix,"_plotRegs.png",sep =""), width = 8, height = 8, units = "in", dpi = 300)
sink()

### sweep the floor, turn everything off and shut the door behind you
q("no")

## Parse args and start logging
args <- commandArgs()
print(args)
prefix <- args[6]
sink(file = paste(prefix, "_discreteTuning.Rout", sep = ""), type = c("output"))
ncores <- as.numeric(args[7])
cvReps <- as.numeric(args[8])
gridSearch <- as.numeric(args[9])
imputeMissingData <- args[10]
bestModelName <- args[11]

## Check command arguments from user
print(paste("DATA PREEFIX file set as ", prefix, sep = ""))
print(paste("RUNNIN ON HOW MANY CORES ??? ", ncores, " cores, is that enough??? ", sep = ""))
print(paste("RUNNNING CROSS VALIDATION FOR ", cvReps, " REPS", sep = ""))
print(paste("GRID SEARCH FOR ", gridSearch, " ITERATIONS", sep = ""))
print(paste("ANOTHER LEVEL OF IMPUTATION AND DATA TRANSFORMATION USING ", imputeMissingData, sep = ""))
print(paste("BEST MODEL FROM STEP 2 file set as ", bestModelName, sep = ""))

## Load additional packages
packageList <- c("caret","ggplot2","data.table","rBayesianOptimization","plotROC")
lapply(packageList, library, character.only = TRUE)

## Load dataset
train <- fread(paste(prefix,".dataForML", sep = ""), header = T)

### set outcome as a factor, check missingness, then impute missing data and scale
train$PHENO[train$PHENO == 2] <- "DISEASE"
train$PHENO[train$PHENO == 1] <- "CONTROL"
ID <- train$ID
train[,c("ID") := NULL]
preProcValues <- preProcess(train[,-1], method = c(paste(imputeMissingData,"Impute", sep = ""))) # note here we pick impute method (KNN or median),  we can also exclude near zero variance predictors and correlated predictors
train_processed <- predict(preProcValues, train) # here we make the preprocessed values

## find out what the best model from earlier tune is
bestAlgorithmTemp <- read.table(paste(prefix,"_bestModel.algorithm",sep = ""))
bestAlgorithm <- as.character(bestAlgorithmTemp[1,1])

### to begin tune first begin parallel parameters 
library("parallel")
library("doParallel")
cluster <- makeCluster(ncores) # convention to leave 1 core for OS
registerDoParallel(cluster)
set.seed(123) # makes generally reproducible grid searches from random or bayes tunes at paramter optimization

## here we set the cross validation
fitControl <- trainControl(method = "repeatedcv",
                           number = cvReps,
                           classProbs = TRUE,
                           summaryFunction = twoClassSummary,
                           search = "random",
                           repeats = cvReps)

## now make the longer tuned model
bestModel <- train(PHENO ~ ., data = train_processed,
                   method = bestAlgorithm,
                   trControl = fitControl,
                   tuneLength = gridSearch,
                   metric = "ROC")

## shut down multicore
stopCluster(cluster)
registerDoSEQ()

## now summarize and export
save(bestModel, file = paste(prefix,"_tuned_bestModel.RData",sep = ""))
varImpList <- varImp(bestModel, scale = F) # here we get the importance matrix for the best model unscaled
varImpTable <- as.matrix(varImpList$importance)
write.table(varImpTable, file = paste(prefix,"_tuned_varImp.tab",sep =""), quote = F, sep = "\t", col.names = F)
train_processed$predicted <- predict(bestModel, train_processed)
train_processed$probDisease <- predict(bestModel, train_processed, type = "prob")[2]
train_processed$diseaseBinomial <- ifelse(train_processed$PHENO == "DISEASE", 1, 0)
train_processed$predictedBinomial <- ifelse(train_processed$predicted == "DISEASE", 1, 0)
trained <- train_processed[,c("PHENO","predicted","probDisease","diseaseBinomial","predictedBinomial")]
trained$ID <- ID
write.table(trained, file = paste(prefix,"_tuned_trainingSetPredictions.tab",sep =""), quote = F, sep = "\t", row.names = F)
overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + geom_rocci() + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
ggsave(plot = overlayedRocs, filename = paste(prefix,"_tuned_plotRoc.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
densPlot <- ggplot(trained, aes(probDisease, fill = PHENO, color = PHENO)) + geom_density(alpha = 0.5) + theme_bw()
ggsave(plot = densPlot, filename = paste(prefix,"_tuned_plotDensity.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
overlayedRocs <- ggplot(trained, aes(d = diseaseBinomial, m = probDisease)) + geom_roc(labels = FALSE) + style_roc(theme = theme_gray) + theme_bw() + scale_fill_brewer(palette="Spectral")
ggsave(plot = overlayedRocs, filename = paste(prefix,"_tuned_plotRocNoCI.png",sep =""), width = 8, height = 5, units = "in", dpi = 300)
confMat <- confusionMatrix(data = as.factor(trained$predicted), reference = as.factor(trained$PHENO), positive = "DISEASE")
sink(file = paste(prefix,"_tuned_confMat.txt",sep =""), type = c("output"))
confMat
sink()
sink()

### sweep the floor, turn everything off and shut the door behind you
q("no")

## run with ... 
## Rscript $pathToGenoML/otherPackages/checkPrs.R $prefix $pheno

library("data.table")
library("caret")
library("pROC")

args <- commandArgs()
print(args)
prefix <- args[6]
pheno <- args[7]
## testing
# prefix <- "g-banner.harmonized-p-banner.amyloid_disc-c-banner.PCs-a-banner.age_sex_e2_e4"
# pheno <- "banner.amyloid_disc"

prsInput <- paste(prefix, ".temp.best", sep = "")
prsFile <- fread(prsInput)
phenoInput <- paste(pheno, "", sep = "") #paste(pheno, ".pheno", sep = "")
phenoFile <- fread(phenoInput)
phenoFile$ID <- paste(phenoFile$FID, phenoFile$IID, sep = "_")
prsFile$ID <- paste(prsFile$FID, prsFile$IID, sep = "_")
data <- merge(phenoFile, prsFile, by = "ID")
minPheno <- min(data$PHENO)
maxPheno <- max(data$PHENO)
if(minPheno == 1 & maxPheno == 2)
{
	data$bin <- data$PHENO - 1
	outPut <- matrix(nrow = 3, ncol = 3)
	model <- glm(bin ~ PRS, data = data, family = "binomial"(link = "logit"))
	data$predicted <- predict(model, data, type = "response")
	rocAuc <- roc(response = data$bin, predictor =  data$predicted)
	outPut[1,1] <- auc(rocAuc)
	outPut[1,2] <- ci(rocAuc, of="auc")[1]
	outPut[1,3] <- ci(rocAuc, of="auc")[3]
	coords(rocAuc, "best")
	thresh <- coords(rocAuc, "best")[1]
	data$bin50 <- as.numeric(ifelse(data$predicted > 0.5, 1, 0))
	rocAuc <- roc(response = data$bin, predictor = data$bin50)
	outPut[2,1] <- auc(rocAuc)
	outPut[2,2] <- ci(rocAuc, of="auc")[1]
	outPut[2,3] <- ci(rocAuc, of="auc")[3]
	data$binBest <- as.numeric(ifelse(data$predicted > thresh, 1, 0))
	rocAuc <- roc(response = data$bin, predictor = data$binBest)
	outPut[3,1] <- auc(rocAuc)
	outPut[3,2] <- ci(rocAuc, of="auc")[1]
	outPut[3,3] <- ci(rocAuc, of="auc")[3]
	row.names(outPut) <- c("probability","partition_at_50percent","partition_at_best")
	write.table(outPut, file = paste(prefix, ".PRS_summary.txt", sep = ""), quote = F, sep = "\t", col.names = c("AUC","low_95_CI","high_95_CI"))
	## here is the confmat at best theshold
	confMat <- confusionMatrix(data = as.factor(data$binBest), reference = as.factor(data$bin), positive = "1")
	print(sink(file = paste(prefix,"_confMatAtBestThresh_PRS.txt",sep ="")))
	confMat
	sink()
}
if(minPheno != 1 & maxPheno != 2)
{
	model <- lm(PHENO ~ PRS, data = data)
	sink(file = paste(prefix, ".PRS_summary.txt", sep = ""))
	print(summary(model))
	sink()
}
q("no")

#!/usr/bin/env Rscript
# Here is the guide to this protentially long R code
# To go to each section, just search for the corresponding header as stated here
# The code structure are as follow
# The easiest way will be to use RStudio and go to the corresponding section by
# selecting it on the bottom left corner of the script console
#
# INSTALL_PACKAGE
# - Contains functions responsible for installing all required packages
#
# COMMAND_FUNC
# - Functions required for command line argument parsing
#
# COMMAD_BUILD
# - Building the command line parser using argparser
#
# CALL_PRSICE
# - call the cpp prsice
#
# PLOTTING
# - Here contains all the function for plotting
# - quantile_plot: plotting the quantile plots
# - run_plot: The function used for calling different plotting functions
#
# CALL PLOTTING FUNCTION
# - Process the input names and call the actual plotting function
#
# Environment stuff: This will allow us to locate the cpp file correctly
#
# For window users, the reason why PRSice doesn't work with window is due to
# area flagged with WINDOW PEOPLE. If you can go around that, then you can
# make PRSice work (though I have not debug PRSice executable in window)


# Remove annoying messages ------------------------------------------------
#options(error = quote({dump.frames(to.file=TRUE); q()}))
In_Regression <-
    DEC <-
    Coef <-
    CI.L <-
    CI.U <-
    Group <-
    Threshold <-
    R2 <-
    print.p <- R <- P <- value <- Phenotype <- Set <- PRS.R2 <- LCI <- UCI <- quant.ref <- NULL

# Help Messages --------------------------------------
help_message <-
"usage: Rscript PRSice.R [options] <-b base_file> <-t target_file> <--prsice prsice_location>\n
\nRequired:\n
    --prsice                Location of the PRSice binary\n
    --dir                   Location to install ggplot. Only require if ggplot\n
                            is not installed\n
\nBase File:\n
    --A1                    Column header containing allele 1 (effective allele)\n
                            Default: A1\n
    --A2                    Column header containing allele 2 (non-effective allele)\n
                            Default: A2\n
    --base          | -b    Base association file\n
    --beta                  Whether the test statistic is in the form of \n
                            BETA or OR. If set, test statistic is assume\n
                            to be in the form of BETA.\n
    --bp                    Column header containing the SNP coordinate\n
                            Default: BP\n
    --chr                   Column header containing the chromosome\n
                            Default: CHR\n
    --index                 If set, assume the INDEX instead of NAME  for\n
                            the corresponding columns are provided. Index\n
                            should be 0-based (start counting from 0)\n
    --info-base             Base INFO score filtering. Format should be\n
                            <Column name>,<Threshold>. SNPs with info \n
                            score less than <Threshold> will be ignored\n
                            Column name default: INFO\n
                            Threshold default: 0.9\n
    --maf-base              Base MAF filtering. Format should be\n
                            <Column name>,<Threshold>. SNPs with maf\n
                            less than <Threshold> will be ignored. An\n
                            additional column can also be added (e.g.\n
                            also filter MAF for cases), using the\n
                            following format:\n
                            <Column name>,<Threshold>:<Column name>,<Threshold>\n
    --no-default            Remove all default options. If set, PRSice\n
                            will not set any default column name and you\n
                            will have to ensure all required columns are\n
                            provided. (--snp, --stat, --A1, --pvalue)\n
    --pvalue        | -p    Column header containing the p-value\n
                            Default: P\n
    --se                    Column header containing the standard error\n
                            Default: SE\n
    --snp                   Column header containing the SNP ID\n
                            Default: SNP\n
    --stat                  Column header containing the summary statistic\n
                            If --beta is set, default as BETA. Otherwise,\n
                            will search for OR or BETA from the header\n
                            of the base file\n
\nTarget File:\n
    --binary-target         Indicate whether the target phenotype\n
                            is binary or not. Either T or F should be\n
                            provided where T represent a binary phenotype.\n
                            For multiple phenotypes, the input should be\n
                            separated by comma without space. \n
                            Default: T if --beta and F if --beta is not\n
    --geno                  Filter SNPs based on gentype missingness\n
    --info                  Filter SNPs based on info score. Only used\n
                            for imputed target\n
    --keep                  File containing the sample(s) to be extracted from\n
                            the target file. First column should be FID and\n
                            the second column should be IID. If --ignore-fid is\n
                            set, first column should be IID\n
                            Mutually exclusive from --remove\n
    --maf                   Filter SNPs based on minor allele frequency (MAF)\n
    --nonfounders           Keep the nonfounders in the analysis\n
                            Note: They will still be excluded from LD calculation\n
    --pheno-col     | -F    Headers of phenotypes to be included from the\n
                            phenotype file\n
    --pheno-file    | -f    Phenotype file containing the phenotype(s).\n
                            First column must be FID of the samples and\n
                            the second column must be IID of the samples.\n
                            When --ignore-fid is set, first column must\n
                            be the IID of the samples.\n
                            Must contain a header if --pheno-col is\n
                            specified\n
    --prevalence    | -k    Prevalence of all binary trait. If provided\n
                            will adjust the ascertainment bias of the R2.\n
                            Note that when multiple binary trait is found,\n
                            prevalence information must be provided for\n
                            all of them (Either adjust all binary traits,\n
                            or don't adjust at all)\n
    --remove                File containing the sample(s) to be removed from\n
                            the target file. First column should be FID and\n
                            the second column should be IID. If --ignore-fid is\n
                            set, first column should be IID\n
                            Mutually exclusive from --keep\n
    --target        | -t    Target genotype file. Currently support\n
                            both BGEN and binary PLINK format. For \n
                            multiple chromosome input, simply substitute\n
                            the chromosome number with #. PRSice will\n
                            automatically replace # with 1-22\n
                            For binary plink format, you can also specify\n
                            a seperate fam file by <prefix>,<fam file>\n
    --target-list           File containing prefix of target genotype\n
                            files. Similar to --target but allow more \n
                            flexibility. Do not support external fam file\n
                            at the moment\n
    --type                  File type of the target file. Support bed \n
                            (binary plink) and bgen format. Default: bed\n
\nDosage:\n
    --allow-inter           Allow the generate of intermediate file. This will\n
                            speed up PRSice when using dosage data as clumping\n
                            reference and for hard coding PRS calculation\n
    --hard-thres            Hard threshold for dosage data. Any call less than\n
                            this will be treated as missing. Note that if dosage\n
                            data is used as a LD reference, it will always be\n
                            hard coded to calculate the LD\n
    --hard                  Use hard coding instead of dosage for PRS construction.\n
                            Default is to use dosage instead of hard coding\n
\nClumping:\n
    --clump-kb              The distance for clumping in kb\n
                            Default: 250 \n
    --clump-r2              The R2 threshold for clumping\n
                            Default: 0.1 \n
    --clump-p               The p-value threshold use for clumping.\n
                            Default: 1.0 \n
    --ld            | -L    LD reference file. Use for LD calculation. If not\n
                            provided, will use the post-filtered target genotype\n
                            for LD calculation. Support multiple chromosome input\n
                            Please see --target for more information\n
    --ld-list               File containing prefix of LD reference files.\n
                            Similar to --ld but allow more \n
                            flexibility. Do not support external fam file\n
                            at the moment\n
    --ld-geno               Filter SNPs based on genotype missingness\n
    --ld-info               Filter SNPs based on info score. Only used\n
                            for imputed LD reference\n
    --ld-hard-thres         Hard threshold for dosage data. Any call less than\n
                            this will be treated as missing.\n
                            Default: 0.9\n
    --ld-keep               File containing the sample(s) to be extracted from\n
                            the LD reference file. First column should be FID and\n
                            the second column should be IID. If --ignore-fid is\n
                            set, first column should be IID\n
                            Mutually exclusive from --ld-remove\n
                            No effect if --ld was not provided\n
    --ld-maf                Filter SNPs based on minor allele frequency\n
    --ld-remove             File containing the sample(s) to be removed from\n
                            the LD reference file. First column should be FID and\n
                            the second column should be IID. If --ignore-fid is\n
                            set, first column should be IID\n
                            Mutually exclusive from --ld-keep\n
    --ld-type               File type of the LD file. Support bed (binary plink)\n
                            and bgen format. Default: bed\n
    --no-clump              Stop PRSice from performing clumping\n
    --proxy                 Proxy threshold for index SNP to be considered\n
                            as part of the region represented by the clumped\n
                            SNP(s). e.g. --proxy 0.8 means the index SNP will\n
                            represent region of any clumped SNP(s) that has a\n
                            R2>=0.8 even if the index SNP does not physically\n
                            locate within the region\n
\nCovariate:\n
    --cov-col       | -c    Header of covariates. If not provided, will use\n
                            all variables in the covariate file. By adding\n
                            @ in front of the string, any numbers within [\n
                            and ] will be parsed. E.g. @PC[1-3] will be\n
                            read as PC1,PC2,PC3. Discontinuous input are also\n
                            supported: @cov[1.3-5] will be parsed as \n
                            cov1,cov3,cov4,cov5\n
    --cov-factor            Header of categorical covariate(s). Dummy variable\n
                            will be automatically generated. Any items in\n
                            --cov-factor must also be found in --cov-col\n
                            Also accept continuous input (start with @).\n
    --cov-file      | -C    Covariate file. First column should be FID and \n
                            the second column should be IID. If --ignore-fid\n
                            is set, first column should be IID\n
\nP-value Thresholding:\n
    --bar-levels            Level of barchart to be plotted. When --fastscore\n
                            is set, PRSice will only calculate the PRS for \n
                            threshold within the bar level. Levels should be\n
                            comma separated without space\n
    --fastscore             Only calculate threshold stated in --bar-levels\n
    --no-full               By default, PRSice will include the full model, \n
                            i.e. p-value threshold = 1. Setting this flag will\n
                            disable that behaviour\n
    --interval      | -i    The step size of the threshold. Default: 0.00005 \n
    --lower         | -l    The starting p-value threshold. Default: 0.0001 \n
    --model                 Genetic model use for regression. The genetic\n
                            encoding is based on the base data where the\n
                            encoding represent number of the coding allele\n
                            Available models include:\n
                            add - Additive model, code as 0/1/2 (default)\n
                            dom - Dominant model, code as 0/1/1\n
                            rec - Recessive model, code as 0/0/1\n
                            het - Heterozygous only model, code as 0/1/0\n
    --no-regress            Do not perform the regression analysis and simply\n
                            output all PRS.\n
    --missing               Method to handle missing genotypes. By default, \n
                            final scores are averages of valid per-allele \n
                            scores with missing genotypes contribute an amount\n
                            proportional to imputed allele frequency. To throw\n
                            out missing observations instead (decreasing the\n
                            denominator in the final average when this happens),\n
                            use the 'no_mean_imputation' modifier. Alternatively,\n
                            you can use the 'center' modifier to shift all scores\n
                            to mean zero. \n
    --score                 Method to calculate the polygenic score.\n
                            Available methods include:\n
                            avg - Take the average effect size (default)\n
                            std - Standardize the effect size \n
                            sum - Direct summation of the effect size \n
    --upper         | -u    The final p-value threshold. Default: 0.5 \n
\nPRSet:\n
    --bed           | -B    Bed file containing the selected regions.\n
                            Name of bed file will be used as the region\n
                            identifier. WARNING: Bed file is 0-based\n
    --feature               Feature(s) to be included from the gtf file.\n
                            Default: exon,CDS,gene,protein_coding.\n
    --gtf           | -g    GTF file containing gene boundaries. Required\n
                            when --msigdb is used\n
    --msigdb        | -m    MSIGDB file containing the pathway information.\n
                            Require the gtf file\n
    --snp-set               Provide a SNP set file containing a single snp set.\n
                            Name of SNP set file will be used as the region\n
                            identifier. This file should contain only one column.\n
    --snp-sets              Provide a SNP set file containing multiple snp sets.\n
                            Each row represent a single SNP set with the first\n
                            column containing name of the SNP set.\n    
\nPRSlice:\n
    --prslice               Perform PRSlice where the whole genome is first cut\n
                            into bin size specified by this option. PRSice will\n
                            then be performed on each bin. Bins are then sorted\n
                            according to the their R2. PRSice is then performed\n
                            again to find the best bin combination.\n
                            This cannot be performed together with PRSet\n
                            (Currently not implemented)\n
\nPlotting:\n
    --bar-col-high          Colour of the most predicting threshold\n
                            Default: firebrick\n
    --bar-col-lower         Colour of the poorest predicting threshold\n
                            Default: dodgerblue\n
    --bar-col-p             Change the colour of bar to p-value threshold\n
                            instead of the association with phenotype\n
    --bar-palatte           Colour palatte to be used for bar plotting when\n
                            --bar_col_p is set. Default: YlOrRd\n
    --multi-plot            Plot the top N phenotype / gene set in a\n
                            summary plot\n 
    --plot                  When set, will only perform plotting.\n
    --plot-set              Define the gene set to be plot. Default: Base\n
    --quantile      | -q    Number of quantiles to plot. No quantile plot\n
                            will be generated when this is not provided.\n
    --quant-break           Quantile groupings for plotting the strata plot\n
    --quant-extract | -e    File containing sample ID to be plot on a separated\n
                            quantile e.g. extra quantile containing only \n
                            schizophrenia samples. Must contain IID. Should\n
                            contain FID if --ignore-fid isn't set.\n
    --quant-ref             Reference quantile for quantile plot\n
    --scatter-r2            y-axis of the high resolution scatter plot should be R2\n

\nMisc:\n
    --all-score             Output PRS for ALL threshold. WARNING: This\n
                            will generate a huge file\n
    --non-cumulate          Calculate non-cumulative PRS. PRS will be reset\n
                            to 0 for each new P-value threshold instead of\n
                            adding up\n
    --exclude               File contains SNPs to be excluded from the\n
                            analysis\n
    --extract               File contains SNPs to be included in the \n
                            analysis\n
    --ignore-fid            Ignore FID for all input. When this is set,\n
                            first column of all file will be assume to\n
                            be IID instead of FID\n
    --keep-ambig            Keep ambiguous SNPs. Only use this option\n
                            if you are certain that the base and target\n
                            has the same A1 and A2 alleles\n
    --logit-perm            When performing permutation, still use logistic\n
                            regression instead of linear regression. This\n
                            will substantially slow down PRSice\n
    --no-install            Forbid PRSice from automatically installing\n
                            the required packages (e.g. ggplot2)\n
    --out           | -o    Prefix for all file output\n
    --perm                  Number of permutation to perform. This swill\n
                            generate the empirical p-value. Recommend to\n
                            use value larger than 10,000\n
    --print-snp             Print all SNPs used to construct the best PRS\n
    --seed          | -s    Seed used for permutation. If not provided,\n
                            system time will be used as seed. When same\n
                            seed and same input is provided, same result\n
                            can be generated\n
    --thread        | -n    Number of thread use\n
    --x-range               Range of SNPs to be excluded from the whole\n
                            analysis. It can either be a single bed file\n
                            or a comma seperated list of range. Range must\n
                            be in the format of chr:start-end or chr:coordinate\n
    --help          | -h    Display this help message\n"




# Library handling --------------------------------------------------------

if (!exists('startsWith', mode = 'function')) {
    startsWith <- function(x, prefix) {
        return(substring(x, 1, nchar(prefix)) == prefix)
    }
}


libraries <-
    c("ggplot2",
      "data.table",
      "optparse",
      "methods",
      "tools",
      "grDevices",
      "RColorBrewer")
found.library.dir <- FALSE
argv <- commandArgs(trailingOnly = TRUE)
dir.arg.idx <- grep("--dir",argv)
no.install <- length(grep("--no-install", argv))>0
if (length(dir.arg.idx) != 0) {
    dir.arg.idx <- dir.arg.idx + 1
    found.library.dir <- TRUE
}

# INSTALL_PACKAGE: Functions for automatically install all required packages
InstalledPackage <- function(package) {
    available <- suppressMessages(suppressWarnings(
        sapply(
            package,
            require,
            quietly = TRUE,
            character.only = TRUE,
            warn.conflicts = FALSE
        )
    ))
    missing <- package[!available]
    if (length(missing) > 0)
        return(FALSE)
    return(TRUE)
}

CRANChoosen <- function()
{
    return(getOption("repos")["CRAN"] != "@CRAN@")
}

UsePackage <- function(package, dir, no.install)
{
    if (!InstalledPackage(package))
    {
        dir.create(file.path(dir, "lib"), showWarnings = FALSE)
        .libPaths(c(.libPaths(), paste(dir, "/lib", sep = "")))
        if (!InstalledPackage(package) & !no.install) {
            if (is.na(dir)) {
                writeLines("WARNING: dir not provided, cannot install the required packages")
                return(FALSE)
                
            } else{
                writeLines(paste(
                    "Trying to install ",
                    package,
                    " in ",
                    dir,
                    "/lib",
                    sep = ""
                ))
            }
            suppressMessages(suppressWarnings(
                install.packages(
                    package,
                    lib = paste(dir, "/lib", sep = ""),
                    repos = "http://cran.rstudio.com/",
                    quiet = T
                )
            ))
        }
        if (!InstalledPackage(package))
            return(FALSE)
    }
    return(TRUE)
}

use.data.table <- T
use.ggplot <- T #cerr
for (library in libraries)
{
    package.directory <- "."
    if (found.library.dir) {
        package.directory <- argv[dir.arg.idx]
    }
    if (!UsePackage(library, package.directory, no.install))
    {
        if (library == "data.table") {
            use.data.table <- F
            writeLines("Cannot install data.table, will fall back and use read.table instead")
            writeLines("Note: It will be slower when reading large files")
        } else if (library == "ggplot2") {
            use.ggplot <- F
            writeLines("Cannot install ggplot2, will fall back and native plotting devices")
            writeLines("Note: The legends will be uglier")
        } else{
            stop("Error: ", library, " cannot be load nor install!")
        }
    }
    
}

# Command line arguments --------------------------------------------------

# We don't type the help message here. Will just directly use the usage information from c++
# See the Help Messages section for more information
option_list <- list(
  # Base file
  make_option(c("--A1"), type = "character"),
  make_option(c("--A2"), type = "character"),
  make_option(c("-b", "--base"), type = "character"),
  make_option(c("--beta"), action = "store_true"),
  make_option(c("--bp"), type = "character"),
  make_option(c("--chr"), type = "character"),
  make_option(c("--index"), action = "store_true"),
  make_option(c("--info-base"), type = "character", dest = "info_base"),
  make_option(c("--maf-base"), type = "character", dest="maf_base"),
  make_option(c("--no-default"), action = "store_true", dest="no_default"),
  make_option(c("-p", "--pvalue"), type = "character"),
  make_option(c("--se"), type = "character"),
  make_option(c("--snp"), type = "character"),
  make_option(c("--stat"), type = "character"),
  # Target file
  make_option(c("--binary-target"), type = "character", dest = "binary_target"),
  make_option(c("--geno"), type = "numeric"),
  make_option(c("--info"), type = "numeric"),
  make_option(c("--keep"), type = "character"),
  make_option(c("--maf"), type = "numeric"),
  make_option(c("--nonfounders"), action = "store_true", dest = "nonfounders"),
  make_option(c("--pheno-col"), type = "character", dest = "pheno_col"),
  make_option(c("-f", "--pheno-file"), type = "character", dest = "pheno_file"),
  make_option(c("-k", "--prevalence"), type = "numeric"),
  make_option(c("--remove"), type = "character"),
  make_option(c("-t", "--target"), type = "character"),
  make_option(c("--target-list"), type = "character", dest="target_list"),
  make_option(c("--type"), type = "character"),
  # Dosage
  make_option(c("--allow-inter"), action = "store_true", dest="allow_inter"),
  make_option(c("--hard-thres"), type = "numeric", dest="hard_thres"),
  make_option(c("--hard"), action = "store_true"),
  # Clumping
  make_option(c("--clump-kb"), type = "character", dest = "clump_kb"),
  make_option(c("--clump-r2"), type = "numeric", dest = "clump_r2"),
  make_option(c("--clump-p"), type = "numeric", dest = "clump_p"),
  make_option(c("-L", "--ld"), type = "character"),
  make_option(c("--ld-list"), type = "character", dest="ld_list"),
  make_option(c("--ld-geno"), type = "numeric", dest="ld_geno"),
  make_option(c("--ld-info"), type = "numeric", dest="ld_info"),
  make_option(c("--ld-hard-thres"), type = "numeric", dest="ld_hard_thres"),
  make_option(c("--ld-keep"), type = "character", dest="ld_keep"),
  make_option(c("--ld-maf"), type = "numeric", dest="ld_maf"),
  make_option(c("--ld-remove"), type = "character", dest="ld_remove"),
  make_option(c("--ld-type"), type = "character", dest="ld_type"),
  make_option(c("--no-clump"), action = "store_true", dest = "no_clump"),
  make_option(c("--proxy"), type = "numeric"),
  # Covariates
  make_option(c("-c", "--cov-col"), type = "character", dest = "cov_col"),
  make_option(c("-C", "--cov-file"), type = "character", dest = "cov_file"),
  make_option(c("--cov-factor"), type = "character", dest = "cov_factor"),
  # P-thresholding
  make_option(
    c("--bar-levels"),
    type = "character",
    dest = "bar_levels"
  ),
  make_option(c("--fastscore"), action = "store_true"),
  make_option(c("--no-full"), action = "store_true"),
  make_option(c("-i", "--interval"), type = "numeric"),
  make_option(c("-l", "--lower"), type = "numeric"),
  make_option(c("--model"), type = "character"),
  make_option(c("--missing"), type = "character"),
  make_option(c("--no-regress"), action = "store_true", dest = "no_regress"),
  make_option(c("--score"), type = "character"),
  make_option(c("-u", "--upper"), type = "numeric"),
  # PRSet
  make_option(c("-B", "--bed"), type = "character"),
  make_option(c("--feature"), type = "character"),
  make_option(c("-g", "--gtf"), type = "character"),
  make_option(c("-m", "--msigdb"), type = "character"),
  make_option(c("--set-perm"), type = "numeric",dest="set_perm"),
  make_option(c("--wind-5"), type = "character", dest="wind_5"),
  make_option(c("--wind-3"), type = "character", dest="wind_3"),
  make_option(c("--snp-set"), type = "character", dest="snp_set"),
  make_option(c("--snp-sets"), type = "character", dest="snp_sets"),
  # PRSlice 
  make_option(c("--prslice"), type = "numeric"),
  # Misc
  make_option(c("--all-score"), action = "store_true", dest="all_score"),
  make_option(c("--exclude"), type = "character"),
  make_option(c("--extract"), type = "character"),
  make_option(c("--ignore-fid"), action = "store_true", dest = "ignore_fid"),
  make_option(c("--logit-perm"), action = "store_true", dest = "logit_perm"),
  make_option(c("--keep-ambig"), action = "store_true", dest = "keep_ambig"),
  make_option(c("-o", "--out"), type = "character", default = "PRSice"),
  make_option(c("--perm"), type = "numeric"),
  make_option(c("-s", "--seed"), type = "numeric"),
  make_option(c("--print-snp"), action = "store_true", dest = "print_snp"),
  make_option(c("--non-cumulate"), action = "store_true", dest = "non_cumulate"),
  make_option(c("--pearson"), action = "store_true"),
  make_option(c("-n", "--thread"), type = "numeric"),
  make_option(c("--x-range"), type = "character", dest="x_range"),
  #R Specified options
  make_option(c("--plot"), action = "store_true"),
  make_option(c("--quantile", "-q"), type = "numeric"),
  make_option(c("--quant-break"), type="character", dest="quant_break"),
  make_option(c("--multi-plot"), type = "numeric", dest = "multi_plot"),
  make_option(c("--plot-set"),
              type = "character",
              dest = "plot_set",
              default = "Base"),
  make_option(c("--quant-pheno"), action = "store_true", dest = "quant_pheno"),
  make_option(c("--quant-extract", "-e"), type = "character", dest = "quant_extract"),
  make_option("--quant-ref", type = "numeric", dest = "quant_ref"),
  make_option("--scatter-r2",
              action = "store_true",
              default = F,
              dest = "scatter_r2"),
  make_option("--bar-col-p",
              action = "store_true",
              default = F,
              dest = "bar_col_p"),
  make_option("--bar-col-low",
              type = "character",
              default = "dodgerblue",
              dest = "bar_col_low"),
  make_option("--bar-col-high",
              type = "character",
              default = "firebrick",
              dest = "bar_col_high"),
  make_option("--bar-palatte",
              type = "character",
              default = "YlOrRd",
              dest = "bar_palatte"),
  make_option("--prsice", type = "character"),
  make_option("--dir", type = "character")
)


capture <- commandArgs(trailingOnly = TRUE)
help <- (sum(c("--help", "-h") %in% capture) >= 1)
has_c <- (sum(c("--prsice") %in% capture) >= 1)
if (help) {
    cat(help_message)
    quit()
}
argv <- parse_args(OptionParser(option_list = option_list))

not_cpp <- c(
    "help",
    "plot",
    "quantile",
    "quant-extract",
    "intermediate",
    "quant-ref",
    "quant-pheno",
    "quant-break",
    "scatter-r2",
    "bar-col-p",
    "bar-col-low",
    "bar-col-high",
    "bar-palatte",
    "prsice",
    "multi-plot",
    "plot-set",
    "dir",
    "no-install"
)

if (is.null(argv$cov_col) && !is.null(argv$cov_header))
{
    argv$cov_col = argv$cov_header
}

# Check help messages --------------------------------------------------

provided <- function(name, argv) {
    return(name %in% names(argv))
}

get_os <- function(){
    sysinf <- Sys.info()
    if (!is.null(sysinf)){
        os <- sysinf['sysname']
        if (os == 'Darwin')
            os <- "osx"
    } else { ## mystery machine
        os <- .Platform$OS.type
        if (grepl("^darwin", R.version$os))
            os <- "osx"
        if (grepl("linux-gnu", R.version$os))
            os <- "linux"
    }
    tolower(os)
}

# CALL_PRSICE: Call the cpp PRSice if required
# To ensure the excutable is set correctly
# For window, we might not be able to start an executable by simply adding ./
# therefore Window people will need to be careful with their parameter input
os <- get_os()
if (provided("prsice", argv)) {
    if (!startsWith(argv$prsice, "/") &&
        !startsWith(argv$prsice, ".") && os!="windows") {
        argv$prsice = paste("./", argv$prsice, sep = "")
    }
}

# Running PRSice ----------------------------------------------------------

# We don't bother to check if the input is correct, the parameter should be checked by the c++ program
add_command <- function(input) {
    if (length(input) == 1) {
        if (is.na(input)) {
            return(NA)
        } else{
            return(input)
        }
    } else{
        return(paste(input, collapse = ","))
    }
}
command <- ""
argv_c <- argv

names(argv_c) <- gsub("_", "-", names(argv))
flags <-
    c(
        "all-score",
        "allow-inter",
        "beta",
        "fastscore",
        "ignore-fid",
        "index",
        "keep-ambig",
        "logit-perm",
        "no-clump",
        "no-default",
        "no-full",
        "no-mt",
        "no-regress",
        "no-x",
        "no-xy",
        "no-y",
        "non-cumulate",
        "print-snp"
    )

if (!provided("plot", argv)) {
    for (i in names(argv_c)) {
        # only need special processing for flags and specific inputs
        if (i %in% flags) {
            if (argv_c[[i]])
                command = paste(command, " --", i, sep = "")
        } else if (i %in% not_cpp) {
            # ignore
        } else{
            temp = add_command(argv_c[[i]])
            if (!is.na(temp)) {
                command = paste(command, " --", i, " ", temp, sep = "")
            }
        }
    }
    if (nchar(command) == 0) {
        cat(help_message)
        quit()
    }
    if (provided("prsice", argv_c)) {
        ret <- system2(argv_c$prsice, command)
        if (ret != 0 || provided(help, argv)) {
            stop()
            
        }
    } else{
        stop("Cannot run PRSice without the PRSice binary file")
    }
}

# Helper functions --------------------------------------------------------
max_length <- function(x) {
    info <- strsplit(as.character(x), split = "\n")[[1]]
    max(sapply(info, nchar))
}
str_wrap <- function(x) {
    lapply(strwrap(x, width = 25, simplify = FALSE), paste, collapse = "\n")
}
shorten_label <- function(x) {
    lab <-
        paste(strsplit(paste(
            strsplit(as.character(x), split = "\\.")[[1]], collapse = " "
        ), split = "_")[[1]], collapse = " ")
    return(str_wrap(lab)[[1]])
}


get_quantile <- function(x, num.quant, quant.ref){
    quant <- as.numeric(cut(x,
                            breaks = unique(quantile(
                                x, probs = seq(0, 1, 1 / num.quant)
                            )),
                            include.lowest = T))
    if(is.na(quant.ref) | is.null(quant.ref)){
        quant.ref <- ceiling(num.quant / 2)
    }
    quant <- factor(quant, levels = c(quant.ref, seq(min(quant), max(quant), 1)[-quant.ref]))
    return(quant)
}

set_uneven_quant <- function(quant.cutoff, ref.cutoff, num.quant, prs, quant.index){

    quant <- get_quantile(prs, num.quant, 1)
    quant <- factor(quant,1:num.quant)
    quant.cut <- sort(as.numeric(strsplit(quant.cutoff, split=",")[[1]]))
    if((!is.null(ref.cutoff) & sum(ref.cutoff == quant.cut)==0) | num.quant < max(quant.cut)){
        stop(
            "Invalid quant-break. quant-break must be smaller than total number of quantiles and quant-ref must be one of the quant-break"
        )
    }
    prev.name <- 0
    ref.level <- NULL
    for(i in 1:length(quant.cut)){
        up.bound <- max(which(suppressWarnings(as.numeric(levels(quant))) <= quant.cut[i]))
        cur.name <- levels(quant)[up.bound]
        name.level <- paste0("(",prev.name, ",", cur.name, "]")
        
        if(prev.name==0){
            name.level <- paste0("[",prev.name, ",", cur.name, "]")
            
        }
        if(!is.null(ref.cutoff)) {
            if (quant.cut[i] == ref.cutoff) {
                ref.level <- name.level
                
            }
        }
        range <- i:up.bound
        levels(quant)[range] <- rep(name.level, length(range))
        prev.name <- cur.name
    }
    if(is.null(ref.level)){
        writeLines("=======================================")
        writeLines("Warning: Cannot find required reference level, will use the middle level as reference")
        writeLines("=======================================")
        ref.level <- levels(quant)[ceiling(length(quant.cut)/2)]
    }
    ref.index <- which(levels(quant)==ref.level)
    quant.index <- c(ref.index,c(1:length(levels(quant)))[-ref.index])
    quant<- relevel(quant, ref=ref.level)
    return(list(quant, quant.index))
}
# Determine Default -------------------------------------------------------
# First, determine the bar levels
if(!provided("bar_levels", argv)){
    if(!provided("msigdb", argv) & !provided("gtf", argv) & !provided("bed", argv)) {
        argv$bar_levels <- paste(0.001, 0.05, 0.1, 0.2, 0.3, 0.4, 0.5, sep=",")
        if (!provided("no_full", argv)) {
            argv$bar_levels <- paste(argv$bar_levels, 1, sep=",")
        }
    } else if (!provided("fastscore", argv) &
               !provided("lower", argv) &
               !provided("upper", argv) & !provided("interval", argv)) {
        # This is prset, so by default, we don't do all threshold
        # unless user use some of the parameter related to the thresholding
        argv$bar_levels <- "1"
    }
}
# Next, we need to determine if we are doing binary target
# This is only required when user does not provide --binary-target
 
if(!provided("binary_target", argv)){
    # Now we want to check if base is beta
    base_beta <- F
    if(provided("beta", argv)){
        # Base is beta
        base_beta <- T
    }else{
        if(!provided("base", argv)){
            writeLines("Warning: Without base file, we cannot determine if the summary statistic is beta or OR, which is used to determine if the target phenotype is binary or not. We will now proceed assuming the target phenotype is binary. If that is incorrect, please use --binary-target to specify the correct target phenotype type, or you can provide the base file")
        }
        else{
            zz <- gzfile(argv$base)
            base_header <- readLines(zz,n=1)
            close(zz)
            or <- length(grep("or",base_header,ignore.case=TRUE))==1
            beta <- length(grep("beta",base_header,ignore.case=TRUE))==1
            if(or & beta){
                stop("Both OR and BETA detected. Cannot determine which one should be used. Please use --beta or --binary-target")
            }
            if(beta){
                base_beta <- T    
            }
            if(!or & !beta){
                stop("Do not detect either BETA or OR. Please ensure your base input is correct")
            }
        }
    }
    # Now we know if the base is beta or not, we can determine the target binary status
    if(!provided("pheno_col", argv)){
        if(base_beta){
            argv$binary_target <- "F"
        }else{
            argv$binary_target <- "T"
        }
    }else if(length(strsplit(argv$pheno_col, split=",")[[1]])==1){
        if(base_beta){
            argv$binary_target <- "F"
        }else{
            argv$binary_target <- "T"
        }    
    }
}

# Sanity check for binary-target
if(provided("pheno_col", argv) & provided("binary_target", argv)){
    pheno_length <- length(strsplit(argv$pheno_col, split=",")[[1]])
    binary_length <- length(strsplit(argv$binary_target, split=",")[[1]])
    if(pheno_length==0 & binary_length==1){
        # This is ok
    }else if(pheno_length!=binary_length){
        stop("Error: Number of target phenotypes doesn't match information of binary target! You must indicate whether the phenotype is binary using --binary-target\n")        
    }
}
    

# Plottings ---------------------------------------------------------------

# Standard Theme for all plots
theme_sam <- NULL
if(use.ggplot){
  theme_sam <- theme_bw()+theme(axis.title=element_text(face="bold", size=18),
                              axis.text=element_text(size=14),
                              legend.title=element_text(face="bold", size=18),
                              legend.text=element_text(size=14),
                              axis.text.x=element_text(angle=45, hjust=1),
                              panel.grid = element_blank(),
                              panel.border = element_blank(), 
                              axis.line = element_line()
                              )
}

# Quantile Plots----------------------------------------------------------

call_quantile <-
    function(pheno.merge,
             prefix,
             num_quant,
             quant.index,
             pheno.as.quant,
             use.residual,
             use.ggplot,
             binary,
             extract,
             uneven) {
        
    if (!pheno.as.quant) {
        family <- gaussian
        if (binary) {
            if (!use.residual) {
                family <- binomial
            }
        }
        reg <-
            summary(glm(Pheno ~ quantile, family, data = pheno.merge))
        coef.quantiles <- (reg$coefficients[1:num_quant, 1])
        ci <- (1.96 * reg$coefficients[1:num_quant, 2])
        
        ci.quantiles.u <-
            coef.quantiles + ci
        ci.quantiles.l <-
            coef.quantiles - ci
        if (binary & !use.residual) {
            ci.quantiles.u <- exp(ci.quantiles.u)
            ci.quantiles.l <- exp(ci.quantiles.l)
            coef.quantiles <- exp(coef.quantiles)
        }
        
        coef.quantiles[1] <-
            ifelse(binary & !use.residual, 1, 0)
        ci.quantiles.u[1] <-
            ifelse(binary & !use.residual, 1, 0)
        ci.quantiles.l[1] <-
            ifelse(binary & !use.residual, 1, 0)
        quantiles.for.table <- factor(levels(pheno.merge$quantile), levels(pheno.merge$quantile))
        quantiles.df <-
            data.frame(
                Coef = coef.quantiles,
                CI.U = ci.quantiles.u,
                CI.L = ci.quantiles.l,
                DEC = quantiles.for.table
            )
        quantiles.df$Group = 0
        if (!is.null(extract)) {
            # Last element should be the cases
            quantiles.df$Group[nrow(quantiles.df)] <- 1
        }
        quantiles.df$Group <-
            factor(quantiles.df$Group, levels = c(0, 1))
        quantiles.df <- quantiles.df[order(quant.index),]
        quantiles.df$DEC <- factor(quantiles.df$DEC, levels=levels(quantiles.df$DEC)[order(quant.index)])
        row.names(quantiles.df) <- quantiles.df$DEC
        quantiles.df <- cbind(Quantile = rownames(quantiles.df), quantiles.df) 
        quant.out <- quantiles.df[,-5]
        sample.size <- as.data.frame(table(pheno.merge$quantile))
        colnames(sample.size) <- c("Quantile", "N")
        quant.out$Order <- 1:nrow(quant.out)
        quant.out <- merge(quant.out,sample.size )
        if(binary & !use.residual){
            colnames(quant.out)[2] <- "OR"
        }
        
        quant.out <-
            quant.out[order(quant.out$Order), !colnames(quant.out) %in% "Order"]
        write.table(
            quant.out,
            paste(prefix, "_QUANTILES_", Sys.Date(), ".txt", sep = ""),
            sep = "\t",
            quote = F,
            row.names = F
        )
        if (use.ggplot) {
            plot.quant(quantiles.df,
                       num_quant,
                       binary,
                       extract,
                       prefix,
                       use.residual,
                       uneven)
        } else{
            plot.quant.no.g(quantiles.df,
                            num_quant,
                            binary,
                            extract,
                            prefix,
                            use.residual,
                            uneven)
        }
    } else{
        # TODO: Maybe also change this to regression? Though might be problematic if we have binary pheno without cov
        pheno.sum <-
            data.frame(
                mean = numeric(num_quant),
                quantile = factor(levels(pheno.merge$quantile)[order(quant.index)],levels=levels(pheno.merge$quantile)[order(quant.index)]),
                UCI = numeric(num_quant),
                LCI = numeric(num_quant)
            )
        for (i in 1:length(levels(pheno.sum$quantile))) {
            
            cur.prs <-
                pheno.merge$PRS[as.character(pheno.merge$quantile) %in% as.character(levels(pheno.sum$quantile))[i]]
            pheno.sum$mean[i] <- mean(cur.prs, na.rm = T)
            pheno.sum$UCI[i] <-
                pheno.sum$mean[i] + sd(cur.prs, na.rm = T)
            pheno.sum$LCI[i] <-
                pheno.sum$mean[i] - sd(cur.prs, na.rm = T)
        }
        pheno.sum$Group = 0
        if (!is.null(extract)) {
            pheno.sum$Group[num_quant] = 1
        }
        pheno.sum$Group <-
            factor(pheno.sum$Group, levels = c(0, 1))
        write.table(
            pheno.sum,
            paste(prefix, "_PHENO_QUANTILES_", Sys.Date(), ".txt", sep = ""),
            sep = "\t",
            quote = F,
            row.names = F
        )
        if (use.ggplot) {
            plot.pheno.quant(pheno.sum,
                             use.residual,
                             num_quant,
                             extract,
                             prefix,
                             uneven)
        } else{
            plot.pheno.quant.no.g(pheno.sum,
                                  use.residual,
                                  num_quant,
                                  extract,
                                  prefix,
                                  uneven)
        }
    }
    
    }


uneven_quantile_plot <- function(base.prs, pheno, prefix, argv, binary, use.ggplot, use.residual){
    binary <- as.logical(binary)
    writeLines("Plotting the quantile plot")
    extract <- NULL
    if (provided("quant_extract", argv)) {
        if (use.data.table) {
            extract <- fread(argv$quant_extract,
                             header = F,
                             data.table = F)
        } else{
            extract <- read.table(argv$quant_extract,
                                  header = F)
        }
        
    }
    num_quant <- argv$quantile
    pheno.merge <- merge(base.prs, pheno)
    pheno.as.quant <- provided("quant_pheno", argv)
    if (pheno.as.quant &&
        length(unique(pheno.merge$Pheno)) < num_quant) {
        writeLines(
            paste(
                "WARNING: There are only ",
                length(unique(pheno.merge$Pheno)),
                " unique Phenotype but asked for ",
                num_quant,
                " quantiles",
                sep = ""
            )
        )
        writeLines(paste("Will not generate the quantile plot for ", prefix))
        return()
    } else if (length(unique(pheno.merge$PRS)) < num_quant) {
        writeLines(
            paste(
                "WARNING: There are only ",
                length(unique(pheno.merge$PRS)),
                " unique PRS but asked for ",
                num_quant,
                " quantiles",
                sep = ""
            )
        )
        writeLines(paste("Will not generate the quantile plot for ", prefix))
        return()
    }
    quants <- NULL
    quant.index <- NULL
    if (!pheno.as.quant) {
        quant.info <- set_uneven_quant(argv$quant_break, argv$quant_ref, num_quant, pheno.merge$PRS, quant.index)
        quants <- quant.info[[1]]
        quant.index <- quant.info[[2]]
    } else{
        quant.info <- set_uneven_quant(argv$quant_break, argv$quant_ref, num_quant, pheno.merge$Pheno, quant.index)
        quants <- quant.info[[1]]
        quant.index <- quant.info[[2]]
    }
    
    num_quant <- length(levels(quants))
    if (!is.null(extract)) {
        extract_ID <- NULL
        best_ID <- NULL
        if (provided("ignore_fid", argv)) {
            extract_ID <- extract$V1
            best_ID <- pheno.merge$IID
        } else{
            extract_ID <- paste(extract$V1, extract$V2, sep = "_")
            best_ID <-
                paste(pheno.merge$FID, pheno.merge$IID, sep = "_")
        }
        levels(quants) <- c(levels(quants),"Extracted")
        quants[best_ID %in% extract_ID] <- "Extracted"
        num_quant <- num_quant + 1
    }
    pheno.merge$quantile <- quants
    call_quantile(pheno.merge,
                  prefix,
                  num_quant,
                  quant.index,
                  pheno.as.quant,
                  use.residual,
                  use.ggplot,
                  binary,
                  extract, TRUE)
}


quantile_plot <- function(base.prs, pheno, prefix, argv, binary, use.ggplot, use.residual){
    binary <- as.logical(binary)
    writeLines("Plotting the quantile plot")
    extract <- NULL
    if (provided("quant_extract", argv)) {
        if (use.data.table) {
            extract <- fread(argv$quant_extract,
                             header = F,
                             data.table = F)
        } else{
            extract <- read.table(argv$quant_extract,
                                  header = F)
        }
        
    }
    num_quant <- argv$quantile
    
    pheno.merge <- merge(base.prs, pheno)
    pheno.as.quant <- provided("quant_pheno", argv)
    if (pheno.as.quant &&
        length(unique(pheno.merge$Pheno)) < num_quant) {
        writeLines(
            paste(
                "WARNING: There are only ",
                length(unique(pheno.merge$Pheno)),
                " unique Phenotype but asked for ",
                num_quant,
                " quantiles",
                sep = ""
            )
        )
        writeLines(paste("Will not generate the quantile plot for ", prefix))
        return()
    } else if (length(unique(pheno.merge$PRS)) < num_quant) {
        writeLines(
            paste(
                "WARNING: There are only ",
                length(unique(pheno.merge$PRS)),
                " unique PRS but asked for ",
                num_quant,
                " quantiles",
                sep = ""
            )
        )
        writeLines(paste("Will not generate the quantile plot for ", prefix))
        return()
    }
    
    quant.ref <- ceiling(argv$quantile / 2)
    if (provided("quant_ref", argv)) {
        quant.ref <- argv$quant_ref
        if (quant.ref > argv$quantile) {
            quant.ref <- ceiling(argv$quantile / 2)
            writeLines("=======================================")
            writeLines(
                paste(
                    "WARNING: reference quantile",
                    quant.ref,
                    "is greater than number of quantiles",
                    argv$quantile,
                    "\n Using middle quantile by default"
                )
            )
            writeLines("=======================================")
        }
    }
    quants <- NULL
    if (!pheno.as.quant) {
        quants <- get_quantile(pheno.merge$PRS, num_quant, quant.ref)
    } else{
        quants <- get_quantile(pheno.merge$Pheno, num_quant, quant.ref)
    }
    num_quant <- length(levels(quants))
    if (!is.null(extract)) {
        extract_ID <- NULL
        best_ID <- NULL
        if (provided("ignore_fid", argv)) {
            extract_ID <- extract$V1
            best_ID <- pheno.merge$IID
        } else{
            extract_ID <- paste(extract$V1, extract$V2, sep = "_")
            best_ID <-
                paste(pheno.merge$FID, pheno.merge$IID, sep = "_")
        }
        levels(quants) <- c(levels(quants),"Extracted")
        quants[best_ID %in% extract_ID] <- "Extracted"
        num_quant <- num_quant + 1
    }
    quant.index <- c(quant.ref, c(1:num_quant)[-quant.ref])
    pheno.merge$quantile <- quants
    call_quantile(pheno.merge,
                 prefix,
                 num_quant,
                 quant.index,
                 pheno.as.quant,
                 use.residual,
                 use.ggplot,
                 binary,
                 extract, FALSE)
}

plot.pheno.quant.no.g <- function(pheno.sum, use_residual, num_quant, extract, prefix, uneven){
  png(paste(prefix, "_QUANTILES_PHENO_PLOT_", Sys.Date(), ".png", sep = ""),
      height=10, width=10, res=300, unit="in")
  par(pty="s", cex.lab=1.5, cex.axis=1.25, font.lab=2, mai=c(0.5,1.25,0.1,0.1))
  pheno.sum$color <- "#D55E00"
  xlab <- NULL
  name <- "Quantiles"
  if(uneven){
      name <- "Strata"
  }
  if(use_residual){
    xlab <-paste0(name, " for Residualized Phenotype")
  }else{
    xlab <-paste0(name, " for Phenotype")
  }
  
  
  if(!is.null(extract)){
    pheno.sum$color <- "#D55E00"
    pheno.sum$color[quantiles.df$Group==1] <- "#0072B2"
  }
  ylab <- "Mean PRS given phenotype in quantiles"
  if(uneven){
      ylab <- "Mean PRS given phenotype in strata"
  }
  with(pheno.sum, 
       plot(x=quantile, y=mean, 
            col=color, pch=19, 
            axes=F, cex=1.5,
            ann=F,
            ylim=c(min(LCI),max(UCI))
       ))
  box(bty='L', lwd=2)
  axis(2,las=2, lwd=2)
  axis(1, label=seq(1,num_quant,2), at=seq(1,num_quant,2),lwd=2)
  axis(1, label=seq(2,num_quant,2), at=seq(2,num_quant,2),lwd=2)
  with(pheno.sum, arrows(quantile,mean, quantile,LCI,length=0, col=color, lwd=1.5))
  with(pheno.sum, arrows(quantile,mean, quantile,UCI,length=0, col=color, lwd=1.5))
  title(ylab=ylab, line=4, cex.lab=1.5, font=2 )
  title(xlab=xlab, line=2.5, cex.lab=1.5, font=2 )
  g<-dev.off()
}

plot.pheno.quant <- function(pheno.sum, use_residual, num_quant, extract, prefix, uneven){
  quantiles.plot <-
    ggplot(pheno.sum, aes(
      x = quantile,
      y = mean,
      ymin = LCI,
      ymax = UCI
    ))+ 
    theme_sam
  if(uneven) {
      quantiles.plot <-
          quantiles.plot + ylab("Mean PRS given phenotype in strata")
  } else{
      quantiles.plot <-
          quantiles.plot + ylab("Mean PRS given phenotype in quantiles")
  }
  if(use_residual){
      if (uneven) {
          quantiles.plot <- quantiles.plot +
              xlab("Strata for Residualized Phenotype")
      } else{
          quantiles.plot <- quantiles.plot +
              xlab("Quantiles for Residualized Phenotype")
      }
  }else{
      if (uneven) {
          quantiles.plot <- quantiles.plot +
              xlab("Quantiles for Phenotype")
      } else{
          quantiles.plot <- quantiles.plot +
              xlab("Strat for Phenotype")
      }
  }
  
  if (is.null(extract)) {
    quantiles.plot <-
      quantiles.plot + geom_point(colour = "#D55E00", size = 4) +
      geom_pointrange(colour = "#D55E00", size = 0.9)
  } else{
    quantiles.plot <-
      quantiles.plot + geom_point(aes(color = Group), size = 4) +
      geom_pointrange(aes(color = Group), size = 0.9) +
      scale_colour_manual(values = c("#D55E00","#0072B2"))
  }
  ggsave(
    paste(prefix, "QUANTILES_PHENO_PLOT_", Sys.Date(),".png", sep = "_"),
    quantiles.plot,
    height=10,width=10
  )
}

plot.quant <- function(quantiles.df, num_quant, binary, extract, prefix, use_residual, uneven){
    quantiles.plot <-
        ggplot(quantiles.df, aes(
            x = DEC,
            y = Coef,
            ymin = CI.L,
            ymax = CI.U
        )) + 
        theme_sam
    if(uneven){
        quantiles.plot <- quantiles.plot+xlab("Strata for Polygenic Score")
    } else{
        quantiles.plot <-
            quantiles.plot + xlab("Quantiles for Polygenic Score")
    }
    if (binary){
        if(!use_residual) {
            quantiles.plot <-
                quantiles.plot + ylab("Odds Ratio for Score on Phenotype")
        }else if(use_residual){
            if(uneven){
                quantiles.plot <- quantiles.plot + ylab("Change in residualized\nPhenotype given score in strata")
            }else{
                quantiles.plot <- quantiles.plot + ylab("Change in residualized\nPhenotype given score in quantiles")
            }
        }
    } else if(use_residual){
        if (uneven) {
            quantiles.plot <-
                quantiles.plot + ylab("Change in residualized\nPhenotype given score in strata")
        } else{
            quantiles.plot <-
                quantiles.plot + ylab("Change in residualized\nPhenotype given score in quantiles")
        }
    }else{
        if (uneven) {
            quantiles.plot <- quantiles.plot +
                ylab("Change in Phenotype \ngiven score in strata")
        } else{
            quantiles.plot <- quantiles.plot +
                ylab("Change in Phenotype \ngiven score in quantiles")
        }
    }
    if (is.null(extract)) {
        quantiles.plot <-
            quantiles.plot + geom_point(colour = "royalblue2", size = 4) +
            geom_pointrange(colour = "royalblue2", size = 0.9)
    } else{
        quantiles.plot <-
            quantiles.plot + geom_point(aes(color = Group), size = 4) +
            geom_pointrange(aes(color = Group), size = 0.9) +
            scale_colour_manual(values = c("#0072B2", "#D55E00"))
    }
    ggsave(
        paste(prefix, "_QUANTILES_PLOT_", Sys.Date(),".png", sep = ""),
        quantiles.plot,
        height=10, width=10
    )
}

plot.quant.no.g <- function(quantiles.df, num_quant, binary, extract, prefix, use_residual, uneven){
  png(paste(prefix, "_QUANTILES_PLOT_", Sys.Date(), ".png", sep = ""),
      height=10, width=10, res=300, unit="in")
  par(pty="s", cex.lab=1.5, cex.axis=1.25, font.lab=2, mai=c(0.5,1.25,0.1,0.1))
  quantiles.df$color <- "royalblue2"
  if(!is.null(extract)){
    quantiles.df$color <- "#0072B2"
    quantiles.df$color[quantiles.df$Group==1] <- "#D55E00"
  }
  ylab <- NULL
  if (binary){
      if(!use_residual) {
          quantiles.plot <-
              quantiles.plot + ylab("Odds Ratio for Score on Phenotype")
      }else if(use_residual){
          if(uneven) {
              quantiles.plot <-
                  quantiles.plot + ylab("Change in residualized\nPhenotype given score in strata")
          } else{
              quantiles.plot <-
                  quantiles.plot + ylab("Change in residualized\nPhenotype given score in quantiles")
          }
      }
  } else if(use_residual){
      if (uneven) {
          quantiles.plot <-
              quantiles.plot + ylab("Change in residualized\nPhenotype given score in strata")
      } else{
          quantiles.plot <-
              quantiles.plot + ylab("Change in residualized\nPhenotype given score in quantiles")
      }
  } else{
      if(uneven) {
          quantiles.plot <- quantiles.plot +
              ylab("Change in Phenotype \ngiven score in strata")
      } else{
          quantiles.plot <- quantiles.plot +
              ylab("Change in Phenotype \ngiven score in quantiles")
      }
  }
  xlab <- "Quantiles for Polygenic Score"
  if(uneven){
      xlab <- "Strata for Polygenic Score"
  }
  with(quantiles.df, 
       plot(x=DEC, y=Coef, 
            col=color, pch=19, 
            axes=F, cex=1.5, ann=F,
            ylim=c(min(CI.L),max(CI.U))
            ))

  axis(2,las=2,lwd=2)
  box(bty='L', lwd=2)
  axis(1, label=seq(1,num_quant,2), at=seq(1,num_quant,2),lwd=2)
  axis(1, label=seq(2,num_quant,2), at=seq(2,num_quant,2),lwd=2)
  with(quantiles.df, arrows(DEC,Coef, DEC,CI.L,length=0, col=color, lwd=1.5))
  with(quantiles.df, arrows(DEC,Coef, DEC,CI.U,length=0, col=color, lwd=1.5))
  title(ylab=ylab, line=4, cex.lab=1.5, font=2 )
  title(xlab=xlab, line=2.5, cex.lab=1.5, font=2 )
  g<-dev.off()
}


# High Resolution Plot ----------------------------------------------------


high_res_plot <- function(PRS, prefix, argv, use.ggplot) {
    # we will always include the best threshold
    writeLines("Plotting the high resolution plot")
    barchart.levels <-
        c(strsplit(argv$bar_levels, split = ",")[[1]], PRS$Threshold[which.max(PRS$R2)])
    barchart.levels <-
        as.numeric(as.character(sort(
            unique(barchart.levels), decreasing = F
        )))
    # As the C++ program will skip thresholds, we need to artificially add the correct threshold information
    PRS.ori <- PRS
    threshold <- as.numeric(as.character(PRS.ori$Threshold))
    for (i in 1:length(barchart.levels)) {
        if (sum(barchart.levels[i] - threshold > 0) > 0) {
            target <- max(threshold[barchart.levels[i] - threshold >= 0])
            temp <- PRS.ori[threshold == target,]
            temp$Threshold <- barchart.levels[i]
            PRS <- rbind(PRS, temp)
            
        } else{
            target <-
                (threshold[which(abs(threshold - barchart.levels[i]) == min(abs(threshold - barchart.levels[i])))])
            temp <- PRS.ori[threshold == target,]
            temp$Threshold <- barchart.levels[i]
            PRS <- rbind(PRS, temp)
            
        }
    }
    PRS = unique(PRS)
    # Need to also plot the barchart level stuff with green
    if(use.ggplot){
      plot.high.res(argv, PRS, prefix, barchart.levels)
    }else{
      plot.high.res.no.g(argv, PRS, prefix, barchart.levels)
    }
}

plot.high.res.no.g <- function(argv, PRS, prefix, barchart.levels){
  png(paste(prefix, "_HIGH-RES_PLOT_", Sys.Date(), ".png", sep = ""),
      height=10, width=10, res=300, unit="in")
  par(pty="s", cex.lab=1.5, cex.axis=1.25, font.lab=2, mai=c(0.5,1.25,0.1,0.1))
  xlab <- expression(italic(P) - value ~ threshold ~ (italic(P)[T]))
  ylab <- expression(paste("PRS model fit:  ", R ^ 2, sep = " "))
  if (argv$scatter_r2) {
    with(PRS[order(PRS$Threshold),], 
         plot(x=Threshold, y=R2, 
              pch=20, 
              axes=FALSE, ann=F))
    
    with(subset(PRS[order(PRS$Threshold),], Threshold%in%barchart.levels ), 
         lines(x=Threshold, y=R2, col="green"))
  }else{
    ylab <- bquote(PRS ~ model ~ fit: ~ italic(P) - value ~ (-log[10]))
    with(PRS[order(PRS$Threshold),], 
         plot(x=Threshold, y=-log10(P),  
              pch=20, 
              axes=FALSE, ann=F))
    
    with(subset(PRS[order(PRS$Threshold),], Threshold%in%barchart.levels ), 
         lines(x=Threshold, y=-log10(P), col="green"))
  }
  box(bty='L', lwd=2)
  axis(2, las=2)
  axis(1)
  
  title(ylab=ylab, line=4, cex.lab=1.5, font=2 )
  title(xlab=xlab, line=2.5, cex.lab=1.5, font=2 )
  g<-dev.off()
}

plot.high.res <- function(argv, PRS, prefix, barchart.levels){
  ggfig.points <- ggplot(data = PRS, aes(x = Threshold)) +
    xlab(expression(italic(P) - value ~ threshold ~ (italic(P)[T]))) +
    theme_sam
  if (argv$scatter_r2) {
    ggfig.points <-
      ggfig.points + geom_point(aes(y = R2)) + geom_line(aes(y = R2), colour = "green",
                                                         data = PRS[with(PRS, Threshold %in% barchart.levels) ,]) +
      ylab(expression(paste("PRS model fit:  ", R ^ 2, sep = " ")))
  } else{
    ggfig.points <-
      ggfig.points + geom_point(aes(y = -log10(P))) + geom_line(aes(y = -log10(P)), colour = "green",
                                                                data = PRS[with(PRS, Threshold %in% barchart.levels) ,]) +
      ylab(bquote(PRS ~ model ~ fit: ~ italic(P) - value ~ (-log[10])))
    
  }
  ggsave(
    paste(prefix, "_HIGH-RES_PLOT_", Sys.Date(), ".png", sep = ""),
    ggfig.points,
    height=10, width=10
  )
}


# Plot bar plot -----------------------------------------------------------


bar_plot <- function(PRS, prefix, argv, use.ggplot) {
    writeLines("Plotting Bar Plot")
    barchart.levels <-
        c(strsplit(argv$bar_levels, split = ",")[[1]], PRS$Threshold[which.max(PRS$R2)])
    barchart.levels <-
        as.numeric(as.character(sort(
            unique(barchart.levels), decreasing = F
        )))
    threshold <- as.numeric(as.character(PRS$Threshold))
    PRS.ori = PRS
    threshold <- as.numeric(as.character(PRS.ori$Threshold))
    for (i in 1:length(barchart.levels)) {
        if (sum(barchart.levels[i] - threshold > 0) > 0) {
            target <- max(threshold[barchart.levels[i] - threshold >= 0])
            temp <- PRS.ori[threshold == target,]
            temp$Threshold <- barchart.levels[i]
            PRS = rbind(PRS, temp)
            
        } else{
            target <-
                (threshold[which(abs(threshold - barchart.levels[i]) == min(abs(threshold - barchart.levels[i])))])
            temp <- PRS.ori[threshold == target,]
            temp$Threshold <- barchart.levels[i]
            PRS = rbind(PRS, temp)
            
        }
    }
    PRS <- unique(PRS[order(PRS$Threshold),])
    # As the C++ program will skip thresholds, we need to artificially add the correct threshold information
    output <- PRS[PRS$Threshold %in% barchart.levels, ]
    output$print.p[round(output$P, digits = 3) != 0] <-
        round(output$P[round(output$P, digits = 3) != 0], digits = 3)
    output$print.p[round(output$P, digits = 3) == 0] <-
        format(output$P[round(output$P, digits = 3) == 0], digits = 2)
    output$sign <- sign(output$Coefficient)
    output$print.p <- sub("e", "*x*10^", output$print.p)
    if(use.ggplot){
      plot.bar(argv, output, prefix)
    }else{
      plot.bar.no.g(argv, output,prefix)
    }
}

plot.bar.no.g <- function(argv, output, prefix){
  png(paste(prefix, "_BARPLOT_", Sys.Date(), ".png", sep = ""),
      height=10, width=10, res=300, unit="in")
  layout(t(1:2), widths=c(8.8,1.2))
  par( cex.lab=1.5, cex.axis=1.25, font.lab=2, 
      oma=c(0,0.5,0,0),
      mar=c(4,6,0.5,0.5))
  xlab <- expression(italic(P) - value ~ threshold ~ (italic(P)[T]))
  ylab <- expression(paste("PRS model fit:  ", R ^ 2))
  if(argv$bar_col_p){
    col <- suppressWarnings(colorRampPalette(brewer.pal(12,argv$bar_palatte)))
    output <- output[order(output$Threshold),]
    output$color <-  col(nrow(output))
    b<- barplot(height=output$R2, 
                col=output$color, 
                border=NA, 
                ylim=c(0, max(output$R2)*1.25), 
                axes = F , ann=F)
    odd <- seq(0,nrow(output)+1,2)
    even <- seq(1,nrow(output),2)
    axis(side=1, at=b[odd], labels=output$Threshold[odd])
    axis(side=1, at=b[even], labels=output$Threshold[even])
    text( parse(text=paste(
      output$print.p)), 
      x = b+0.1, 
      y =  output$R2+ (max(output$R2)*1.05-max(output$R2)), 
      srt = 45)
  }else{
    col <- suppressWarnings(colorRampPalette(c(argv$bar_col_low, argv$bar_col_high)))
    output <- output[order(-log10(output$P)),]
    output$color <-  col(nrow(output))
    output <- output[order(output$Threshold),]
    b<- barplot(height=output$R2, 
                col=output$color, 
                border=NA, 
                ylim=c(0, max(output$R2)*1.25), 
                axes = F, ann=F)
    
    odd <- seq(0,nrow(output)+1,2)
    even <- seq(1,nrow(output),2)
    axis(side=1, at=b[odd], labels=output$Threshold[odd], lwd=2)
    axis(side=1, at=b[even], labels=output$Threshold[even],lwd=2)
    axis(side=1, at=c(0,b[1],2*b[length(b)]-b[length(b)-1]), labels=c("","",""), lwd=2, lwd.tick=0)
    text( parse(text=paste(
      output$print.p)), 
      x = b+0.1, 
      y =  output$R2+ (max(output$R2)*1.05-max(output$R2)), 
      srt = 45)
  }
  box(bty='L', lwd=2)
  axis(2,las=2, lwd=2)
  
  title(ylab=ylab, line=4, cex.lab=1.5, font=2 )
  title(xlab=xlab, line=2.5, cex.lab=1.5, font=2 )
  
  par(cex.lab=1.5, cex.axis=1.25, font.lab=2, 
      mar=c(20,0,20,4))
  if(argv$bar_col_p){
    output <- output[order(output$Threshold),]
    image(1, output$Threshold, t(output$Threshold), col=output$color, axes=FALSE, ann=F)
    axis(4,las=2,xaxs='r',yaxs='r', tck=0.2, col="white")
    title( bquote(atop(italic(P) - value , threshold), ),  
           line=2, cex=1.5, font=2, adj=0)
  }else{
    output <- output[order(-log10(output$P)),]
    image(1, -log10(output$P), t(seq_along(-log10(output$P))), col=output$color, axes=F,ann=F)
    axis(4,las=2,xaxs='r',yaxs='r', tck=0.2, col="white")
    title(bquote(atop(-log[10] ~ model, italic(P) - value), ), 
          line=2, cex=1.5, font=2, adj=0)
  }
  g<-dev.off()
}

plot.bar <- function(argv, output, prefix){
  ggfig.plot <- ggplot(data = output, aes(x = factor(Threshold), y = R2)) + geom_text(
    aes(label = paste(print.p)),
    vjust = -1.5,
    hjust = 0,
    angle = 45,
    cex = 4,
    parse = T
  )  +
    theme_sam + 
    scale_y_continuous(limits = c(0, max(output$R2) * 1.25)) +
    xlab(expression(italic(P) - value ~ threshold ~ (italic(P)[T]))) +
    ylab(expression(paste("PRS model fit:  ", R ^ 2)))
  if (argv$bar_col_p) {
    ggfig.plot <-
      ggfig.plot + geom_bar(aes(fill = factor(Threshold)), stat = "identity") +
      scale_fill_brewer(palette = argv$bar_palatte,
                        name = expression(italic(P) - value ~ threshold))
  }else {
    ggfig.plot <-
      ggfig.plot + geom_bar(aes(fill = -log10(P)), stat = "identity") +
      scale_fill_gradient(
        low = argv$bar_col_low,
        high = argv$bar_col_high,
        name = bquote(atop(-log[10] ~ model, italic(P) - value), )
      )
  }
  
  ggsave(
    paste(prefix, "_BARPLOT_", Sys.Date(), ".png", sep = ""),
    ggfig.plot,
    height=10,width=10
  )
}


# Plot multi-phenotype plot -----------------------------------------------

multi_pheno_plot <- function(parameters, use.ggplot, use.data.table){
    writeLines("Plotting the Multi-Phenotype Plot")
    prs.summary <- NULL
    if(use.data.table){
        prs.summary <- fread(paste0(parameters$out, ".summary"), data.table=F)
    }else{
        prs.summary <- read.table(paste0(parameters$out, ".summary"), header=T)
    }
    multipheno <- subset(prs.summary, Set=="Base")
    multipheno$Phenotype <- sapply(multipheno$Phenotype, shorten_label)
    multipheno <- multipheno[order(multipheno$PRS.R2, decreasing=T), ]
    multipheno$Phenotype <- factor(multipheno$Phenotype, levels = multipheno$Phenotype)
    if(use.ggplot){
        b <-
            ggplot(multipheno[1:(min(parameters$multi_plot, nrow(multipheno))), ],
                   aes(
                       x = Phenotype,
                       y = PRS.R2,
                       fill = -log10(P)
                   )) +
            theme_sam +
            geom_bar(stat = "identity") +
            coord_flip() +
            ylab("Variance explained by PRS") +
            scale_fill_distiller(palette = "Spectral", name = bquote(atop(-log[10] ~ model, italic(P) - value), ))
        ggsave(paste(
            parameters$out,
            "_MULTIPHENO_BARPLOT_",
            Sys.Date(),
            ".png",
            sep = ""
        ))
    }else{
        png(paste(parameters$out, "_MULTIPHENO_BARPLOT_", Sys.Date(), ".png", sep = ""),
            height=10, width=10, res=300, unit="in")
        layout(t(1:2), widths=c(8.8,1.2))
        
        output <- multipheno[1:(min(parameters$multi_plot, nrow(multipheno))), ]
        max.label.length <- max(sapply(output$Phenotype, 
                                       max_length
        ))*0.75
        par( cex.lab=1.5, cex.axis=1.25, font.lab=2, 
             oma=c(0,0.5,0,0),
             mar=c(4,max.label.length,0.5,0.5))
        ylab <- "Variance explained by PRS"
        col <- suppressWarnings(colorRampPalette(brewer.pal(12,"RdYlBu")))
        
        output <- output[order(-log10(output$P)),]
        output$color <-  col(nrow(output))
        output <- output[order(output$PRS.R2),]
        b<- barplot(height=output$PRS.R2, 
                    col=output$color, 
                    border=NA, 
                    ann=F, horiz=TRUE,
                    ylab="",
                    xlab=ylab)
        axis(2,las=2, lwd=2, at=b, labels=output$Phenotype)
        box(bty="L",lwd=2)
        
        
        par(cex.lab=1.5, cex.axis=1.25, font.lab=2, 
            mar=c(20,0,20,4))
        output <- output[order(-log10(output$P)),]
        image(1, -log10(output$P), t(seq_along(-log10(output$P))), col=output$color, axes=F,ann=F)
        axis(4,las=2,xaxs='r',yaxs='r', tck=0.2, col="white")
        title(bquote(atop(-log[10] ~ model, italic(P) - value), ), 
              line=2, cex=1.5, font=2, adj=0)
        
        g<-dev.off()
    }
}
# Plot multi-set plot -----------------------------------------------------


multi_set_plot <- function(prefix, prs.summary, pheno.name, parameters, use.ggplot){
    writeLines("Plotting Multi-Set-Plot")
    if (nrow(prs.summary) < 1)
        stop((
            "Error: Cannot generate multi-plot as only one phenotype and the base set was observed!"
        ))
    overview <- subset(prs.summary, Phenotype==pheno.name)
    # process phenotype & pathway name to make it fit into the plot
    overview$Phenotype <- sapply(overview$Phenotype, shorten_label)
    overview$Set <- sapply(overview$Set, shorten_label)
    sets <- unique(overview$Set)
    multiset <- overview[order(overview$PRS.R2, decreasing=T), ]
    multiset$Set <- factor(multiset$Set, levels = multiset$Set)
    if(use.ggplot){
        b <-
            ggplot(multiset[1:(min(parameters$multi_plot, nrow(multiset))),], aes(
                x = Set,
                y = PRS.R2,
                fill = -log10(P)
            )) +
            theme_sam +
            geom_bar(stat = "identity") +
            coord_flip() +
            ylab("Variance explained by PRS") +
            scale_fill_distiller(palette = "PuOr", name = bquote(atop(-log[10] ~ model, italic(P) - value),)) +
            theme(axis.title.y = element_blank())
        ggsave(
            paste(prefix,
                  "_MULTISET_BARPLOT_",
                  Sys.Date(),
                  ".png",
                  sep = ""),
            b,
            height = 10,
            width = 10
        )
    } else{
        png(
            paste(
                prefix,
                "_MULTISET_BARPLOT_",
                Sys.Date(),
                ".png",
                sep = ""
            ),
            height = 10,
            width = 10,
            res = 300,
            unit = "in"
        )
        layout(t(1:2), widths = c(8.8, 1.2))
        output <-
            multiset[1:(min(parameters$multi_plot, nrow(multiset))),]
        max.label.length <- max(sapply(output$Set,
                                       max_length)) * 0.75
        par(
            cex.lab = 1.5,
            cex.axis = 1.25,
            font.lab = 2,
            oma = c(0, 0.5, 0, 0),
            mar = c(4, max.label.length, 0.5, 0.5)
        )
        ylab <- "Variance explained by PRS"
        col <-
            suppressWarnings(colorRampPalette(brewer.pal(12, "PuOr")))
        
        output <- output[order(-log10(output$P)), ]
        output$color <-  col(nrow(output))
        output <- output[order(output$PRS.R2, decreasing=T), ]
        b <- barplot(
            height = output$PRS.R2,
            col = output$color,
            border = NA,
            ann = F,
            horiz = TRUE,
            ylab = "",
            xlab = ylab
        )
        axis(
            2,
            las = 2,
            lwd = 2,
            at = b,
            labels = output$Set
        )
        box(bty = "L", lwd = 2)
        
        
        par(
            cex.lab = 1.5,
            cex.axis = 1.25,
            font.lab = 2,
            mar = c(20, 0, 20, 4)
        )
        output <- output[order(-log10(output$P)), ]
        image(
            1,
            -log10(output$P),
            t(seq_along(-log10(output$P))),
            col = output$color,
            axes = F,
            ann = F
        )
        axis(
            4,
            las = 2,
            xaxs = 'r',
            yaxs = 'r',
            tck = 0.2,
            col = "white"
        )
        title(
            bquote(atop(-log[10] ~ model, italic(P) - value),),
            line = 2,
            cex = 1.5,
            font = 2,
            adj = 0
        )
        
        g <- dev.off()
    }
}

# Sanity Check ------------------------------------------------------------


if (provided("no_regress", argv)) {
    quit("yes")
}
ignore_fid <- provided("ignore_fid", argv)

extract_matrix <- function(x, y) {
    z = which(x == y)
    
    if (length(z) == 0) {
        return(NA)
    } else{
        return(z)
    }
}
# CALL PLOTTING FUNCTION: Process the input names and call the actual plotting function
# we need to deduce the file names
# Now we actually require one single string for the input, separated by ,
# Get all the region information
# With this update, we only allow a single base file therefore we don't even need the
# information of base here

if (!provided("target", argv)) {
    stop("Target file name not found. You'll need to provide the target name for plotting! (even with --plot)")
}


phenos <- NULL

binary_target <- strsplit(argv$binary_target, split = ",")[[1]]
pheno.index <- 6
if (provided("pheno_col", argv)) {
    phenos <- strsplit(argv$pheno_col, split = ",")[[1]]
    if (!provided("pheno_file", argv)) {
        writeLines(
            strwrap(
                "WARNING: Cannot have multiple phenotypes if pheno_file is not provided. We will ignore the pheno_col option.",
                width = 80
            )
        )
    }else if (length(binary_target) != length(phenos)) {
        message <-
            "Number of binray target should match number of phenotype provided!"
        message <- paste(
            message,
            "There are ",
            length(binary_target),
            " binary target information and ",
            length(phenos),
            "phenotypes",
            sep = ""
        )
        stop(message)
    } else{
        header <- read.table(argv$pheno_file, nrows = 1, header = TRUE)
        # This will automatically filter out un-used phenos
        valid.pheno <- phenos %in% colnames(header)
        valid.file.index <- colnames(header) %in% phenos
        if (sum(valid.pheno) == 0) {
            stop("Error: None of the phenotype is identified in phenotype header!")
        }
        binary_target <- binary_target[valid.pheno]
        phenos <- phenos[valid.pheno]
        pheno.index <- c(1:ncol(header))[valid.file.index]
    }
} else if (provided("pheno_file", argv)) {
    pheno.index <- 3
    if (ignore_fid)
        pheno.index <- 2
} else{
    if (length(binary_target) != 1) {
        stop("Too many binary target information. We only have one phenotype")
    }
}


# Read in covariates ------------------------------------------------------
update_cov_header <- function(c) {
    res <- NULL
    for (i in c) {
        if (substr(i, 0, 1) == "@") {
            i <- substr(i, 2, nchar(i))
            temp <- strsplit(i, "\\[")[[1]]
            
            info <- NULL
            is_list <- NULL
            for (j in temp) {
                if (grepl("\\]", j)) {
                    tem <- strsplit(j, "\\]")[[1]]
                    
                    for (k in 1:length(tem)) {
                        info <- rbind(info, tem[k])
                        
                        is_list <- rbind(is_list, k == 1)
                        
                    }
                } else{
                    info <- rbind(info, j)
                    
                    is_list <- rbind(is_list, FALSE)
                    
                }
            }
            final <- NULL
            
            for (j in 1:nrow(info)) {
                if (is_list[j]) {
                    num <- NULL
                    ind <- strsplit(info[j], split = "\\.")[[1]]
                    
                    for (k in ind) {
                        if (grepl("-", k)) {
                            range <- strsplit(k , split = "-")[[1]]
                            
                            r <- range[1]:range[2]
                            
                            num <- c(num, r)
                            
                        } else{
                            num <- c(num, k)
                            
                        }
                    }
                    cur <- final
                    final <- NULL
                    for (n in num) {
                        final <- c(final, paste(cur, n, sep = ""))
                        
                    }
                } else{
                    final <- paste(final, info[j], sep = "")
                    
                }
            }
            res <- c(res, final)
        } else{
            res <- c(res, i)
            
        }
    }
    return(res)
}

covariance <- NULL
covariance.base <- NULL
if (provided("cov_file", argv)) {
    if (use.data.table) {
        covariance <- fread(argv$cov_file,
                            data.table = F,
                            header = T)
    } else {
        covariance <- read.table(argv$cov_file, header = T)
    }
    cov.header <- colnames(covariance)
    selected.cov <- cov.header[!cov.header%in%c("FID", "IID")]
    if(provided("cov_col", argv)){
        c <- strsplit(argv$cov_col, split = ",")[[1]]
        c <- update_cov_header(c)
        selected.cov <- cov.header[cov.header %in% c]
    }
    covariance.base <- covariance[, cov.header%in%c("FID", "IID",selected.cov)]
}

# we no longer have those complication
prefix <- argv$out

#regions <- read.table(paste(prefix, "region", sep = "."), header =T)
#num_region = nrow(regions)

# Process plot functions --------------------------------------------------

process_plot <-
    function(prefix,
             covariance,
             is_binary,
             pheno.file,
             parameters,
             pheno.index,
             use.data.table,
             use.ggplot,
             pheno.name) {
        sum.prefix <- prefix
        if(pheno.name!="-"){
            prefix <- paste(prefix, pheno.name, sep=".")
        }
        best <- NULL
        prs.summary <- NULL
        prsice.result <- NULL
        phenotype <- NULL
        if (use.data.table) {
            best <- fread(paste0(prefix, ".best"), data.table = F)
            prs.summary <-
                fread(paste0(sum.prefix, ".summary"), data.table = F)
            prsice.result <-
                fread(paste0(prefix, ".prsice"), data.table = F)
            phenotype <-
                fread(pheno.file, data.table = F, header = F)
        } else{
            best <- read.table(paste0(prefix, ".best"), header = T)
            prs.summary <-
                read.table(paste0(sum.prefix, ".summary"), header = T)
            prsice.result <-
                read.table(paste0(prefix, ".prsice"), header = T)
            # Allow header = false for fam or for phenotype files that does not contain phenotype name
            phenotype <- read.table(pheno.file, header = F)
        }
        best <- subset(best, In_Regression == "Yes")
        # We know the format of the best file, and it will always contain FID and IID
        
        base.prs <- best[,c(1,2,4)]
        if(provided("plot_set", parameters) & (provided("msigdb", parameters) | provided("bed", parameters) | provided("gtf", parameters)| provided("snp_set", parameters)| provided("snp_sets", parameters))){
            base.prs <- best[,colnames(best)%in%c("FID", "IID", parameters$plot_set)]
            colnames(base.prs)[3] <- "PRS"
        }
# Generate phenotype matrix -----------------------------------------------
        # extract the phenotype column
        # And only retain samples with phenotype and covariate information
        # They will be found in the best data.frame
        
        ignore_fid <- provided("ignore_fid", parameters)
        if (!ignore_fid) {
            phenotype <- phenotype[, c(1:2, pheno.index)]
            colnames(phenotype) <- c("FID", "IID", "Pheno")
            phenotype <-
                phenotype[phenotype$FID %in% best$FID &
                              phenotype$IID %in% best$IID, ]
        } else{
            phenotype <- phenotype[, c(1, pheno.index)]
            colnames(phenotype) <- c("IID", "Pheno")
            phenotype <- phenotype[phenotype$IID %in% best$IID, ]
        }
        phenotype$Pheno <- as.numeric(as.character(phenotype$Pheno))
        pheno <- phenotype
        use.residual <- F
        if(is_binary){
            if(max(pheno$Pheno)==2){
                pheno$Pheno <- pheno$Pheno-1
            }
        }
        if(!is.null(covariance)){
            # We will regress out the residual
            # Can direct merge as we have standardized the header
            temp.pheno <- merge(pheno, covariance)
            family <- gaussian
            if(is_binary){
                family <- binomial
            }
            residual <-
                rstandard(glm(Pheno ~ ., 
                              data = temp.pheno[, !colnames(temp.pheno) %in% c("FID", "IID")], 
                              family =family))
            pheno$Pheno <- residual
            use.residual <- T
        }
        
# Start calling functions -------------------------------------------------
        if (provided("quantile", parameters) && parameters$quantile > 0) {
            # Need to plot the quantile plot (Remember to remove the iid when performing the regression)
            if(!provided("quant_break", parameters)){
                quantile_plot(base.prs, pheno, prefix, parameters, is_binary, use.ggplot, use.residual)
            }else{
                uneven_quantile_plot(base.prs, pheno, prefix, parameters, is_binary, use.ggplot, use.residual)
            }
        }
        if(provided("msigdb", parameters) | provided("bed", parameters) | provided("gtf", parameters)
           | provided("snp_test", parameters) | provided("snp_tests", parameters)){
            if(length(strsplit(argv$bar_levels, split=",")[[1]])>1){
                bar_plot(prsice.result, prefix, parameters, use.ggplot) 
                if(!provided("fastscore", parameters)){
                    high_res_plot(prsice.result, prefix, parameters, use.ggplot)
                }
            }
        }else{
            bar_plot(prsice.result, prefix, parameters, use.ggplot)
            if(!provided("fastscore", parameters)){
                high_res_plot(prsice.result, prefix, parameters, use.ggplot)
            }
        }
        if(provided("multi_plot", parameters)){
            multi_set_plot(prefix, prs.summary, pheno.name, parameters, use.ggplot)
        }
    }


# Check if phenotype file is of sample format -----------------------------
is_sample_format <- function(file) {
    con = file(file, "r")
    first_line <- readLines(con, n = 1)
    second_line <- readLines(con, n = 1)
    close(con)
    if (length(first_line) == 0 | length(second_line) == 0) {
        # Unless there is only one sample? but that will be ridiculous for us to consider that
        stop("Error: Phenotype file should contain at least 2 line of input")
    }
    first <- strsplit(first_line, split = "\t")[[1]]
    if (length(first) == 1) {
        # Maybe seperated by space?
        first <- strsplit(first_line, split = " ")[[1]]
    }
    second <- strsplit(second_line, split = "\t")[[1]]
    if (length(first) == 1) {
        second <- strsplit(second_line, split = " ")[[1]]
    }
    if (length(first) != length(second) | length(first) < 3) {
        return(FALSE)
    }
    for (i in 1:3) {
        if (second[i] != 0) {
            return(FALSE)
        }
    }
    for (i in 4:length(second)) {
        if (second[i] != "D" &
            second[i] != "C" &
            second[i] != "P" & second[i] != "B") {
            return(FALSE)
        }
    }
    return(TRUE)
}
# Calling plot functions --------------------------------------------------
# Check target
pheno.file <- NULL

if (provided("pheno_file", argv)) {
    pheno.file <- argv$pheno_file
} else if(provided("target", argv)){
    # Check if external fam / sample file is provided
    target.info <- strsplit(argv$target, split = ",")[[1]]
    if (length(target.info) == 2) {
        pheno.file <- target.info[2]
        if (provided("type", argv)) {
            if (argv$type == "bgen") {
                # sample file should contain FID and IID by format requirement
                pheno.index <- 3
                if (ignore_fid &
                    !is_sample_format(pheno.file))
                    pheno.index <- 2
            }
        }
    } else{
        if (provided("type", argv)) {
            if (argv$type == "bgen") {
                stop("Error: You must provide either a phenotype or sample file for bgen input")
            } else if (argv$type == "bed") {
                pheno.file <- paste0(argv$target, ".fam")
            }
        } else{
            # Because default is always plink
            pheno.file <- paste0(argv$target, ".fam")
        }
    }
}else if(provided("target_list", argv)){
    # Assume no header
    target.list <- read.table(argv$target_list)
    target.prefix <- target.list[1]
    pheno.file <- paste0(target.prefix, ".fam")    
    if(provided("type", argv)){
        if(argv$type=="bgen"){
            stop("Error: You must provide a phenotype file for bgen list input")
        }   
    }
}

update_cov_factor <- function(parameters, pheno.file, pheno.index, cov.base){
    
    phenotype <- NULL
    if (use.data.table) {
        phenotype <-
            fread(pheno.file, data.table = F, header = F)
    } else{
        # Allow header = false for fam or for phenotype files that does not contain phenotype name
        phenotype <- read.table(pheno.file, header = F)
    }
    ignore_fid <- provided("ignore_fid", parameters)
    if (!ignore_fid) {
        phenotype <- phenotype[, c(1:2, pheno.index)]
        colnames(phenotype) <- c("FID", "IID", "Pheno")
        phenotype$Pheno <- suppressWarnings(as.numeric(as.character(phenotype$Pheno)))
        phenotype <-
            phenotype[!is.na(phenotype$Pheno), ]
    } else{
        phenotype <- phenotype[, c(1, pheno.index)]
        colnames(phenotype) <- c("IID", "Pheno")
        phenotype$Pheno <- suppressWarnings(as.numeric(as.character(phenotype$Pheno)))
        phenotype <-
            phenotype[!is.na(phenotype$Pheno), ]
    }
    # Now remove any missing sample from cov.base
    covariance <- NULL
    if(!is.null(cov.base)){
        if(!ignore_fid){
            covariance <- cov.base[cov.base$FID %in% phenotype$FID & 
                                       cov.base$IID %in% phenotype$IID, ]
        }else{
            covariance <- cov.base[cov.base$IID %in% phenotype$IID, ]
        }
        # Note: cov.base only contains the valid headers
        if(provided("cov_factor", parameters)){
            factor_cov <- parameters$cov_factor
            for(i in colnames(covariance)){
                if(i != "FID" & i != "IID"){
                    if(i %in%factor_cov){
                        covariance[,i] <- factor(covariance[,i], levels=unique(covariance[,i]))
                    }else{
                        covariance[,i] <- as.numeric(covariance[,i])
                    }
                }
            }
        }else{
            for(i in colnames(covariance)){
                if(i!="FID" & i!="IID"){
                    covariance[,i] <- as.numeric(covariance[,i])
                }
            }
        }
        if (ignore_fid) { 
            colnames(covariance) <- 
                c("IID", paste0("Cov", 1:(ncol(covariance) - 1))) 
        } else{ 
            colnames(covariance) <- 
                c("FID", "IID", paste0("Cov", 1:(ncol(covariance) - 2))) 
        } 
    }
    return(covariance)
}
# To account for the chromosome number
pheno.file <- gsub("#", "1", pheno.file)
if (!is.null(phenos) &
    length(phenos) > 1) {
    for (i in 1:length(phenos)) {
        # Update the covariance matrix accordingly
        covariance <- update_cov_factor(argv, pheno.file, pheno.index[i], covariance.base)
        process_plot(
            argv$out,
            covariance,
            binary_target[i],
            pheno.file,
            argv,
            pheno.index[i],
            use.data.table,
            use.ggplot,
            phenos[i]
        )
    }
    if(provided("multi_plot", argv)){
        multi_pheno_plot(argv, use.ggplot, use.data.table)
    }
} else if (!is.null(phenos)) {
    covariance <- update_cov_factor(argv, pheno.file, pheno.index[1], covariance.base)
    process_plot(
        argv$out,
        covariance,
        binary_target[1],
        pheno.file,
        argv,
        pheno.index[1],
        use.data.table,
        use.ggplot,
        "-"
    )
} else{
    covariance <- update_cov_factor(argv, pheno.file, pheno.index[1], covariance.base)
    process_plot(
        argv$out,
        covariance,
        binary_target[1],
        pheno.file,
        argv,
        pheno.index[1],
        use.data.table,
        use.ggplot,
        "-"
    )
}
